
function fifo_gen(p)


fid = fopen('../verilog/FFT_FIFO.v','w');

% -- wb_[
fprintf(fid,'`ifdef SYNTOOL_OFF \n');
fprintf(fid,'`else \n');
fprintf(fid,'`include "definition.v" \n');
fprintf(fid,'`endif \n\n');

for s=1:log2(p.N)
    fifo_num = p.N / 2^s;
    fprintf(fid,'\n');
    fprintf(fid,'module FIFO_ST%d(clk, Fin_r, Fin_i, Fout_r, Fout_i);\n', s);
    
    fprintf(fid,'input  clk;\n');
    fprintf(fid,'input  [`W-1:0]  Fin_r, Fin_i;\n');
    fprintf(fid,'output [`W-1:0]  Fout_r, Fout_i;\n');
    
    for k=1:fifo_num
       fprintf(fid,'reg    [2*`W-1:0]  F%d;\n',k);
    end
    
    fprintf(fid,'always@(posedge clk)\n');
    fprintf(fid,'begin\n');
    for k=1:fifo_num
        if (k==1)
            fprintf(fid,'F1 <= {Fin_r, Fin_i};\n');
        else
            fprintf(fid,'F%d <= F%d;\n',k,k-1);
        end
    end 
    fprintf(fid,'end\n');
    fprintf(fid,'assign Fout_r = F%d[2*`W-1:`W];\n',fifo_num);
    fprintf(fid,'assign Fout_i = F%d[`W-1:0];\n',fifo_num);
    % -- tb_[
    fprintf(fid,'endmodule\n\n');
end

fclose(fid);