
function twiddle_gen(p)
   
for t=1:log2(p.N)-1
    Twiddle_Table(1,t) = 2^(t+1);
end

fid = fopen('../verilog/FFT_TWIDDLE.v','w');

% -- wb_[
fprintf(fid,'`ifdef SYNTOOL_OFF \n');
fprintf(fid,'`else \n');
fprintf(fid,'`include "definition.v" \n');
fprintf(fid,'`endif \n\n');

for m=1:size(Twiddle_Table,2)
    st_num = log2(p.N) - m;
    [W_r, W_ex_r, W_i, W_ex_i] = twiddle_gen_calc(Twiddle_Table(1,m), p.Wordlength);
    fprintf(fid,'\n');
    fprintf(fid,'module TWIDDLE_ST%d(k, W_ex_r, W_r, W_ex_i, W_i);\n', st_num);
    if ((log2(Twiddle_Table(1,m))-2)==0)
        fprintf(fid,'input          k;\n');
    else
        fprintf(fid,'input  [%d:0]  k;\n', log2(Twiddle_Table(1,m))-2);
    end
        fprintf(fid,'output [`W-1:0]  W_r, W_i;\n');
    fprintf(fid,'output [1:0]   W_ex_r, W_ex_i;\n');
    fprintf(fid,'assign W_r = Twiddle_W_r(k);\n');
    fprintf(fid,'assign W_i = Twiddle_W_i(k);\n');
    fprintf(fid,'assign W_ex_r = Twiddle_W_ex_r(k);\n');
    fprintf(fid,'assign W_ex_i = Twiddle_W_ex_i(k);\n');
    % --- W_r ---
    fprintf(fid,'function [`W-1:0] Twiddle_W_r;\n');
    if ((log2(Twiddle_Table(1,m))-2)==0)
        fprintf(fid,'input          k;\n');
    else
        fprintf(fid,'input  [%d:0]  k;\n', log2(Twiddle_Table(1,m))-2);
    end
    fprintf(fid,'case(k)\n');
    for k=1:size(W_r,2);
        fprintf(fid,' %d : Twiddle_W_r = %d;\n', k-1, W_r(1,k));
    end
    fprintf(fid,'default : Twiddle_W_r = 0;\n');
    fprintf(fid,'endcase\n');
    fprintf(fid,'endfunction\n');
    % --- W_i ---
    fprintf(fid,'function [`W-1:0] Twiddle_W_i;\n');
    if ((log2(Twiddle_Table(1,m))-2)==0)
        fprintf(fid,'input          k;\n');
    else
        fprintf(fid,'input  [%d:0]  k;\n', log2(Twiddle_Table(1,m))-2);
    end
    fprintf(fid,'case(k)\n');
    for k=1:size(W_i,2);
        fprintf(fid,' %d : Twiddle_W_i = %d;\n', k-1, W_i(1,k));
    end
    fprintf(fid,'default : Twiddle_W_i = 0;\n');
    fprintf(fid,'endcase\n');
    fprintf(fid,'endfunction\n');
    % --- W_ex_r ---
    fprintf(fid,'function [1:0] Twiddle_W_ex_r;\n');
    if ((log2(Twiddle_Table(1,m))-2)==0)
        fprintf(fid,'input          k;\n');
    else
        fprintf(fid,'input  [%d:0]  k;\n', log2(Twiddle_Table(1,m))-2);
    end
    fprintf(fid,'case(k)\n');
    for k=1:size(W_ex_r,2);
        fprintf(fid,' %d : Twiddle_W_ex_r = %d;\n', k-1, W_ex_r(1,k));
    end
    fprintf(fid,'default : Twiddle_W_ex_r = 0;\n');
    fprintf(fid,'endcase\n');
    fprintf(fid,'endfunction\n');
    % --- W_ex_i ---
    fprintf(fid,'function [1:0] Twiddle_W_ex_i;\n');
    if ((log2(Twiddle_Table(1,m))-2)==0)
        fprintf(fid,'input          k;\n');
    else
        fprintf(fid,'input  [%d:0]  k;\n', log2(Twiddle_Table(1,m))-2);
    end
    fprintf(fid,'case(k)\n');
    for k=1:size(W_ex_i,2);
        fprintf(fid,' %d : Twiddle_W_ex_i = %d;\n', k-1, W_ex_i(1,k));
    end
    fprintf(fid,'default : Twiddle_W_ex_i = 0;\n');
    fprintf(fid,'endcase\n');
    fprintf(fid,'endfunction\n');
    % -- tb_[
    fprintf(fid,'endmodule\n\n');
end

fclose(fid);
