`ifdef SYNTOOL_OFF 
`else 
`include "definition.v" 
`endif 

module FFT(CLK, RESET, EN, X_r, X_i, Y_r, Y_i);
input          CLK;
input          RESET;
input          EN;
parameter      IDLE = 0;
parameter      RUN  = 1;
input  [`W-1:0]  X_r, X_i;
output [`W-1:0]  Y_r, Y_i;
reg              state;
reg    [`N_AD_BUS-1:0]   k_count_st1;
reg    [`N_AD_BUS-1:0]   k_count_st2;
reg    [`N_AD_BUS-1:0]   k_count_st3;
reg    [`N_AD_BUS-1:0]   k_count_st4;
reg    [`N_AD_BUS-1:0]   k_count_st5;
reg    [`N_AD_BUS-1:0]   k_count_st6;
reg    [`N_AD_BUS-1:0]   k_count_st7;
reg    [`N_AD_BUS-1:0]   k_count_st8;
reg    [`N_AD_BUS-1:0]   k_count_st9;
reg    [`N_AD_BUS-1:0]   k_count_st10;
reg    [`N_AD_BUS-1:0]   k_count_st11;
reg    [`N_AD_BUS-1:0]   k_count_st12;
reg    [`N_AD_BUS-1:0]   k_count_st13;
reg    [`N_AD_BUS-1:0]   k_count_st14;
reg    [`N_AD_BUS-1:0]   k_count_st15;
reg    [`N_AD_BUS-1:0]   k_count_st16;
reg    [`N_AD_BUS-1:0]   k_count_st17;
reg    [`N_AD_BUS-1:0]   k_count_st18;
reg    [`N_AD_BUS-1:0]   k_count_st19;
reg    [`N_AD_BUS-1:0]   k_count_st20;
reg    [`N_AD_BUS-1:0]   k_count_st21;
reg    [`N_AD_BUS-1:0]   k_count_st22;
reg    [`N_AD_BUS-1:0]   k_count_st23;
reg    [`N_AD_BUS-1:0]   k_count_st24;
reg    [`N_AD_BUS-1:0]   k_count_st25;
reg    [`N_AD_BUS-1:0]   k_count_st26;
reg    [`N_AD_BUS-1:0]   k_count_st27;
reg    [`N_AD_BUS-1:0]   k_count_st28;
reg    [`N_AD_BUS-1:0]   k_count_st29;
reg    [`N_AD_BUS-1:0]   k_count_st30;
reg    [`N_AD_BUS-1:0]   k_count_st31;
reg    [`N_AD_BUS-1:0]   k_count_st32;
reg    [`N_AD_BUS-1:0]   k_count_st33;
reg    [`N_AD_BUS-1:0]   k_count_st34;
reg    [`N_AD_BUS-1:0]   k_count_st35;
reg    [`N_AD_BUS-1:0]   k_count_st36;
reg    [`N_AD_BUS-1:0]   k_count_st37;
reg    [`N_AD_BUS-1:0]   k_count_st38;
reg    [`N_AD_BUS-1:0]   k_count_st39;
reg    [`N_AD_BUS-1:0]   k_count_st40;
reg    [`N_AD_BUS-1:0]   k_count_st41;
reg    [`N_AD_BUS-1:0]   k_count_st42;
reg    [`N_AD_BUS-1:0]   k_count_st43;
reg    [`N_AD_BUS-1:0]   k_count_st44;
reg    [`N_AD_BUS-1:0]   k_count_st45;
reg    [`N_AD_BUS-1:0]   k_count_st46;
wire   [`W-1:0]  Y_st1_r, Y_st1_i;
wire   [`W-1:0]  Y_st2_r, Y_st2_i;
wire   [`W-1:0]  Y_st3_r, Y_st3_i;
wire   [`W-1:0]  Y_st4_r, Y_st4_i;
wire   [`W-1:0]  Y_st5_r, Y_st5_i;
wire   [`W-1:0]  Y_st6_r, Y_st6_i;
wire   [`W-1:0]  Y_st7_r, Y_st7_i;
wire   [`W-1:0]  Y_st8_r, Y_st8_i;
wire   [`W-1:0]  Y_st9_r, Y_st9_i;
wire   [`W-1:0]  Y_st10_r, Y_st10_i;
BUTTERFLY_STAGE1 BUTTERFLY_STAGE1(CLK, k_count_st1,      X_r,     X_i, Y_st1_r, Y_st1_i);
BUTTERFLY_STAGE2 BUTTERFLY_STAGE2(CLK, k_count_st6,  Y_st1_r, Y_st1_i, Y_st2_r, Y_st2_i);
BUTTERFLY_STAGE3 BUTTERFLY_STAGE3(CLK, k_count_st11,  Y_st2_r, Y_st2_i, Y_st3_r, Y_st3_i);
BUTTERFLY_STAGE4 BUTTERFLY_STAGE4(CLK, k_count_st16,  Y_st3_r, Y_st3_i, Y_st4_r, Y_st4_i);
BUTTERFLY_STAGE5 BUTTERFLY_STAGE5(CLK, k_count_st21,  Y_st4_r, Y_st4_i, Y_st5_r, Y_st5_i);
BUTTERFLY_STAGE6 BUTTERFLY_STAGE6(CLK, k_count_st26,  Y_st5_r, Y_st5_i, Y_st6_r, Y_st6_i);
BUTTERFLY_STAGE7 BUTTERFLY_STAGE7(CLK, k_count_st31,  Y_st6_r, Y_st6_i, Y_st7_r, Y_st7_i);
BUTTERFLY_STAGE8 BUTTERFLY_STAGE8(CLK, k_count_st36,  Y_st7_r, Y_st7_i, Y_st8_r, Y_st8_i);
BUTTERFLY_STAGE9 BUTTERFLY_STAGE9(CLK, k_count_st41,  Y_st8_r, Y_st8_i, Y_st9_r, Y_st9_i);
BUTTERFLY_STAGE10 BUTTERFLY_STAGE10(CLK, k_count_st46,  Y_st9_r, Y_st9_i, Y_r,     Y_i);
always@(posedge CLK or negedge RESET)
begin
 if(!RESET)
    begin
     state   <= IDLE;
    end
 else
   begin
     k_count_st2 <= k_count_st1;
     k_count_st3 <= k_count_st2;
     k_count_st4 <= k_count_st3;
     k_count_st5 <= k_count_st4;
     k_count_st6 <= k_count_st5;
     k_count_st7 <= k_count_st6;
     k_count_st8 <= k_count_st7;
     k_count_st9 <= k_count_st8;
     k_count_st10 <= k_count_st9;
     k_count_st11 <= k_count_st10;
     k_count_st12 <= k_count_st11;
     k_count_st13 <= k_count_st12;
     k_count_st14 <= k_count_st13;
     k_count_st15 <= k_count_st14;
     k_count_st16 <= k_count_st15;
     k_count_st17 <= k_count_st16;
     k_count_st18 <= k_count_st17;
     k_count_st19 <= k_count_st18;
     k_count_st20 <= k_count_st19;
     k_count_st21 <= k_count_st20;
     k_count_st22 <= k_count_st21;
     k_count_st23 <= k_count_st22;
     k_count_st24 <= k_count_st23;
     k_count_st25 <= k_count_st24;
     k_count_st26 <= k_count_st25;
     k_count_st27 <= k_count_st26;
     k_count_st28 <= k_count_st27;
     k_count_st29 <= k_count_st28;
     k_count_st30 <= k_count_st29;
     k_count_st31 <= k_count_st30;
     k_count_st32 <= k_count_st31;
     k_count_st33 <= k_count_st32;
     k_count_st34 <= k_count_st33;
     k_count_st35 <= k_count_st34;
     k_count_st36 <= k_count_st35;
     k_count_st37 <= k_count_st36;
     k_count_st38 <= k_count_st37;
     k_count_st39 <= k_count_st38;
     k_count_st40 <= k_count_st39;
     k_count_st41 <= k_count_st40;
     k_count_st42 <= k_count_st41;
     k_count_st43 <= k_count_st42;
     k_count_st44 <= k_count_st43;
     k_count_st45 <= k_count_st44;
     k_count_st46 <= k_count_st45;
     case(state)
        IDLE :
           begin
             k_count_st1 <= 0;
             if(EN == 1) state <= RUN;
             else           state <= IDLE;
           end
        RUN :
           begin
             k_count_st1 <= k_count_st1 + 1;
             if(EN == 0)  state <= IDLE;
           end
      endcase
   end
end
endmodule
