`ifdef SYNTOOL_OFF 
`else 
`include "definition.v" 
`endif 


module TWIDDLE_ST9(k, W_ex_r, W_r, W_ex_i, W_i);
input          k;
output [`W-1:0]  W_r, W_i;
output [1:0]   W_ex_r, W_ex_i;
assign W_r = Twiddle_W_r(k);
assign W_i = Twiddle_W_i(k);
assign W_ex_r = Twiddle_W_ex_r(k);
assign W_ex_i = Twiddle_W_ex_i(k);
function [`W-1:0] Twiddle_W_r;
input          k;
case(k)
 0 : Twiddle_W_r = 32604;
 1 : Twiddle_W_r = 0;
default : Twiddle_W_r = 0;
endcase
endfunction
function [`W-1:0] Twiddle_W_i;
input          k;
case(k)
 0 : Twiddle_W_i = 0;
 1 : Twiddle_W_i = 32931;
default : Twiddle_W_i = 0;
endcase
endfunction
function [1:0] Twiddle_W_ex_r;
input          k;
case(k)
 0 : Twiddle_W_ex_r = 1;
 1 : Twiddle_W_ex_r = 0;
default : Twiddle_W_ex_r = 0;
endcase
endfunction
function [1:0] Twiddle_W_ex_i;
input          k;
case(k)
 0 : Twiddle_W_ex_i = 0;
 1 : Twiddle_W_ex_i = 2;
default : Twiddle_W_ex_i = 0;
endcase
endfunction
endmodule


module TWIDDLE_ST8(k, W_ex_r, W_r, W_ex_i, W_i);
input  [1:0]  k;
output [`W-1:0]  W_r, W_i;
output [1:0]   W_ex_r, W_ex_i;
assign W_r = Twiddle_W_r(k);
assign W_i = Twiddle_W_i(k);
assign W_ex_r = Twiddle_W_ex_r(k);
assign W_ex_i = Twiddle_W_ex_i(k);
function [`W-1:0] Twiddle_W_r;
input  [1:0]  k;
case(k)
 0 : Twiddle_W_r = 32604;
 1 : Twiddle_W_r = 23170;
 2 : Twiddle_W_r = 0;
 3 : Twiddle_W_r = 42365;
default : Twiddle_W_r = 0;
endcase
endfunction
function [`W-1:0] Twiddle_W_i;
input  [1:0]  k;
case(k)
 0 : Twiddle_W_i = 0;
 1 : Twiddle_W_i = 42365;
 2 : Twiddle_W_i = 32931;
 3 : Twiddle_W_i = 42365;
default : Twiddle_W_i = 0;
endcase
endfunction
function [1:0] Twiddle_W_ex_r;
input  [1:0]  k;
case(k)
 0 : Twiddle_W_ex_r = 1;
 1 : Twiddle_W_ex_r = 0;
 2 : Twiddle_W_ex_r = 0;
 3 : Twiddle_W_ex_r = 0;
default : Twiddle_W_ex_r = 0;
endcase
endfunction
function [1:0] Twiddle_W_ex_i;
input  [1:0]  k;
case(k)
 0 : Twiddle_W_ex_i = 0;
 1 : Twiddle_W_ex_i = 0;
 2 : Twiddle_W_ex_i = 2;
 3 : Twiddle_W_ex_i = 0;
default : Twiddle_W_ex_i = 0;
endcase
endfunction
endmodule


module TWIDDLE_ST7(k, W_ex_r, W_r, W_ex_i, W_i);
input  [2:0]  k;
output [`W-1:0]  W_r, W_i;
output [1:0]   W_ex_r, W_ex_i;
assign W_r = Twiddle_W_r(k);
assign W_i = Twiddle_W_i(k);
assign W_ex_r = Twiddle_W_ex_r(k);
assign W_ex_i = Twiddle_W_ex_i(k);
function [`W-1:0] Twiddle_W_r;
input  [2:0]  k;
case(k)
 0 : Twiddle_W_r = 32604;
 1 : Twiddle_W_r = 30273;
 2 : Twiddle_W_r = 23170;
 3 : Twiddle_W_r = 12539;
 4 : Twiddle_W_r = 0;
 5 : Twiddle_W_r = 52996;
 6 : Twiddle_W_r = 42365;
 7 : Twiddle_W_r = 35262;
default : Twiddle_W_r = 0;
endcase
endfunction
function [`W-1:0] Twiddle_W_i;
input  [2:0]  k;
case(k)
 0 : Twiddle_W_i = 0;
 1 : Twiddle_W_i = 52996;
 2 : Twiddle_W_i = 42365;
 3 : Twiddle_W_i = 35262;
 4 : Twiddle_W_i = 32931;
 5 : Twiddle_W_i = 35262;
 6 : Twiddle_W_i = 42365;
 7 : Twiddle_W_i = 52996;
default : Twiddle_W_i = 0;
endcase
endfunction
function [1:0] Twiddle_W_ex_r;
input  [2:0]  k;
case(k)
 0 : Twiddle_W_ex_r = 1;
 1 : Twiddle_W_ex_r = 0;
 2 : Twiddle_W_ex_r = 0;
 3 : Twiddle_W_ex_r = 0;
 4 : Twiddle_W_ex_r = 0;
 5 : Twiddle_W_ex_r = 0;
 6 : Twiddle_W_ex_r = 0;
 7 : Twiddle_W_ex_r = 0;
default : Twiddle_W_ex_r = 0;
endcase
endfunction
function [1:0] Twiddle_W_ex_i;
input  [2:0]  k;
case(k)
 0 : Twiddle_W_ex_i = 0;
 1 : Twiddle_W_ex_i = 0;
 2 : Twiddle_W_ex_i = 0;
 3 : Twiddle_W_ex_i = 0;
 4 : Twiddle_W_ex_i = 2;
 5 : Twiddle_W_ex_i = 0;
 6 : Twiddle_W_ex_i = 0;
 7 : Twiddle_W_ex_i = 0;
default : Twiddle_W_ex_i = 0;
endcase
endfunction
endmodule


module TWIDDLE_ST6(k, W_ex_r, W_r, W_ex_i, W_i);
input  [3:0]  k;
output [`W-1:0]  W_r, W_i;
output [1:0]   W_ex_r, W_ex_i;
assign W_r = Twiddle_W_r(k);
assign W_i = Twiddle_W_i(k);
assign W_ex_r = Twiddle_W_ex_r(k);
assign W_ex_i = Twiddle_W_ex_i(k);
function [`W-1:0] Twiddle_W_r;
input  [3:0]  k;
case(k)
 0 : Twiddle_W_r = 32604;
 1 : Twiddle_W_r = 32138;
 2 : Twiddle_W_r = 30273;
 3 : Twiddle_W_r = 27245;
 4 : Twiddle_W_r = 23170;
 5 : Twiddle_W_r = 18204;
 6 : Twiddle_W_r = 12539;
 7 : Twiddle_W_r = 6392;
 8 : Twiddle_W_r = 0;
 9 : Twiddle_W_r = 59143;
 10 : Twiddle_W_r = 52996;
 11 : Twiddle_W_r = 47331;
 12 : Twiddle_W_r = 42365;
 13 : Twiddle_W_r = 38290;
 14 : Twiddle_W_r = 35262;
 15 : Twiddle_W_r = 33397;
default : Twiddle_W_r = 0;
endcase
endfunction
function [`W-1:0] Twiddle_W_i;
input  [3:0]  k;
case(k)
 0 : Twiddle_W_i = 0;
 1 : Twiddle_W_i = 59143;
 2 : Twiddle_W_i = 52996;
 3 : Twiddle_W_i = 47331;
 4 : Twiddle_W_i = 42365;
 5 : Twiddle_W_i = 38290;
 6 : Twiddle_W_i = 35262;
 7 : Twiddle_W_i = 33397;
 8 : Twiddle_W_i = 32931;
 9 : Twiddle_W_i = 33397;
 10 : Twiddle_W_i = 35262;
 11 : Twiddle_W_i = 38290;
 12 : Twiddle_W_i = 42365;
 13 : Twiddle_W_i = 47331;
 14 : Twiddle_W_i = 52996;
 15 : Twiddle_W_i = 59143;
default : Twiddle_W_i = 0;
endcase
endfunction
function [1:0] Twiddle_W_ex_r;
input  [3:0]  k;
case(k)
 0 : Twiddle_W_ex_r = 1;
 1 : Twiddle_W_ex_r = 0;
 2 : Twiddle_W_ex_r = 0;
 3 : Twiddle_W_ex_r = 0;
 4 : Twiddle_W_ex_r = 0;
 5 : Twiddle_W_ex_r = 0;
 6 : Twiddle_W_ex_r = 0;
 7 : Twiddle_W_ex_r = 0;
 8 : Twiddle_W_ex_r = 0;
 9 : Twiddle_W_ex_r = 0;
 10 : Twiddle_W_ex_r = 0;
 11 : Twiddle_W_ex_r = 0;
 12 : Twiddle_W_ex_r = 0;
 13 : Twiddle_W_ex_r = 0;
 14 : Twiddle_W_ex_r = 0;
 15 : Twiddle_W_ex_r = 0;
default : Twiddle_W_ex_r = 0;
endcase
endfunction
function [1:0] Twiddle_W_ex_i;
input  [3:0]  k;
case(k)
 0 : Twiddle_W_ex_i = 0;
 1 : Twiddle_W_ex_i = 0;
 2 : Twiddle_W_ex_i = 0;
 3 : Twiddle_W_ex_i = 0;
 4 : Twiddle_W_ex_i = 0;
 5 : Twiddle_W_ex_i = 0;
 6 : Twiddle_W_ex_i = 0;
 7 : Twiddle_W_ex_i = 0;
 8 : Twiddle_W_ex_i = 2;
 9 : Twiddle_W_ex_i = 0;
 10 : Twiddle_W_ex_i = 0;
 11 : Twiddle_W_ex_i = 0;
 12 : Twiddle_W_ex_i = 0;
 13 : Twiddle_W_ex_i = 0;
 14 : Twiddle_W_ex_i = 0;
 15 : Twiddle_W_ex_i = 0;
default : Twiddle_W_ex_i = 0;
endcase
endfunction
endmodule


module TWIDDLE_ST5(k, W_ex_r, W_r, W_ex_i, W_i);
input  [4:0]  k;
output [`W-1:0]  W_r, W_i;
output [1:0]   W_ex_r, W_ex_i;
assign W_r = Twiddle_W_r(k);
assign W_i = Twiddle_W_i(k);
assign W_ex_r = Twiddle_W_ex_r(k);
assign W_ex_i = Twiddle_W_ex_i(k);
function [`W-1:0] Twiddle_W_r;
input  [4:0]  k;
case(k)
 0 : Twiddle_W_r = 32604;
 1 : Twiddle_W_r = 32610;
 2 : Twiddle_W_r = 32138;
 3 : Twiddle_W_r = 31357;
 4 : Twiddle_W_r = 30273;
 5 : Twiddle_W_r = 28898;
 6 : Twiddle_W_r = 27245;
 7 : Twiddle_W_r = 25330;
 8 : Twiddle_W_r = 23170;
 9 : Twiddle_W_r = 20787;
 10 : Twiddle_W_r = 18204;
 11 : Twiddle_W_r = 15446;
 12 : Twiddle_W_r = 12539;
 13 : Twiddle_W_r = 9512;
 14 : Twiddle_W_r = 6392;
 15 : Twiddle_W_r = 3211;
 16 : Twiddle_W_r = 0;
 17 : Twiddle_W_r = 62324;
 18 : Twiddle_W_r = 59143;
 19 : Twiddle_W_r = 56023;
 20 : Twiddle_W_r = 52996;
 21 : Twiddle_W_r = 50089;
 22 : Twiddle_W_r = 47331;
 23 : Twiddle_W_r = 44748;
 24 : Twiddle_W_r = 42365;
 25 : Twiddle_W_r = 40205;
 26 : Twiddle_W_r = 38290;
 27 : Twiddle_W_r = 36637;
 28 : Twiddle_W_r = 35262;
 29 : Twiddle_W_r = 34178;
 30 : Twiddle_W_r = 33397;
 31 : Twiddle_W_r = 32925;
default : Twiddle_W_r = 0;
endcase
endfunction
function [`W-1:0] Twiddle_W_i;
input  [4:0]  k;
case(k)
 0 : Twiddle_W_i = 0;
 1 : Twiddle_W_i = 62324;
 2 : Twiddle_W_i = 59143;
 3 : Twiddle_W_i = 56023;
 4 : Twiddle_W_i = 52996;
 5 : Twiddle_W_i = 50089;
 6 : Twiddle_W_i = 47331;
 7 : Twiddle_W_i = 44748;
 8 : Twiddle_W_i = 42365;
 9 : Twiddle_W_i = 40205;
 10 : Twiddle_W_i = 38290;
 11 : Twiddle_W_i = 36637;
 12 : Twiddle_W_i = 35262;
 13 : Twiddle_W_i = 34178;
 14 : Twiddle_W_i = 33397;
 15 : Twiddle_W_i = 32925;
 16 : Twiddle_W_i = 32931;
 17 : Twiddle_W_i = 32925;
 18 : Twiddle_W_i = 33397;
 19 : Twiddle_W_i = 34178;
 20 : Twiddle_W_i = 35262;
 21 : Twiddle_W_i = 36637;
 22 : Twiddle_W_i = 38290;
 23 : Twiddle_W_i = 40205;
 24 : Twiddle_W_i = 42365;
 25 : Twiddle_W_i = 44748;
 26 : Twiddle_W_i = 47331;
 27 : Twiddle_W_i = 50089;
 28 : Twiddle_W_i = 52996;
 29 : Twiddle_W_i = 56023;
 30 : Twiddle_W_i = 59143;
 31 : Twiddle_W_i = 62324;
default : Twiddle_W_i = 0;
endcase
endfunction
function [1:0] Twiddle_W_ex_r;
input  [4:0]  k;
case(k)
 0 : Twiddle_W_ex_r = 1;
 1 : Twiddle_W_ex_r = 0;
 2 : Twiddle_W_ex_r = 0;
 3 : Twiddle_W_ex_r = 0;
 4 : Twiddle_W_ex_r = 0;
 5 : Twiddle_W_ex_r = 0;
 6 : Twiddle_W_ex_r = 0;
 7 : Twiddle_W_ex_r = 0;
 8 : Twiddle_W_ex_r = 0;
 9 : Twiddle_W_ex_r = 0;
 10 : Twiddle_W_ex_r = 0;
 11 : Twiddle_W_ex_r = 0;
 12 : Twiddle_W_ex_r = 0;
 13 : Twiddle_W_ex_r = 0;
 14 : Twiddle_W_ex_r = 0;
 15 : Twiddle_W_ex_r = 0;
 16 : Twiddle_W_ex_r = 0;
 17 : Twiddle_W_ex_r = 0;
 18 : Twiddle_W_ex_r = 0;
 19 : Twiddle_W_ex_r = 0;
 20 : Twiddle_W_ex_r = 0;
 21 : Twiddle_W_ex_r = 0;
 22 : Twiddle_W_ex_r = 0;
 23 : Twiddle_W_ex_r = 0;
 24 : Twiddle_W_ex_r = 0;
 25 : Twiddle_W_ex_r = 0;
 26 : Twiddle_W_ex_r = 0;
 27 : Twiddle_W_ex_r = 0;
 28 : Twiddle_W_ex_r = 0;
 29 : Twiddle_W_ex_r = 0;
 30 : Twiddle_W_ex_r = 0;
 31 : Twiddle_W_ex_r = 0;
default : Twiddle_W_ex_r = 0;
endcase
endfunction
function [1:0] Twiddle_W_ex_i;
input  [4:0]  k;
case(k)
 0 : Twiddle_W_ex_i = 0;
 1 : Twiddle_W_ex_i = 0;
 2 : Twiddle_W_ex_i = 0;
 3 : Twiddle_W_ex_i = 0;
 4 : Twiddle_W_ex_i = 0;
 5 : Twiddle_W_ex_i = 0;
 6 : Twiddle_W_ex_i = 0;
 7 : Twiddle_W_ex_i = 0;
 8 : Twiddle_W_ex_i = 0;
 9 : Twiddle_W_ex_i = 0;
 10 : Twiddle_W_ex_i = 0;
 11 : Twiddle_W_ex_i = 0;
 12 : Twiddle_W_ex_i = 0;
 13 : Twiddle_W_ex_i = 0;
 14 : Twiddle_W_ex_i = 0;
 15 : Twiddle_W_ex_i = 0;
 16 : Twiddle_W_ex_i = 2;
 17 : Twiddle_W_ex_i = 0;
 18 : Twiddle_W_ex_i = 0;
 19 : Twiddle_W_ex_i = 0;
 20 : Twiddle_W_ex_i = 0;
 21 : Twiddle_W_ex_i = 0;
 22 : Twiddle_W_ex_i = 0;
 23 : Twiddle_W_ex_i = 0;
 24 : Twiddle_W_ex_i = 0;
 25 : Twiddle_W_ex_i = 0;
 26 : Twiddle_W_ex_i = 0;
 27 : Twiddle_W_ex_i = 0;
 28 : Twiddle_W_ex_i = 0;
 29 : Twiddle_W_ex_i = 0;
 30 : Twiddle_W_ex_i = 0;
 31 : Twiddle_W_ex_i = 0;
default : Twiddle_W_ex_i = 0;
endcase
endfunction
endmodule


module TWIDDLE_ST4(k, W_ex_r, W_r, W_ex_i, W_i);
input  [5:0]  k;
output [`W-1:0]  W_r, W_i;
output [1:0]   W_ex_r, W_ex_i;
assign W_r = Twiddle_W_r(k);
assign W_i = Twiddle_W_i(k);
assign W_ex_r = Twiddle_W_ex_r(k);
assign W_ex_i = Twiddle_W_ex_i(k);
function [`W-1:0] Twiddle_W_r;
input  [5:0]  k;
case(k)
 0 : Twiddle_W_r = 32604;
 1 : Twiddle_W_r = 32728;
 2 : Twiddle_W_r = 32610;
 3 : Twiddle_W_r = 32413;
 4 : Twiddle_W_r = 32138;
 5 : Twiddle_W_r = 31785;
 6 : Twiddle_W_r = 31357;
 7 : Twiddle_W_r = 30852;
 8 : Twiddle_W_r = 30273;
 9 : Twiddle_W_r = 29621;
 10 : Twiddle_W_r = 28898;
 11 : Twiddle_W_r = 28106;
 12 : Twiddle_W_r = 27245;
 13 : Twiddle_W_r = 26319;
 14 : Twiddle_W_r = 25330;
 15 : Twiddle_W_r = 24279;
 16 : Twiddle_W_r = 23170;
 17 : Twiddle_W_r = 22005;
 18 : Twiddle_W_r = 20787;
 19 : Twiddle_W_r = 19519;
 20 : Twiddle_W_r = 18204;
 21 : Twiddle_W_r = 16846;
 22 : Twiddle_W_r = 15446;
 23 : Twiddle_W_r = 14010;
 24 : Twiddle_W_r = 12539;
 25 : Twiddle_W_r = 11039;
 26 : Twiddle_W_r = 9512;
 27 : Twiddle_W_r = 7961;
 28 : Twiddle_W_r = 6392;
 29 : Twiddle_W_r = 4808;
 30 : Twiddle_W_r = 3211;
 31 : Twiddle_W_r = 1607;
 32 : Twiddle_W_r = 0;
 33 : Twiddle_W_r = 63928;
 34 : Twiddle_W_r = 62324;
 35 : Twiddle_W_r = 60727;
 36 : Twiddle_W_r = 59143;
 37 : Twiddle_W_r = 57574;
 38 : Twiddle_W_r = 56023;
 39 : Twiddle_W_r = 54496;
 40 : Twiddle_W_r = 52996;
 41 : Twiddle_W_r = 51525;
 42 : Twiddle_W_r = 50089;
 43 : Twiddle_W_r = 48689;
 44 : Twiddle_W_r = 47331;
 45 : Twiddle_W_r = 46016;
 46 : Twiddle_W_r = 44748;
 47 : Twiddle_W_r = 43530;
 48 : Twiddle_W_r = 42365;
 49 : Twiddle_W_r = 41256;
 50 : Twiddle_W_r = 40205;
 51 : Twiddle_W_r = 39216;
 52 : Twiddle_W_r = 38290;
 53 : Twiddle_W_r = 37429;
 54 : Twiddle_W_r = 36637;
 55 : Twiddle_W_r = 35914;
 56 : Twiddle_W_r = 35262;
 57 : Twiddle_W_r = 34683;
 58 : Twiddle_W_r = 34178;
 59 : Twiddle_W_r = 33750;
 60 : Twiddle_W_r = 33397;
 61 : Twiddle_W_r = 33122;
 62 : Twiddle_W_r = 32925;
 63 : Twiddle_W_r = 32807;
default : Twiddle_W_r = 0;
endcase
endfunction
function [`W-1:0] Twiddle_W_i;
input  [5:0]  k;
case(k)
 0 : Twiddle_W_i = 0;
 1 : Twiddle_W_i = 63928;
 2 : Twiddle_W_i = 62324;
 3 : Twiddle_W_i = 60727;
 4 : Twiddle_W_i = 59143;
 5 : Twiddle_W_i = 57574;
 6 : Twiddle_W_i = 56023;
 7 : Twiddle_W_i = 54496;
 8 : Twiddle_W_i = 52996;
 9 : Twiddle_W_i = 51525;
 10 : Twiddle_W_i = 50089;
 11 : Twiddle_W_i = 48689;
 12 : Twiddle_W_i = 47331;
 13 : Twiddle_W_i = 46016;
 14 : Twiddle_W_i = 44748;
 15 : Twiddle_W_i = 43530;
 16 : Twiddle_W_i = 42365;
 17 : Twiddle_W_i = 41256;
 18 : Twiddle_W_i = 40205;
 19 : Twiddle_W_i = 39216;
 20 : Twiddle_W_i = 38290;
 21 : Twiddle_W_i = 37429;
 22 : Twiddle_W_i = 36637;
 23 : Twiddle_W_i = 35914;
 24 : Twiddle_W_i = 35262;
 25 : Twiddle_W_i = 34683;
 26 : Twiddle_W_i = 34178;
 27 : Twiddle_W_i = 33750;
 28 : Twiddle_W_i = 33397;
 29 : Twiddle_W_i = 33122;
 30 : Twiddle_W_i = 32925;
 31 : Twiddle_W_i = 32807;
 32 : Twiddle_W_i = 32931;
 33 : Twiddle_W_i = 32807;
 34 : Twiddle_W_i = 32925;
 35 : Twiddle_W_i = 33122;
 36 : Twiddle_W_i = 33397;
 37 : Twiddle_W_i = 33750;
 38 : Twiddle_W_i = 34178;
 39 : Twiddle_W_i = 34683;
 40 : Twiddle_W_i = 35262;
 41 : Twiddle_W_i = 35914;
 42 : Twiddle_W_i = 36637;
 43 : Twiddle_W_i = 37429;
 44 : Twiddle_W_i = 38290;
 45 : Twiddle_W_i = 39216;
 46 : Twiddle_W_i = 40205;
 47 : Twiddle_W_i = 41256;
 48 : Twiddle_W_i = 42365;
 49 : Twiddle_W_i = 43530;
 50 : Twiddle_W_i = 44748;
 51 : Twiddle_W_i = 46016;
 52 : Twiddle_W_i = 47331;
 53 : Twiddle_W_i = 48689;
 54 : Twiddle_W_i = 50089;
 55 : Twiddle_W_i = 51525;
 56 : Twiddle_W_i = 52996;
 57 : Twiddle_W_i = 54496;
 58 : Twiddle_W_i = 56023;
 59 : Twiddle_W_i = 57574;
 60 : Twiddle_W_i = 59143;
 61 : Twiddle_W_i = 60727;
 62 : Twiddle_W_i = 62324;
 63 : Twiddle_W_i = 63928;
default : Twiddle_W_i = 0;
endcase
endfunction
function [1:0] Twiddle_W_ex_r;
input  [5:0]  k;
case(k)
 0 : Twiddle_W_ex_r = 1;
 1 : Twiddle_W_ex_r = 0;
 2 : Twiddle_W_ex_r = 0;
 3 : Twiddle_W_ex_r = 0;
 4 : Twiddle_W_ex_r = 0;
 5 : Twiddle_W_ex_r = 0;
 6 : Twiddle_W_ex_r = 0;
 7 : Twiddle_W_ex_r = 0;
 8 : Twiddle_W_ex_r = 0;
 9 : Twiddle_W_ex_r = 0;
 10 : Twiddle_W_ex_r = 0;
 11 : Twiddle_W_ex_r = 0;
 12 : Twiddle_W_ex_r = 0;
 13 : Twiddle_W_ex_r = 0;
 14 : Twiddle_W_ex_r = 0;
 15 : Twiddle_W_ex_r = 0;
 16 : Twiddle_W_ex_r = 0;
 17 : Twiddle_W_ex_r = 0;
 18 : Twiddle_W_ex_r = 0;
 19 : Twiddle_W_ex_r = 0;
 20 : Twiddle_W_ex_r = 0;
 21 : Twiddle_W_ex_r = 0;
 22 : Twiddle_W_ex_r = 0;
 23 : Twiddle_W_ex_r = 0;
 24 : Twiddle_W_ex_r = 0;
 25 : Twiddle_W_ex_r = 0;
 26 : Twiddle_W_ex_r = 0;
 27 : Twiddle_W_ex_r = 0;
 28 : Twiddle_W_ex_r = 0;
 29 : Twiddle_W_ex_r = 0;
 30 : Twiddle_W_ex_r = 0;
 31 : Twiddle_W_ex_r = 0;
 32 : Twiddle_W_ex_r = 0;
 33 : Twiddle_W_ex_r = 0;
 34 : Twiddle_W_ex_r = 0;
 35 : Twiddle_W_ex_r = 0;
 36 : Twiddle_W_ex_r = 0;
 37 : Twiddle_W_ex_r = 0;
 38 : Twiddle_W_ex_r = 0;
 39 : Twiddle_W_ex_r = 0;
 40 : Twiddle_W_ex_r = 0;
 41 : Twiddle_W_ex_r = 0;
 42 : Twiddle_W_ex_r = 0;
 43 : Twiddle_W_ex_r = 0;
 44 : Twiddle_W_ex_r = 0;
 45 : Twiddle_W_ex_r = 0;
 46 : Twiddle_W_ex_r = 0;
 47 : Twiddle_W_ex_r = 0;
 48 : Twiddle_W_ex_r = 0;
 49 : Twiddle_W_ex_r = 0;
 50 : Twiddle_W_ex_r = 0;
 51 : Twiddle_W_ex_r = 0;
 52 : Twiddle_W_ex_r = 0;
 53 : Twiddle_W_ex_r = 0;
 54 : Twiddle_W_ex_r = 0;
 55 : Twiddle_W_ex_r = 0;
 56 : Twiddle_W_ex_r = 0;
 57 : Twiddle_W_ex_r = 0;
 58 : Twiddle_W_ex_r = 0;
 59 : Twiddle_W_ex_r = 0;
 60 : Twiddle_W_ex_r = 0;
 61 : Twiddle_W_ex_r = 0;
 62 : Twiddle_W_ex_r = 0;
 63 : Twiddle_W_ex_r = 0;
default : Twiddle_W_ex_r = 0;
endcase
endfunction
function [1:0] Twiddle_W_ex_i;
input  [5:0]  k;
case(k)
 0 : Twiddle_W_ex_i = 0;
 1 : Twiddle_W_ex_i = 0;
 2 : Twiddle_W_ex_i = 0;
 3 : Twiddle_W_ex_i = 0;
 4 : Twiddle_W_ex_i = 0;
 5 : Twiddle_W_ex_i = 0;
 6 : Twiddle_W_ex_i = 0;
 7 : Twiddle_W_ex_i = 0;
 8 : Twiddle_W_ex_i = 0;
 9 : Twiddle_W_ex_i = 0;
 10 : Twiddle_W_ex_i = 0;
 11 : Twiddle_W_ex_i = 0;
 12 : Twiddle_W_ex_i = 0;
 13 : Twiddle_W_ex_i = 0;
 14 : Twiddle_W_ex_i = 0;
 15 : Twiddle_W_ex_i = 0;
 16 : Twiddle_W_ex_i = 0;
 17 : Twiddle_W_ex_i = 0;
 18 : Twiddle_W_ex_i = 0;
 19 : Twiddle_W_ex_i = 0;
 20 : Twiddle_W_ex_i = 0;
 21 : Twiddle_W_ex_i = 0;
 22 : Twiddle_W_ex_i = 0;
 23 : Twiddle_W_ex_i = 0;
 24 : Twiddle_W_ex_i = 0;
 25 : Twiddle_W_ex_i = 0;
 26 : Twiddle_W_ex_i = 0;
 27 : Twiddle_W_ex_i = 0;
 28 : Twiddle_W_ex_i = 0;
 29 : Twiddle_W_ex_i = 0;
 30 : Twiddle_W_ex_i = 0;
 31 : Twiddle_W_ex_i = 0;
 32 : Twiddle_W_ex_i = 2;
 33 : Twiddle_W_ex_i = 0;
 34 : Twiddle_W_ex_i = 0;
 35 : Twiddle_W_ex_i = 0;
 36 : Twiddle_W_ex_i = 0;
 37 : Twiddle_W_ex_i = 0;
 38 : Twiddle_W_ex_i = 0;
 39 : Twiddle_W_ex_i = 0;
 40 : Twiddle_W_ex_i = 0;
 41 : Twiddle_W_ex_i = 0;
 42 : Twiddle_W_ex_i = 0;
 43 : Twiddle_W_ex_i = 0;
 44 : Twiddle_W_ex_i = 0;
 45 : Twiddle_W_ex_i = 0;
 46 : Twiddle_W_ex_i = 0;
 47 : Twiddle_W_ex_i = 0;
 48 : Twiddle_W_ex_i = 0;
 49 : Twiddle_W_ex_i = 0;
 50 : Twiddle_W_ex_i = 0;
 51 : Twiddle_W_ex_i = 0;
 52 : Twiddle_W_ex_i = 0;
 53 : Twiddle_W_ex_i = 0;
 54 : Twiddle_W_ex_i = 0;
 55 : Twiddle_W_ex_i = 0;
 56 : Twiddle_W_ex_i = 0;
 57 : Twiddle_W_ex_i = 0;
 58 : Twiddle_W_ex_i = 0;
 59 : Twiddle_W_ex_i = 0;
 60 : Twiddle_W_ex_i = 0;
 61 : Twiddle_W_ex_i = 0;
 62 : Twiddle_W_ex_i = 0;
 63 : Twiddle_W_ex_i = 0;
default : Twiddle_W_ex_i = 0;
endcase
endfunction
endmodule


module TWIDDLE_ST3(k, W_ex_r, W_r, W_ex_i, W_i);
input  [6:0]  k;
output [`W-1:0]  W_r, W_i;
output [1:0]   W_ex_r, W_ex_i;
assign W_r = Twiddle_W_r(k);
assign W_i = Twiddle_W_i(k);
assign W_ex_r = Twiddle_W_ex_r(k);
assign W_ex_i = Twiddle_W_ex_i(k);
function [`W-1:0] Twiddle_W_r;
input  [6:0]  k;
case(k)
 0 : Twiddle_W_r = 32604;
 1 : Twiddle_W_r = 32758;
 2 : Twiddle_W_r = 32728;
 3 : Twiddle_W_r = 32679;
 4 : Twiddle_W_r = 32610;
 5 : Twiddle_W_r = 32521;
 6 : Twiddle_W_r = 32413;
 7 : Twiddle_W_r = 32285;
 8 : Twiddle_W_r = 32138;
 9 : Twiddle_W_r = 31971;
 10 : Twiddle_W_r = 31785;
 11 : Twiddle_W_r = 31581;
 12 : Twiddle_W_r = 31357;
 13 : Twiddle_W_r = 31114;
 14 : Twiddle_W_r = 30852;
 15 : Twiddle_W_r = 30572;
 16 : Twiddle_W_r = 30273;
 17 : Twiddle_W_r = 29956;
 18 : Twiddle_W_r = 29621;
 19 : Twiddle_W_r = 29269;
 20 : Twiddle_W_r = 28898;
 21 : Twiddle_W_r = 28511;
 22 : Twiddle_W_r = 28106;
 23 : Twiddle_W_r = 27684;
 24 : Twiddle_W_r = 27245;
 25 : Twiddle_W_r = 26790;
 26 : Twiddle_W_r = 26319;
 27 : Twiddle_W_r = 25832;
 28 : Twiddle_W_r = 25330;
 29 : Twiddle_W_r = 24812;
 30 : Twiddle_W_r = 24279;
 31 : Twiddle_W_r = 23732;
 32 : Twiddle_W_r = 23170;
 33 : Twiddle_W_r = 22594;
 34 : Twiddle_W_r = 22005;
 35 : Twiddle_W_r = 21403;
 36 : Twiddle_W_r = 20787;
 37 : Twiddle_W_r = 20159;
 38 : Twiddle_W_r = 19519;
 39 : Twiddle_W_r = 18868;
 40 : Twiddle_W_r = 18204;
 41 : Twiddle_W_r = 17530;
 42 : Twiddle_W_r = 16846;
 43 : Twiddle_W_r = 16151;
 44 : Twiddle_W_r = 15446;
 45 : Twiddle_W_r = 14732;
 46 : Twiddle_W_r = 14010;
 47 : Twiddle_W_r = 13278;
 48 : Twiddle_W_r = 12539;
 49 : Twiddle_W_r = 11793;
 50 : Twiddle_W_r = 11039;
 51 : Twiddle_W_r = 10278;
 52 : Twiddle_W_r = 9512;
 53 : Twiddle_W_r = 8739;
 54 : Twiddle_W_r = 7961;
 55 : Twiddle_W_r = 7179;
 56 : Twiddle_W_r = 6392;
 57 : Twiddle_W_r = 5602;
 58 : Twiddle_W_r = 4808;
 59 : Twiddle_W_r = 4011;
 60 : Twiddle_W_r = 3211;
 61 : Twiddle_W_r = 2410;
 62 : Twiddle_W_r = 1607;
 63 : Twiddle_W_r = 804;
 64 : Twiddle_W_r = 0;
 65 : Twiddle_W_r = 64731;
 66 : Twiddle_W_r = 63928;
 67 : Twiddle_W_r = 63125;
 68 : Twiddle_W_r = 62324;
 69 : Twiddle_W_r = 61524;
 70 : Twiddle_W_r = 60727;
 71 : Twiddle_W_r = 59933;
 72 : Twiddle_W_r = 59143;
 73 : Twiddle_W_r = 58356;
 74 : Twiddle_W_r = 57574;
 75 : Twiddle_W_r = 56796;
 76 : Twiddle_W_r = 56023;
 77 : Twiddle_W_r = 55257;
 78 : Twiddle_W_r = 54496;
 79 : Twiddle_W_r = 53742;
 80 : Twiddle_W_r = 52996;
 81 : Twiddle_W_r = 52257;
 82 : Twiddle_W_r = 51525;
 83 : Twiddle_W_r = 50803;
 84 : Twiddle_W_r = 50089;
 85 : Twiddle_W_r = 49384;
 86 : Twiddle_W_r = 48689;
 87 : Twiddle_W_r = 48005;
 88 : Twiddle_W_r = 47331;
 89 : Twiddle_W_r = 46667;
 90 : Twiddle_W_r = 46016;
 91 : Twiddle_W_r = 45376;
 92 : Twiddle_W_r = 44748;
 93 : Twiddle_W_r = 44132;
 94 : Twiddle_W_r = 43530;
 95 : Twiddle_W_r = 42941;
 96 : Twiddle_W_r = 42365;
 97 : Twiddle_W_r = 41803;
 98 : Twiddle_W_r = 41256;
 99 : Twiddle_W_r = 40723;
 100 : Twiddle_W_r = 40205;
 101 : Twiddle_W_r = 39703;
 102 : Twiddle_W_r = 39216;
 103 : Twiddle_W_r = 38745;
 104 : Twiddle_W_r = 38290;
 105 : Twiddle_W_r = 37851;
 106 : Twiddle_W_r = 37429;
 107 : Twiddle_W_r = 37024;
 108 : Twiddle_W_r = 36637;
 109 : Twiddle_W_r = 36266;
 110 : Twiddle_W_r = 35914;
 111 : Twiddle_W_r = 35579;
 112 : Twiddle_W_r = 35262;
 113 : Twiddle_W_r = 34963;
 114 : Twiddle_W_r = 34683;
 115 : Twiddle_W_r = 34421;
 116 : Twiddle_W_r = 34178;
 117 : Twiddle_W_r = 33954;
 118 : Twiddle_W_r = 33750;
 119 : Twiddle_W_r = 33564;
 120 : Twiddle_W_r = 33397;
 121 : Twiddle_W_r = 33250;
 122 : Twiddle_W_r = 33122;
 123 : Twiddle_W_r = 33014;
 124 : Twiddle_W_r = 32925;
 125 : Twiddle_W_r = 32856;
 126 : Twiddle_W_r = 32807;
 127 : Twiddle_W_r = 32777;
default : Twiddle_W_r = 0;
endcase
endfunction
function [`W-1:0] Twiddle_W_i;
input  [6:0]  k;
case(k)
 0 : Twiddle_W_i = 0;
 1 : Twiddle_W_i = 64731;
 2 : Twiddle_W_i = 63928;
 3 : Twiddle_W_i = 63125;
 4 : Twiddle_W_i = 62324;
 5 : Twiddle_W_i = 61524;
 6 : Twiddle_W_i = 60727;
 7 : Twiddle_W_i = 59933;
 8 : Twiddle_W_i = 59143;
 9 : Twiddle_W_i = 58356;
 10 : Twiddle_W_i = 57574;
 11 : Twiddle_W_i = 56796;
 12 : Twiddle_W_i = 56023;
 13 : Twiddle_W_i = 55257;
 14 : Twiddle_W_i = 54496;
 15 : Twiddle_W_i = 53742;
 16 : Twiddle_W_i = 52996;
 17 : Twiddle_W_i = 52257;
 18 : Twiddle_W_i = 51525;
 19 : Twiddle_W_i = 50803;
 20 : Twiddle_W_i = 50089;
 21 : Twiddle_W_i = 49384;
 22 : Twiddle_W_i = 48689;
 23 : Twiddle_W_i = 48005;
 24 : Twiddle_W_i = 47331;
 25 : Twiddle_W_i = 46667;
 26 : Twiddle_W_i = 46016;
 27 : Twiddle_W_i = 45376;
 28 : Twiddle_W_i = 44748;
 29 : Twiddle_W_i = 44132;
 30 : Twiddle_W_i = 43530;
 31 : Twiddle_W_i = 42941;
 32 : Twiddle_W_i = 42365;
 33 : Twiddle_W_i = 41803;
 34 : Twiddle_W_i = 41256;
 35 : Twiddle_W_i = 40723;
 36 : Twiddle_W_i = 40205;
 37 : Twiddle_W_i = 39703;
 38 : Twiddle_W_i = 39216;
 39 : Twiddle_W_i = 38745;
 40 : Twiddle_W_i = 38290;
 41 : Twiddle_W_i = 37851;
 42 : Twiddle_W_i = 37429;
 43 : Twiddle_W_i = 37024;
 44 : Twiddle_W_i = 36637;
 45 : Twiddle_W_i = 36266;
 46 : Twiddle_W_i = 35914;
 47 : Twiddle_W_i = 35579;
 48 : Twiddle_W_i = 35262;
 49 : Twiddle_W_i = 34963;
 50 : Twiddle_W_i = 34683;
 51 : Twiddle_W_i = 34421;
 52 : Twiddle_W_i = 34178;
 53 : Twiddle_W_i = 33954;
 54 : Twiddle_W_i = 33750;
 55 : Twiddle_W_i = 33564;
 56 : Twiddle_W_i = 33397;
 57 : Twiddle_W_i = 33250;
 58 : Twiddle_W_i = 33122;
 59 : Twiddle_W_i = 33014;
 60 : Twiddle_W_i = 32925;
 61 : Twiddle_W_i = 32856;
 62 : Twiddle_W_i = 32807;
 63 : Twiddle_W_i = 32777;
 64 : Twiddle_W_i = 32931;
 65 : Twiddle_W_i = 32777;
 66 : Twiddle_W_i = 32807;
 67 : Twiddle_W_i = 32856;
 68 : Twiddle_W_i = 32925;
 69 : Twiddle_W_i = 33014;
 70 : Twiddle_W_i = 33122;
 71 : Twiddle_W_i = 33250;
 72 : Twiddle_W_i = 33397;
 73 : Twiddle_W_i = 33564;
 74 : Twiddle_W_i = 33750;
 75 : Twiddle_W_i = 33954;
 76 : Twiddle_W_i = 34178;
 77 : Twiddle_W_i = 34421;
 78 : Twiddle_W_i = 34683;
 79 : Twiddle_W_i = 34963;
 80 : Twiddle_W_i = 35262;
 81 : Twiddle_W_i = 35579;
 82 : Twiddle_W_i = 35914;
 83 : Twiddle_W_i = 36266;
 84 : Twiddle_W_i = 36637;
 85 : Twiddle_W_i = 37024;
 86 : Twiddle_W_i = 37429;
 87 : Twiddle_W_i = 37851;
 88 : Twiddle_W_i = 38290;
 89 : Twiddle_W_i = 38745;
 90 : Twiddle_W_i = 39216;
 91 : Twiddle_W_i = 39703;
 92 : Twiddle_W_i = 40205;
 93 : Twiddle_W_i = 40723;
 94 : Twiddle_W_i = 41256;
 95 : Twiddle_W_i = 41803;
 96 : Twiddle_W_i = 42365;
 97 : Twiddle_W_i = 42941;
 98 : Twiddle_W_i = 43530;
 99 : Twiddle_W_i = 44132;
 100 : Twiddle_W_i = 44748;
 101 : Twiddle_W_i = 45376;
 102 : Twiddle_W_i = 46016;
 103 : Twiddle_W_i = 46667;
 104 : Twiddle_W_i = 47331;
 105 : Twiddle_W_i = 48005;
 106 : Twiddle_W_i = 48689;
 107 : Twiddle_W_i = 49384;
 108 : Twiddle_W_i = 50089;
 109 : Twiddle_W_i = 50803;
 110 : Twiddle_W_i = 51525;
 111 : Twiddle_W_i = 52257;
 112 : Twiddle_W_i = 52996;
 113 : Twiddle_W_i = 53742;
 114 : Twiddle_W_i = 54496;
 115 : Twiddle_W_i = 55257;
 116 : Twiddle_W_i = 56023;
 117 : Twiddle_W_i = 56796;
 118 : Twiddle_W_i = 57574;
 119 : Twiddle_W_i = 58356;
 120 : Twiddle_W_i = 59143;
 121 : Twiddle_W_i = 59933;
 122 : Twiddle_W_i = 60727;
 123 : Twiddle_W_i = 61524;
 124 : Twiddle_W_i = 62324;
 125 : Twiddle_W_i = 63125;
 126 : Twiddle_W_i = 63928;
 127 : Twiddle_W_i = 64731;
default : Twiddle_W_i = 0;
endcase
endfunction
function [1:0] Twiddle_W_ex_r;
input  [6:0]  k;
case(k)
 0 : Twiddle_W_ex_r = 1;
 1 : Twiddle_W_ex_r = 0;
 2 : Twiddle_W_ex_r = 0;
 3 : Twiddle_W_ex_r = 0;
 4 : Twiddle_W_ex_r = 0;
 5 : Twiddle_W_ex_r = 0;
 6 : Twiddle_W_ex_r = 0;
 7 : Twiddle_W_ex_r = 0;
 8 : Twiddle_W_ex_r = 0;
 9 : Twiddle_W_ex_r = 0;
 10 : Twiddle_W_ex_r = 0;
 11 : Twiddle_W_ex_r = 0;
 12 : Twiddle_W_ex_r = 0;
 13 : Twiddle_W_ex_r = 0;
 14 : Twiddle_W_ex_r = 0;
 15 : Twiddle_W_ex_r = 0;
 16 : Twiddle_W_ex_r = 0;
 17 : Twiddle_W_ex_r = 0;
 18 : Twiddle_W_ex_r = 0;
 19 : Twiddle_W_ex_r = 0;
 20 : Twiddle_W_ex_r = 0;
 21 : Twiddle_W_ex_r = 0;
 22 : Twiddle_W_ex_r = 0;
 23 : Twiddle_W_ex_r = 0;
 24 : Twiddle_W_ex_r = 0;
 25 : Twiddle_W_ex_r = 0;
 26 : Twiddle_W_ex_r = 0;
 27 : Twiddle_W_ex_r = 0;
 28 : Twiddle_W_ex_r = 0;
 29 : Twiddle_W_ex_r = 0;
 30 : Twiddle_W_ex_r = 0;
 31 : Twiddle_W_ex_r = 0;
 32 : Twiddle_W_ex_r = 0;
 33 : Twiddle_W_ex_r = 0;
 34 : Twiddle_W_ex_r = 0;
 35 : Twiddle_W_ex_r = 0;
 36 : Twiddle_W_ex_r = 0;
 37 : Twiddle_W_ex_r = 0;
 38 : Twiddle_W_ex_r = 0;
 39 : Twiddle_W_ex_r = 0;
 40 : Twiddle_W_ex_r = 0;
 41 : Twiddle_W_ex_r = 0;
 42 : Twiddle_W_ex_r = 0;
 43 : Twiddle_W_ex_r = 0;
 44 : Twiddle_W_ex_r = 0;
 45 : Twiddle_W_ex_r = 0;
 46 : Twiddle_W_ex_r = 0;
 47 : Twiddle_W_ex_r = 0;
 48 : Twiddle_W_ex_r = 0;
 49 : Twiddle_W_ex_r = 0;
 50 : Twiddle_W_ex_r = 0;
 51 : Twiddle_W_ex_r = 0;
 52 : Twiddle_W_ex_r = 0;
 53 : Twiddle_W_ex_r = 0;
 54 : Twiddle_W_ex_r = 0;
 55 : Twiddle_W_ex_r = 0;
 56 : Twiddle_W_ex_r = 0;
 57 : Twiddle_W_ex_r = 0;
 58 : Twiddle_W_ex_r = 0;
 59 : Twiddle_W_ex_r = 0;
 60 : Twiddle_W_ex_r = 0;
 61 : Twiddle_W_ex_r = 0;
 62 : Twiddle_W_ex_r = 0;
 63 : Twiddle_W_ex_r = 0;
 64 : Twiddle_W_ex_r = 0;
 65 : Twiddle_W_ex_r = 0;
 66 : Twiddle_W_ex_r = 0;
 67 : Twiddle_W_ex_r = 0;
 68 : Twiddle_W_ex_r = 0;
 69 : Twiddle_W_ex_r = 0;
 70 : Twiddle_W_ex_r = 0;
 71 : Twiddle_W_ex_r = 0;
 72 : Twiddle_W_ex_r = 0;
 73 : Twiddle_W_ex_r = 0;
 74 : Twiddle_W_ex_r = 0;
 75 : Twiddle_W_ex_r = 0;
 76 : Twiddle_W_ex_r = 0;
 77 : Twiddle_W_ex_r = 0;
 78 : Twiddle_W_ex_r = 0;
 79 : Twiddle_W_ex_r = 0;
 80 : Twiddle_W_ex_r = 0;
 81 : Twiddle_W_ex_r = 0;
 82 : Twiddle_W_ex_r = 0;
 83 : Twiddle_W_ex_r = 0;
 84 : Twiddle_W_ex_r = 0;
 85 : Twiddle_W_ex_r = 0;
 86 : Twiddle_W_ex_r = 0;
 87 : Twiddle_W_ex_r = 0;
 88 : Twiddle_W_ex_r = 0;
 89 : Twiddle_W_ex_r = 0;
 90 : Twiddle_W_ex_r = 0;
 91 : Twiddle_W_ex_r = 0;
 92 : Twiddle_W_ex_r = 0;
 93 : Twiddle_W_ex_r = 0;
 94 : Twiddle_W_ex_r = 0;
 95 : Twiddle_W_ex_r = 0;
 96 : Twiddle_W_ex_r = 0;
 97 : Twiddle_W_ex_r = 0;
 98 : Twiddle_W_ex_r = 0;
 99 : Twiddle_W_ex_r = 0;
 100 : Twiddle_W_ex_r = 0;
 101 : Twiddle_W_ex_r = 0;
 102 : Twiddle_W_ex_r = 0;
 103 : Twiddle_W_ex_r = 0;
 104 : Twiddle_W_ex_r = 0;
 105 : Twiddle_W_ex_r = 0;
 106 : Twiddle_W_ex_r = 0;
 107 : Twiddle_W_ex_r = 0;
 108 : Twiddle_W_ex_r = 0;
 109 : Twiddle_W_ex_r = 0;
 110 : Twiddle_W_ex_r = 0;
 111 : Twiddle_W_ex_r = 0;
 112 : Twiddle_W_ex_r = 0;
 113 : Twiddle_W_ex_r = 0;
 114 : Twiddle_W_ex_r = 0;
 115 : Twiddle_W_ex_r = 0;
 116 : Twiddle_W_ex_r = 0;
 117 : Twiddle_W_ex_r = 0;
 118 : Twiddle_W_ex_r = 0;
 119 : Twiddle_W_ex_r = 0;
 120 : Twiddle_W_ex_r = 0;
 121 : Twiddle_W_ex_r = 0;
 122 : Twiddle_W_ex_r = 0;
 123 : Twiddle_W_ex_r = 0;
 124 : Twiddle_W_ex_r = 0;
 125 : Twiddle_W_ex_r = 0;
 126 : Twiddle_W_ex_r = 0;
 127 : Twiddle_W_ex_r = 0;
default : Twiddle_W_ex_r = 0;
endcase
endfunction
function [1:0] Twiddle_W_ex_i;
input  [6:0]  k;
case(k)
 0 : Twiddle_W_ex_i = 0;
 1 : Twiddle_W_ex_i = 0;
 2 : Twiddle_W_ex_i = 0;
 3 : Twiddle_W_ex_i = 0;
 4 : Twiddle_W_ex_i = 0;
 5 : Twiddle_W_ex_i = 0;
 6 : Twiddle_W_ex_i = 0;
 7 : Twiddle_W_ex_i = 0;
 8 : Twiddle_W_ex_i = 0;
 9 : Twiddle_W_ex_i = 0;
 10 : Twiddle_W_ex_i = 0;
 11 : Twiddle_W_ex_i = 0;
 12 : Twiddle_W_ex_i = 0;
 13 : Twiddle_W_ex_i = 0;
 14 : Twiddle_W_ex_i = 0;
 15 : Twiddle_W_ex_i = 0;
 16 : Twiddle_W_ex_i = 0;
 17 : Twiddle_W_ex_i = 0;
 18 : Twiddle_W_ex_i = 0;
 19 : Twiddle_W_ex_i = 0;
 20 : Twiddle_W_ex_i = 0;
 21 : Twiddle_W_ex_i = 0;
 22 : Twiddle_W_ex_i = 0;
 23 : Twiddle_W_ex_i = 0;
 24 : Twiddle_W_ex_i = 0;
 25 : Twiddle_W_ex_i = 0;
 26 : Twiddle_W_ex_i = 0;
 27 : Twiddle_W_ex_i = 0;
 28 : Twiddle_W_ex_i = 0;
 29 : Twiddle_W_ex_i = 0;
 30 : Twiddle_W_ex_i = 0;
 31 : Twiddle_W_ex_i = 0;
 32 : Twiddle_W_ex_i = 0;
 33 : Twiddle_W_ex_i = 0;
 34 : Twiddle_W_ex_i = 0;
 35 : Twiddle_W_ex_i = 0;
 36 : Twiddle_W_ex_i = 0;
 37 : Twiddle_W_ex_i = 0;
 38 : Twiddle_W_ex_i = 0;
 39 : Twiddle_W_ex_i = 0;
 40 : Twiddle_W_ex_i = 0;
 41 : Twiddle_W_ex_i = 0;
 42 : Twiddle_W_ex_i = 0;
 43 : Twiddle_W_ex_i = 0;
 44 : Twiddle_W_ex_i = 0;
 45 : Twiddle_W_ex_i = 0;
 46 : Twiddle_W_ex_i = 0;
 47 : Twiddle_W_ex_i = 0;
 48 : Twiddle_W_ex_i = 0;
 49 : Twiddle_W_ex_i = 0;
 50 : Twiddle_W_ex_i = 0;
 51 : Twiddle_W_ex_i = 0;
 52 : Twiddle_W_ex_i = 0;
 53 : Twiddle_W_ex_i = 0;
 54 : Twiddle_W_ex_i = 0;
 55 : Twiddle_W_ex_i = 0;
 56 : Twiddle_W_ex_i = 0;
 57 : Twiddle_W_ex_i = 0;
 58 : Twiddle_W_ex_i = 0;
 59 : Twiddle_W_ex_i = 0;
 60 : Twiddle_W_ex_i = 0;
 61 : Twiddle_W_ex_i = 0;
 62 : Twiddle_W_ex_i = 0;
 63 : Twiddle_W_ex_i = 0;
 64 : Twiddle_W_ex_i = 2;
 65 : Twiddle_W_ex_i = 0;
 66 : Twiddle_W_ex_i = 0;
 67 : Twiddle_W_ex_i = 0;
 68 : Twiddle_W_ex_i = 0;
 69 : Twiddle_W_ex_i = 0;
 70 : Twiddle_W_ex_i = 0;
 71 : Twiddle_W_ex_i = 0;
 72 : Twiddle_W_ex_i = 0;
 73 : Twiddle_W_ex_i = 0;
 74 : Twiddle_W_ex_i = 0;
 75 : Twiddle_W_ex_i = 0;
 76 : Twiddle_W_ex_i = 0;
 77 : Twiddle_W_ex_i = 0;
 78 : Twiddle_W_ex_i = 0;
 79 : Twiddle_W_ex_i = 0;
 80 : Twiddle_W_ex_i = 0;
 81 : Twiddle_W_ex_i = 0;
 82 : Twiddle_W_ex_i = 0;
 83 : Twiddle_W_ex_i = 0;
 84 : Twiddle_W_ex_i = 0;
 85 : Twiddle_W_ex_i = 0;
 86 : Twiddle_W_ex_i = 0;
 87 : Twiddle_W_ex_i = 0;
 88 : Twiddle_W_ex_i = 0;
 89 : Twiddle_W_ex_i = 0;
 90 : Twiddle_W_ex_i = 0;
 91 : Twiddle_W_ex_i = 0;
 92 : Twiddle_W_ex_i = 0;
 93 : Twiddle_W_ex_i = 0;
 94 : Twiddle_W_ex_i = 0;
 95 : Twiddle_W_ex_i = 0;
 96 : Twiddle_W_ex_i = 0;
 97 : Twiddle_W_ex_i = 0;
 98 : Twiddle_W_ex_i = 0;
 99 : Twiddle_W_ex_i = 0;
 100 : Twiddle_W_ex_i = 0;
 101 : Twiddle_W_ex_i = 0;
 102 : Twiddle_W_ex_i = 0;
 103 : Twiddle_W_ex_i = 0;
 104 : Twiddle_W_ex_i = 0;
 105 : Twiddle_W_ex_i = 0;
 106 : Twiddle_W_ex_i = 0;
 107 : Twiddle_W_ex_i = 0;
 108 : Twiddle_W_ex_i = 0;
 109 : Twiddle_W_ex_i = 0;
 110 : Twiddle_W_ex_i = 0;
 111 : Twiddle_W_ex_i = 0;
 112 : Twiddle_W_ex_i = 0;
 113 : Twiddle_W_ex_i = 0;
 114 : Twiddle_W_ex_i = 0;
 115 : Twiddle_W_ex_i = 0;
 116 : Twiddle_W_ex_i = 0;
 117 : Twiddle_W_ex_i = 0;
 118 : Twiddle_W_ex_i = 0;
 119 : Twiddle_W_ex_i = 0;
 120 : Twiddle_W_ex_i = 0;
 121 : Twiddle_W_ex_i = 0;
 122 : Twiddle_W_ex_i = 0;
 123 : Twiddle_W_ex_i = 0;
 124 : Twiddle_W_ex_i = 0;
 125 : Twiddle_W_ex_i = 0;
 126 : Twiddle_W_ex_i = 0;
 127 : Twiddle_W_ex_i = 0;
default : Twiddle_W_ex_i = 0;
endcase
endfunction
endmodule


module TWIDDLE_ST2(k, W_ex_r, W_r, W_ex_i, W_i);
input  [7:0]  k;
output [`W-1:0]  W_r, W_i;
output [1:0]   W_ex_r, W_ex_i;
assign W_r = Twiddle_W_r(k);
assign W_i = Twiddle_W_i(k);
assign W_ex_r = Twiddle_W_ex_r(k);
assign W_ex_i = Twiddle_W_ex_i(k);
function [`W-1:0] Twiddle_W_r;
input  [7:0]  k;
case(k)
 0 : Twiddle_W_r = 32604;
 1 : Twiddle_W_r = 32765;
 2 : Twiddle_W_r = 32758;
 3 : Twiddle_W_r = 32745;
 4 : Twiddle_W_r = 32728;
 5 : Twiddle_W_r = 32706;
 6 : Twiddle_W_r = 32679;
 7 : Twiddle_W_r = 32647;
 8 : Twiddle_W_r = 32610;
 9 : Twiddle_W_r = 32568;
 10 : Twiddle_W_r = 32521;
 11 : Twiddle_W_r = 32469;
 12 : Twiddle_W_r = 32413;
 13 : Twiddle_W_r = 32351;
 14 : Twiddle_W_r = 32285;
 15 : Twiddle_W_r = 32214;
 16 : Twiddle_W_r = 32138;
 17 : Twiddle_W_r = 32057;
 18 : Twiddle_W_r = 31971;
 19 : Twiddle_W_r = 31881;
 20 : Twiddle_W_r = 31785;
 21 : Twiddle_W_r = 31685;
 22 : Twiddle_W_r = 31581;
 23 : Twiddle_W_r = 31471;
 24 : Twiddle_W_r = 31357;
 25 : Twiddle_W_r = 31237;
 26 : Twiddle_W_r = 31114;
 27 : Twiddle_W_r = 30985;
 28 : Twiddle_W_r = 30852;
 29 : Twiddle_W_r = 30714;
 30 : Twiddle_W_r = 30572;
 31 : Twiddle_W_r = 30425;
 32 : Twiddle_W_r = 30273;
 33 : Twiddle_W_r = 30117;
 34 : Twiddle_W_r = 29956;
 35 : Twiddle_W_r = 29791;
 36 : Twiddle_W_r = 29621;
 37 : Twiddle_W_r = 29447;
 38 : Twiddle_W_r = 29269;
 39 : Twiddle_W_r = 29086;
 40 : Twiddle_W_r = 28898;
 41 : Twiddle_W_r = 28707;
 42 : Twiddle_W_r = 28511;
 43 : Twiddle_W_r = 28310;
 44 : Twiddle_W_r = 28106;
 45 : Twiddle_W_r = 27897;
 46 : Twiddle_W_r = 27684;
 47 : Twiddle_W_r = 27466;
 48 : Twiddle_W_r = 27245;
 49 : Twiddle_W_r = 27020;
 50 : Twiddle_W_r = 26790;
 51 : Twiddle_W_r = 26557;
 52 : Twiddle_W_r = 26319;
 53 : Twiddle_W_r = 26077;
 54 : Twiddle_W_r = 25832;
 55 : Twiddle_W_r = 25583;
 56 : Twiddle_W_r = 25330;
 57 : Twiddle_W_r = 25073;
 58 : Twiddle_W_r = 24812;
 59 : Twiddle_W_r = 24547;
 60 : Twiddle_W_r = 24279;
 61 : Twiddle_W_r = 24007;
 62 : Twiddle_W_r = 23732;
 63 : Twiddle_W_r = 23453;
 64 : Twiddle_W_r = 23170;
 65 : Twiddle_W_r = 22884;
 66 : Twiddle_W_r = 22594;
 67 : Twiddle_W_r = 22301;
 68 : Twiddle_W_r = 22005;
 69 : Twiddle_W_r = 21706;
 70 : Twiddle_W_r = 21403;
 71 : Twiddle_W_r = 21097;
 72 : Twiddle_W_r = 20787;
 73 : Twiddle_W_r = 20475;
 74 : Twiddle_W_r = 20159;
 75 : Twiddle_W_r = 19841;
 76 : Twiddle_W_r = 19519;
 77 : Twiddle_W_r = 19195;
 78 : Twiddle_W_r = 18868;
 79 : Twiddle_W_r = 18537;
 80 : Twiddle_W_r = 18204;
 81 : Twiddle_W_r = 17869;
 82 : Twiddle_W_r = 17530;
 83 : Twiddle_W_r = 17189;
 84 : Twiddle_W_r = 16846;
 85 : Twiddle_W_r = 16499;
 86 : Twiddle_W_r = 16151;
 87 : Twiddle_W_r = 15800;
 88 : Twiddle_W_r = 15446;
 89 : Twiddle_W_r = 15090;
 90 : Twiddle_W_r = 14732;
 91 : Twiddle_W_r = 14372;
 92 : Twiddle_W_r = 14010;
 93 : Twiddle_W_r = 13645;
 94 : Twiddle_W_r = 13278;
 95 : Twiddle_W_r = 12910;
 96 : Twiddle_W_r = 12539;
 97 : Twiddle_W_r = 12167;
 98 : Twiddle_W_r = 11793;
 99 : Twiddle_W_r = 11416;
 100 : Twiddle_W_r = 11039;
 101 : Twiddle_W_r = 10659;
 102 : Twiddle_W_r = 10278;
 103 : Twiddle_W_r = 9896;
 104 : Twiddle_W_r = 9512;
 105 : Twiddle_W_r = 9126;
 106 : Twiddle_W_r = 8739;
 107 : Twiddle_W_r = 8351;
 108 : Twiddle_W_r = 7961;
 109 : Twiddle_W_r = 7571;
 110 : Twiddle_W_r = 7179;
 111 : Twiddle_W_r = 6786;
 112 : Twiddle_W_r = 6392;
 113 : Twiddle_W_r = 5997;
 114 : Twiddle_W_r = 5602;
 115 : Twiddle_W_r = 5205;
 116 : Twiddle_W_r = 4808;
 117 : Twiddle_W_r = 4409;
 118 : Twiddle_W_r = 4011;
 119 : Twiddle_W_r = 3611;
 120 : Twiddle_W_r = 3211;
 121 : Twiddle_W_r = 2811;
 122 : Twiddle_W_r = 2410;
 123 : Twiddle_W_r = 2009;
 124 : Twiddle_W_r = 1607;
 125 : Twiddle_W_r = 1206;
 126 : Twiddle_W_r = 804;
 127 : Twiddle_W_r = 402;
 128 : Twiddle_W_r = 0;
 129 : Twiddle_W_r = 65133;
 130 : Twiddle_W_r = 64731;
 131 : Twiddle_W_r = 64329;
 132 : Twiddle_W_r = 63928;
 133 : Twiddle_W_r = 63526;
 134 : Twiddle_W_r = 63125;
 135 : Twiddle_W_r = 62724;
 136 : Twiddle_W_r = 62324;
 137 : Twiddle_W_r = 61924;
 138 : Twiddle_W_r = 61524;
 139 : Twiddle_W_r = 61126;
 140 : Twiddle_W_r = 60727;
 141 : Twiddle_W_r = 60330;
 142 : Twiddle_W_r = 59933;
 143 : Twiddle_W_r = 59538;
 144 : Twiddle_W_r = 59143;
 145 : Twiddle_W_r = 58749;
 146 : Twiddle_W_r = 58356;
 147 : Twiddle_W_r = 57964;
 148 : Twiddle_W_r = 57574;
 149 : Twiddle_W_r = 57184;
 150 : Twiddle_W_r = 56796;
 151 : Twiddle_W_r = 56409;
 152 : Twiddle_W_r = 56023;
 153 : Twiddle_W_r = 55639;
 154 : Twiddle_W_r = 55257;
 155 : Twiddle_W_r = 54876;
 156 : Twiddle_W_r = 54496;
 157 : Twiddle_W_r = 54119;
 158 : Twiddle_W_r = 53742;
 159 : Twiddle_W_r = 53368;
 160 : Twiddle_W_r = 52996;
 161 : Twiddle_W_r = 52625;
 162 : Twiddle_W_r = 52257;
 163 : Twiddle_W_r = 51890;
 164 : Twiddle_W_r = 51525;
 165 : Twiddle_W_r = 51163;
 166 : Twiddle_W_r = 50803;
 167 : Twiddle_W_r = 50445;
 168 : Twiddle_W_r = 50089;
 169 : Twiddle_W_r = 49735;
 170 : Twiddle_W_r = 49384;
 171 : Twiddle_W_r = 49036;
 172 : Twiddle_W_r = 48689;
 173 : Twiddle_W_r = 48346;
 174 : Twiddle_W_r = 48005;
 175 : Twiddle_W_r = 47666;
 176 : Twiddle_W_r = 47331;
 177 : Twiddle_W_r = 46998;
 178 : Twiddle_W_r = 46667;
 179 : Twiddle_W_r = 46340;
 180 : Twiddle_W_r = 46016;
 181 : Twiddle_W_r = 45694;
 182 : Twiddle_W_r = 45376;
 183 : Twiddle_W_r = 45060;
 184 : Twiddle_W_r = 44748;
 185 : Twiddle_W_r = 44438;
 186 : Twiddle_W_r = 44132;
 187 : Twiddle_W_r = 43829;
 188 : Twiddle_W_r = 43530;
 189 : Twiddle_W_r = 43234;
 190 : Twiddle_W_r = 42941;
 191 : Twiddle_W_r = 42651;
 192 : Twiddle_W_r = 42365;
 193 : Twiddle_W_r = 42082;
 194 : Twiddle_W_r = 41803;
 195 : Twiddle_W_r = 41528;
 196 : Twiddle_W_r = 41256;
 197 : Twiddle_W_r = 40988;
 198 : Twiddle_W_r = 40723;
 199 : Twiddle_W_r = 40462;
 200 : Twiddle_W_r = 40205;
 201 : Twiddle_W_r = 39952;
 202 : Twiddle_W_r = 39703;
 203 : Twiddle_W_r = 39458;
 204 : Twiddle_W_r = 39216;
 205 : Twiddle_W_r = 38978;
 206 : Twiddle_W_r = 38745;
 207 : Twiddle_W_r = 38515;
 208 : Twiddle_W_r = 38290;
 209 : Twiddle_W_r = 38069;
 210 : Twiddle_W_r = 37851;
 211 : Twiddle_W_r = 37638;
 212 : Twiddle_W_r = 37429;
 213 : Twiddle_W_r = 37225;
 214 : Twiddle_W_r = 37024;
 215 : Twiddle_W_r = 36828;
 216 : Twiddle_W_r = 36637;
 217 : Twiddle_W_r = 36449;
 218 : Twiddle_W_r = 36266;
 219 : Twiddle_W_r = 36088;
 220 : Twiddle_W_r = 35914;
 221 : Twiddle_W_r = 35744;
 222 : Twiddle_W_r = 35579;
 223 : Twiddle_W_r = 35418;
 224 : Twiddle_W_r = 35262;
 225 : Twiddle_W_r = 35110;
 226 : Twiddle_W_r = 34963;
 227 : Twiddle_W_r = 34821;
 228 : Twiddle_W_r = 34683;
 229 : Twiddle_W_r = 34550;
 230 : Twiddle_W_r = 34421;
 231 : Twiddle_W_r = 34298;
 232 : Twiddle_W_r = 34178;
 233 : Twiddle_W_r = 34064;
 234 : Twiddle_W_r = 33954;
 235 : Twiddle_W_r = 33850;
 236 : Twiddle_W_r = 33750;
 237 : Twiddle_W_r = 33654;
 238 : Twiddle_W_r = 33564;
 239 : Twiddle_W_r = 33478;
 240 : Twiddle_W_r = 33397;
 241 : Twiddle_W_r = 33321;
 242 : Twiddle_W_r = 33250;
 243 : Twiddle_W_r = 33184;
 244 : Twiddle_W_r = 33122;
 245 : Twiddle_W_r = 33066;
 246 : Twiddle_W_r = 33014;
 247 : Twiddle_W_r = 32967;
 248 : Twiddle_W_r = 32925;
 249 : Twiddle_W_r = 32888;
 250 : Twiddle_W_r = 32856;
 251 : Twiddle_W_r = 32829;
 252 : Twiddle_W_r = 32807;
 253 : Twiddle_W_r = 32790;
 254 : Twiddle_W_r = 32777;
 255 : Twiddle_W_r = 32770;
default : Twiddle_W_r = 0;
endcase
endfunction
function [`W-1:0] Twiddle_W_i;
input  [7:0]  k;
case(k)
 0 : Twiddle_W_i = 0;
 1 : Twiddle_W_i = 65133;
 2 : Twiddle_W_i = 64731;
 3 : Twiddle_W_i = 64329;
 4 : Twiddle_W_i = 63928;
 5 : Twiddle_W_i = 63526;
 6 : Twiddle_W_i = 63125;
 7 : Twiddle_W_i = 62724;
 8 : Twiddle_W_i = 62324;
 9 : Twiddle_W_i = 61924;
 10 : Twiddle_W_i = 61524;
 11 : Twiddle_W_i = 61126;
 12 : Twiddle_W_i = 60727;
 13 : Twiddle_W_i = 60330;
 14 : Twiddle_W_i = 59933;
 15 : Twiddle_W_i = 59538;
 16 : Twiddle_W_i = 59143;
 17 : Twiddle_W_i = 58749;
 18 : Twiddle_W_i = 58356;
 19 : Twiddle_W_i = 57964;
 20 : Twiddle_W_i = 57574;
 21 : Twiddle_W_i = 57184;
 22 : Twiddle_W_i = 56796;
 23 : Twiddle_W_i = 56409;
 24 : Twiddle_W_i = 56023;
 25 : Twiddle_W_i = 55639;
 26 : Twiddle_W_i = 55257;
 27 : Twiddle_W_i = 54876;
 28 : Twiddle_W_i = 54496;
 29 : Twiddle_W_i = 54119;
 30 : Twiddle_W_i = 53742;
 31 : Twiddle_W_i = 53368;
 32 : Twiddle_W_i = 52996;
 33 : Twiddle_W_i = 52625;
 34 : Twiddle_W_i = 52257;
 35 : Twiddle_W_i = 51890;
 36 : Twiddle_W_i = 51525;
 37 : Twiddle_W_i = 51163;
 38 : Twiddle_W_i = 50803;
 39 : Twiddle_W_i = 50445;
 40 : Twiddle_W_i = 50089;
 41 : Twiddle_W_i = 49735;
 42 : Twiddle_W_i = 49384;
 43 : Twiddle_W_i = 49036;
 44 : Twiddle_W_i = 48689;
 45 : Twiddle_W_i = 48346;
 46 : Twiddle_W_i = 48005;
 47 : Twiddle_W_i = 47666;
 48 : Twiddle_W_i = 47331;
 49 : Twiddle_W_i = 46998;
 50 : Twiddle_W_i = 46667;
 51 : Twiddle_W_i = 46340;
 52 : Twiddle_W_i = 46016;
 53 : Twiddle_W_i = 45694;
 54 : Twiddle_W_i = 45376;
 55 : Twiddle_W_i = 45060;
 56 : Twiddle_W_i = 44748;
 57 : Twiddle_W_i = 44438;
 58 : Twiddle_W_i = 44132;
 59 : Twiddle_W_i = 43829;
 60 : Twiddle_W_i = 43530;
 61 : Twiddle_W_i = 43234;
 62 : Twiddle_W_i = 42941;
 63 : Twiddle_W_i = 42651;
 64 : Twiddle_W_i = 42365;
 65 : Twiddle_W_i = 42082;
 66 : Twiddle_W_i = 41803;
 67 : Twiddle_W_i = 41528;
 68 : Twiddle_W_i = 41256;
 69 : Twiddle_W_i = 40988;
 70 : Twiddle_W_i = 40723;
 71 : Twiddle_W_i = 40462;
 72 : Twiddle_W_i = 40205;
 73 : Twiddle_W_i = 39952;
 74 : Twiddle_W_i = 39703;
 75 : Twiddle_W_i = 39458;
 76 : Twiddle_W_i = 39216;
 77 : Twiddle_W_i = 38978;
 78 : Twiddle_W_i = 38745;
 79 : Twiddle_W_i = 38515;
 80 : Twiddle_W_i = 38290;
 81 : Twiddle_W_i = 38069;
 82 : Twiddle_W_i = 37851;
 83 : Twiddle_W_i = 37638;
 84 : Twiddle_W_i = 37429;
 85 : Twiddle_W_i = 37225;
 86 : Twiddle_W_i = 37024;
 87 : Twiddle_W_i = 36828;
 88 : Twiddle_W_i = 36637;
 89 : Twiddle_W_i = 36449;
 90 : Twiddle_W_i = 36266;
 91 : Twiddle_W_i = 36088;
 92 : Twiddle_W_i = 35914;
 93 : Twiddle_W_i = 35744;
 94 : Twiddle_W_i = 35579;
 95 : Twiddle_W_i = 35418;
 96 : Twiddle_W_i = 35262;
 97 : Twiddle_W_i = 35110;
 98 : Twiddle_W_i = 34963;
 99 : Twiddle_W_i = 34821;
 100 : Twiddle_W_i = 34683;
 101 : Twiddle_W_i = 34550;
 102 : Twiddle_W_i = 34421;
 103 : Twiddle_W_i = 34298;
 104 : Twiddle_W_i = 34178;
 105 : Twiddle_W_i = 34064;
 106 : Twiddle_W_i = 33954;
 107 : Twiddle_W_i = 33850;
 108 : Twiddle_W_i = 33750;
 109 : Twiddle_W_i = 33654;
 110 : Twiddle_W_i = 33564;
 111 : Twiddle_W_i = 33478;
 112 : Twiddle_W_i = 33397;
 113 : Twiddle_W_i = 33321;
 114 : Twiddle_W_i = 33250;
 115 : Twiddle_W_i = 33184;
 116 : Twiddle_W_i = 33122;
 117 : Twiddle_W_i = 33066;
 118 : Twiddle_W_i = 33014;
 119 : Twiddle_W_i = 32967;
 120 : Twiddle_W_i = 32925;
 121 : Twiddle_W_i = 32888;
 122 : Twiddle_W_i = 32856;
 123 : Twiddle_W_i = 32829;
 124 : Twiddle_W_i = 32807;
 125 : Twiddle_W_i = 32790;
 126 : Twiddle_W_i = 32777;
 127 : Twiddle_W_i = 32770;
 128 : Twiddle_W_i = 32931;
 129 : Twiddle_W_i = 32770;
 130 : Twiddle_W_i = 32777;
 131 : Twiddle_W_i = 32790;
 132 : Twiddle_W_i = 32807;
 133 : Twiddle_W_i = 32829;
 134 : Twiddle_W_i = 32856;
 135 : Twiddle_W_i = 32888;
 136 : Twiddle_W_i = 32925;
 137 : Twiddle_W_i = 32967;
 138 : Twiddle_W_i = 33014;
 139 : Twiddle_W_i = 33066;
 140 : Twiddle_W_i = 33122;
 141 : Twiddle_W_i = 33184;
 142 : Twiddle_W_i = 33250;
 143 : Twiddle_W_i = 33321;
 144 : Twiddle_W_i = 33397;
 145 : Twiddle_W_i = 33478;
 146 : Twiddle_W_i = 33564;
 147 : Twiddle_W_i = 33654;
 148 : Twiddle_W_i = 33750;
 149 : Twiddle_W_i = 33850;
 150 : Twiddle_W_i = 33954;
 151 : Twiddle_W_i = 34064;
 152 : Twiddle_W_i = 34178;
 153 : Twiddle_W_i = 34298;
 154 : Twiddle_W_i = 34421;
 155 : Twiddle_W_i = 34550;
 156 : Twiddle_W_i = 34683;
 157 : Twiddle_W_i = 34821;
 158 : Twiddle_W_i = 34963;
 159 : Twiddle_W_i = 35110;
 160 : Twiddle_W_i = 35262;
 161 : Twiddle_W_i = 35418;
 162 : Twiddle_W_i = 35579;
 163 : Twiddle_W_i = 35744;
 164 : Twiddle_W_i = 35914;
 165 : Twiddle_W_i = 36088;
 166 : Twiddle_W_i = 36266;
 167 : Twiddle_W_i = 36449;
 168 : Twiddle_W_i = 36637;
 169 : Twiddle_W_i = 36828;
 170 : Twiddle_W_i = 37024;
 171 : Twiddle_W_i = 37225;
 172 : Twiddle_W_i = 37429;
 173 : Twiddle_W_i = 37638;
 174 : Twiddle_W_i = 37851;
 175 : Twiddle_W_i = 38069;
 176 : Twiddle_W_i = 38290;
 177 : Twiddle_W_i = 38515;
 178 : Twiddle_W_i = 38745;
 179 : Twiddle_W_i = 38978;
 180 : Twiddle_W_i = 39216;
 181 : Twiddle_W_i = 39458;
 182 : Twiddle_W_i = 39703;
 183 : Twiddle_W_i = 39952;
 184 : Twiddle_W_i = 40205;
 185 : Twiddle_W_i = 40462;
 186 : Twiddle_W_i = 40723;
 187 : Twiddle_W_i = 40988;
 188 : Twiddle_W_i = 41256;
 189 : Twiddle_W_i = 41528;
 190 : Twiddle_W_i = 41803;
 191 : Twiddle_W_i = 42082;
 192 : Twiddle_W_i = 42365;
 193 : Twiddle_W_i = 42651;
 194 : Twiddle_W_i = 42941;
 195 : Twiddle_W_i = 43234;
 196 : Twiddle_W_i = 43530;
 197 : Twiddle_W_i = 43829;
 198 : Twiddle_W_i = 44132;
 199 : Twiddle_W_i = 44438;
 200 : Twiddle_W_i = 44748;
 201 : Twiddle_W_i = 45060;
 202 : Twiddle_W_i = 45376;
 203 : Twiddle_W_i = 45694;
 204 : Twiddle_W_i = 46016;
 205 : Twiddle_W_i = 46340;
 206 : Twiddle_W_i = 46667;
 207 : Twiddle_W_i = 46998;
 208 : Twiddle_W_i = 47331;
 209 : Twiddle_W_i = 47666;
 210 : Twiddle_W_i = 48005;
 211 : Twiddle_W_i = 48346;
 212 : Twiddle_W_i = 48689;
 213 : Twiddle_W_i = 49036;
 214 : Twiddle_W_i = 49384;
 215 : Twiddle_W_i = 49735;
 216 : Twiddle_W_i = 50089;
 217 : Twiddle_W_i = 50445;
 218 : Twiddle_W_i = 50803;
 219 : Twiddle_W_i = 51163;
 220 : Twiddle_W_i = 51525;
 221 : Twiddle_W_i = 51890;
 222 : Twiddle_W_i = 52257;
 223 : Twiddle_W_i = 52625;
 224 : Twiddle_W_i = 52996;
 225 : Twiddle_W_i = 53368;
 226 : Twiddle_W_i = 53742;
 227 : Twiddle_W_i = 54119;
 228 : Twiddle_W_i = 54496;
 229 : Twiddle_W_i = 54876;
 230 : Twiddle_W_i = 55257;
 231 : Twiddle_W_i = 55639;
 232 : Twiddle_W_i = 56023;
 233 : Twiddle_W_i = 56409;
 234 : Twiddle_W_i = 56796;
 235 : Twiddle_W_i = 57184;
 236 : Twiddle_W_i = 57574;
 237 : Twiddle_W_i = 57964;
 238 : Twiddle_W_i = 58356;
 239 : Twiddle_W_i = 58749;
 240 : Twiddle_W_i = 59143;
 241 : Twiddle_W_i = 59538;
 242 : Twiddle_W_i = 59933;
 243 : Twiddle_W_i = 60330;
 244 : Twiddle_W_i = 60727;
 245 : Twiddle_W_i = 61126;
 246 : Twiddle_W_i = 61524;
 247 : Twiddle_W_i = 61924;
 248 : Twiddle_W_i = 62324;
 249 : Twiddle_W_i = 62724;
 250 : Twiddle_W_i = 63125;
 251 : Twiddle_W_i = 63526;
 252 : Twiddle_W_i = 63928;
 253 : Twiddle_W_i = 64329;
 254 : Twiddle_W_i = 64731;
 255 : Twiddle_W_i = 65133;
default : Twiddle_W_i = 0;
endcase
endfunction
function [1:0] Twiddle_W_ex_r;
input  [7:0]  k;
case(k)
 0 : Twiddle_W_ex_r = 1;
 1 : Twiddle_W_ex_r = 0;
 2 : Twiddle_W_ex_r = 0;
 3 : Twiddle_W_ex_r = 0;
 4 : Twiddle_W_ex_r = 0;
 5 : Twiddle_W_ex_r = 0;
 6 : Twiddle_W_ex_r = 0;
 7 : Twiddle_W_ex_r = 0;
 8 : Twiddle_W_ex_r = 0;
 9 : Twiddle_W_ex_r = 0;
 10 : Twiddle_W_ex_r = 0;
 11 : Twiddle_W_ex_r = 0;
 12 : Twiddle_W_ex_r = 0;
 13 : Twiddle_W_ex_r = 0;
 14 : Twiddle_W_ex_r = 0;
 15 : Twiddle_W_ex_r = 0;
 16 : Twiddle_W_ex_r = 0;
 17 : Twiddle_W_ex_r = 0;
 18 : Twiddle_W_ex_r = 0;
 19 : Twiddle_W_ex_r = 0;
 20 : Twiddle_W_ex_r = 0;
 21 : Twiddle_W_ex_r = 0;
 22 : Twiddle_W_ex_r = 0;
 23 : Twiddle_W_ex_r = 0;
 24 : Twiddle_W_ex_r = 0;
 25 : Twiddle_W_ex_r = 0;
 26 : Twiddle_W_ex_r = 0;
 27 : Twiddle_W_ex_r = 0;
 28 : Twiddle_W_ex_r = 0;
 29 : Twiddle_W_ex_r = 0;
 30 : Twiddle_W_ex_r = 0;
 31 : Twiddle_W_ex_r = 0;
 32 : Twiddle_W_ex_r = 0;
 33 : Twiddle_W_ex_r = 0;
 34 : Twiddle_W_ex_r = 0;
 35 : Twiddle_W_ex_r = 0;
 36 : Twiddle_W_ex_r = 0;
 37 : Twiddle_W_ex_r = 0;
 38 : Twiddle_W_ex_r = 0;
 39 : Twiddle_W_ex_r = 0;
 40 : Twiddle_W_ex_r = 0;
 41 : Twiddle_W_ex_r = 0;
 42 : Twiddle_W_ex_r = 0;
 43 : Twiddle_W_ex_r = 0;
 44 : Twiddle_W_ex_r = 0;
 45 : Twiddle_W_ex_r = 0;
 46 : Twiddle_W_ex_r = 0;
 47 : Twiddle_W_ex_r = 0;
 48 : Twiddle_W_ex_r = 0;
 49 : Twiddle_W_ex_r = 0;
 50 : Twiddle_W_ex_r = 0;
 51 : Twiddle_W_ex_r = 0;
 52 : Twiddle_W_ex_r = 0;
 53 : Twiddle_W_ex_r = 0;
 54 : Twiddle_W_ex_r = 0;
 55 : Twiddle_W_ex_r = 0;
 56 : Twiddle_W_ex_r = 0;
 57 : Twiddle_W_ex_r = 0;
 58 : Twiddle_W_ex_r = 0;
 59 : Twiddle_W_ex_r = 0;
 60 : Twiddle_W_ex_r = 0;
 61 : Twiddle_W_ex_r = 0;
 62 : Twiddle_W_ex_r = 0;
 63 : Twiddle_W_ex_r = 0;
 64 : Twiddle_W_ex_r = 0;
 65 : Twiddle_W_ex_r = 0;
 66 : Twiddle_W_ex_r = 0;
 67 : Twiddle_W_ex_r = 0;
 68 : Twiddle_W_ex_r = 0;
 69 : Twiddle_W_ex_r = 0;
 70 : Twiddle_W_ex_r = 0;
 71 : Twiddle_W_ex_r = 0;
 72 : Twiddle_W_ex_r = 0;
 73 : Twiddle_W_ex_r = 0;
 74 : Twiddle_W_ex_r = 0;
 75 : Twiddle_W_ex_r = 0;
 76 : Twiddle_W_ex_r = 0;
 77 : Twiddle_W_ex_r = 0;
 78 : Twiddle_W_ex_r = 0;
 79 : Twiddle_W_ex_r = 0;
 80 : Twiddle_W_ex_r = 0;
 81 : Twiddle_W_ex_r = 0;
 82 : Twiddle_W_ex_r = 0;
 83 : Twiddle_W_ex_r = 0;
 84 : Twiddle_W_ex_r = 0;
 85 : Twiddle_W_ex_r = 0;
 86 : Twiddle_W_ex_r = 0;
 87 : Twiddle_W_ex_r = 0;
 88 : Twiddle_W_ex_r = 0;
 89 : Twiddle_W_ex_r = 0;
 90 : Twiddle_W_ex_r = 0;
 91 : Twiddle_W_ex_r = 0;
 92 : Twiddle_W_ex_r = 0;
 93 : Twiddle_W_ex_r = 0;
 94 : Twiddle_W_ex_r = 0;
 95 : Twiddle_W_ex_r = 0;
 96 : Twiddle_W_ex_r = 0;
 97 : Twiddle_W_ex_r = 0;
 98 : Twiddle_W_ex_r = 0;
 99 : Twiddle_W_ex_r = 0;
 100 : Twiddle_W_ex_r = 0;
 101 : Twiddle_W_ex_r = 0;
 102 : Twiddle_W_ex_r = 0;
 103 : Twiddle_W_ex_r = 0;
 104 : Twiddle_W_ex_r = 0;
 105 : Twiddle_W_ex_r = 0;
 106 : Twiddle_W_ex_r = 0;
 107 : Twiddle_W_ex_r = 0;
 108 : Twiddle_W_ex_r = 0;
 109 : Twiddle_W_ex_r = 0;
 110 : Twiddle_W_ex_r = 0;
 111 : Twiddle_W_ex_r = 0;
 112 : Twiddle_W_ex_r = 0;
 113 : Twiddle_W_ex_r = 0;
 114 : Twiddle_W_ex_r = 0;
 115 : Twiddle_W_ex_r = 0;
 116 : Twiddle_W_ex_r = 0;
 117 : Twiddle_W_ex_r = 0;
 118 : Twiddle_W_ex_r = 0;
 119 : Twiddle_W_ex_r = 0;
 120 : Twiddle_W_ex_r = 0;
 121 : Twiddle_W_ex_r = 0;
 122 : Twiddle_W_ex_r = 0;
 123 : Twiddle_W_ex_r = 0;
 124 : Twiddle_W_ex_r = 0;
 125 : Twiddle_W_ex_r = 0;
 126 : Twiddle_W_ex_r = 0;
 127 : Twiddle_W_ex_r = 0;
 128 : Twiddle_W_ex_r = 0;
 129 : Twiddle_W_ex_r = 0;
 130 : Twiddle_W_ex_r = 0;
 131 : Twiddle_W_ex_r = 0;
 132 : Twiddle_W_ex_r = 0;
 133 : Twiddle_W_ex_r = 0;
 134 : Twiddle_W_ex_r = 0;
 135 : Twiddle_W_ex_r = 0;
 136 : Twiddle_W_ex_r = 0;
 137 : Twiddle_W_ex_r = 0;
 138 : Twiddle_W_ex_r = 0;
 139 : Twiddle_W_ex_r = 0;
 140 : Twiddle_W_ex_r = 0;
 141 : Twiddle_W_ex_r = 0;
 142 : Twiddle_W_ex_r = 0;
 143 : Twiddle_W_ex_r = 0;
 144 : Twiddle_W_ex_r = 0;
 145 : Twiddle_W_ex_r = 0;
 146 : Twiddle_W_ex_r = 0;
 147 : Twiddle_W_ex_r = 0;
 148 : Twiddle_W_ex_r = 0;
 149 : Twiddle_W_ex_r = 0;
 150 : Twiddle_W_ex_r = 0;
 151 : Twiddle_W_ex_r = 0;
 152 : Twiddle_W_ex_r = 0;
 153 : Twiddle_W_ex_r = 0;
 154 : Twiddle_W_ex_r = 0;
 155 : Twiddle_W_ex_r = 0;
 156 : Twiddle_W_ex_r = 0;
 157 : Twiddle_W_ex_r = 0;
 158 : Twiddle_W_ex_r = 0;
 159 : Twiddle_W_ex_r = 0;
 160 : Twiddle_W_ex_r = 0;
 161 : Twiddle_W_ex_r = 0;
 162 : Twiddle_W_ex_r = 0;
 163 : Twiddle_W_ex_r = 0;
 164 : Twiddle_W_ex_r = 0;
 165 : Twiddle_W_ex_r = 0;
 166 : Twiddle_W_ex_r = 0;
 167 : Twiddle_W_ex_r = 0;
 168 : Twiddle_W_ex_r = 0;
 169 : Twiddle_W_ex_r = 0;
 170 : Twiddle_W_ex_r = 0;
 171 : Twiddle_W_ex_r = 0;
 172 : Twiddle_W_ex_r = 0;
 173 : Twiddle_W_ex_r = 0;
 174 : Twiddle_W_ex_r = 0;
 175 : Twiddle_W_ex_r = 0;
 176 : Twiddle_W_ex_r = 0;
 177 : Twiddle_W_ex_r = 0;
 178 : Twiddle_W_ex_r = 0;
 179 : Twiddle_W_ex_r = 0;
 180 : Twiddle_W_ex_r = 0;
 181 : Twiddle_W_ex_r = 0;
 182 : Twiddle_W_ex_r = 0;
 183 : Twiddle_W_ex_r = 0;
 184 : Twiddle_W_ex_r = 0;
 185 : Twiddle_W_ex_r = 0;
 186 : Twiddle_W_ex_r = 0;
 187 : Twiddle_W_ex_r = 0;
 188 : Twiddle_W_ex_r = 0;
 189 : Twiddle_W_ex_r = 0;
 190 : Twiddle_W_ex_r = 0;
 191 : Twiddle_W_ex_r = 0;
 192 : Twiddle_W_ex_r = 0;
 193 : Twiddle_W_ex_r = 0;
 194 : Twiddle_W_ex_r = 0;
 195 : Twiddle_W_ex_r = 0;
 196 : Twiddle_W_ex_r = 0;
 197 : Twiddle_W_ex_r = 0;
 198 : Twiddle_W_ex_r = 0;
 199 : Twiddle_W_ex_r = 0;
 200 : Twiddle_W_ex_r = 0;
 201 : Twiddle_W_ex_r = 0;
 202 : Twiddle_W_ex_r = 0;
 203 : Twiddle_W_ex_r = 0;
 204 : Twiddle_W_ex_r = 0;
 205 : Twiddle_W_ex_r = 0;
 206 : Twiddle_W_ex_r = 0;
 207 : Twiddle_W_ex_r = 0;
 208 : Twiddle_W_ex_r = 0;
 209 : Twiddle_W_ex_r = 0;
 210 : Twiddle_W_ex_r = 0;
 211 : Twiddle_W_ex_r = 0;
 212 : Twiddle_W_ex_r = 0;
 213 : Twiddle_W_ex_r = 0;
 214 : Twiddle_W_ex_r = 0;
 215 : Twiddle_W_ex_r = 0;
 216 : Twiddle_W_ex_r = 0;
 217 : Twiddle_W_ex_r = 0;
 218 : Twiddle_W_ex_r = 0;
 219 : Twiddle_W_ex_r = 0;
 220 : Twiddle_W_ex_r = 0;
 221 : Twiddle_W_ex_r = 0;
 222 : Twiddle_W_ex_r = 0;
 223 : Twiddle_W_ex_r = 0;
 224 : Twiddle_W_ex_r = 0;
 225 : Twiddle_W_ex_r = 0;
 226 : Twiddle_W_ex_r = 0;
 227 : Twiddle_W_ex_r = 0;
 228 : Twiddle_W_ex_r = 0;
 229 : Twiddle_W_ex_r = 0;
 230 : Twiddle_W_ex_r = 0;
 231 : Twiddle_W_ex_r = 0;
 232 : Twiddle_W_ex_r = 0;
 233 : Twiddle_W_ex_r = 0;
 234 : Twiddle_W_ex_r = 0;
 235 : Twiddle_W_ex_r = 0;
 236 : Twiddle_W_ex_r = 0;
 237 : Twiddle_W_ex_r = 0;
 238 : Twiddle_W_ex_r = 0;
 239 : Twiddle_W_ex_r = 0;
 240 : Twiddle_W_ex_r = 0;
 241 : Twiddle_W_ex_r = 0;
 242 : Twiddle_W_ex_r = 0;
 243 : Twiddle_W_ex_r = 0;
 244 : Twiddle_W_ex_r = 0;
 245 : Twiddle_W_ex_r = 0;
 246 : Twiddle_W_ex_r = 0;
 247 : Twiddle_W_ex_r = 0;
 248 : Twiddle_W_ex_r = 0;
 249 : Twiddle_W_ex_r = 0;
 250 : Twiddle_W_ex_r = 0;
 251 : Twiddle_W_ex_r = 0;
 252 : Twiddle_W_ex_r = 0;
 253 : Twiddle_W_ex_r = 0;
 254 : Twiddle_W_ex_r = 0;
 255 : Twiddle_W_ex_r = 0;
default : Twiddle_W_ex_r = 0;
endcase
endfunction
function [1:0] Twiddle_W_ex_i;
input  [7:0]  k;
case(k)
 0 : Twiddle_W_ex_i = 0;
 1 : Twiddle_W_ex_i = 0;
 2 : Twiddle_W_ex_i = 0;
 3 : Twiddle_W_ex_i = 0;
 4 : Twiddle_W_ex_i = 0;
 5 : Twiddle_W_ex_i = 0;
 6 : Twiddle_W_ex_i = 0;
 7 : Twiddle_W_ex_i = 0;
 8 : Twiddle_W_ex_i = 0;
 9 : Twiddle_W_ex_i = 0;
 10 : Twiddle_W_ex_i = 0;
 11 : Twiddle_W_ex_i = 0;
 12 : Twiddle_W_ex_i = 0;
 13 : Twiddle_W_ex_i = 0;
 14 : Twiddle_W_ex_i = 0;
 15 : Twiddle_W_ex_i = 0;
 16 : Twiddle_W_ex_i = 0;
 17 : Twiddle_W_ex_i = 0;
 18 : Twiddle_W_ex_i = 0;
 19 : Twiddle_W_ex_i = 0;
 20 : Twiddle_W_ex_i = 0;
 21 : Twiddle_W_ex_i = 0;
 22 : Twiddle_W_ex_i = 0;
 23 : Twiddle_W_ex_i = 0;
 24 : Twiddle_W_ex_i = 0;
 25 : Twiddle_W_ex_i = 0;
 26 : Twiddle_W_ex_i = 0;
 27 : Twiddle_W_ex_i = 0;
 28 : Twiddle_W_ex_i = 0;
 29 : Twiddle_W_ex_i = 0;
 30 : Twiddle_W_ex_i = 0;
 31 : Twiddle_W_ex_i = 0;
 32 : Twiddle_W_ex_i = 0;
 33 : Twiddle_W_ex_i = 0;
 34 : Twiddle_W_ex_i = 0;
 35 : Twiddle_W_ex_i = 0;
 36 : Twiddle_W_ex_i = 0;
 37 : Twiddle_W_ex_i = 0;
 38 : Twiddle_W_ex_i = 0;
 39 : Twiddle_W_ex_i = 0;
 40 : Twiddle_W_ex_i = 0;
 41 : Twiddle_W_ex_i = 0;
 42 : Twiddle_W_ex_i = 0;
 43 : Twiddle_W_ex_i = 0;
 44 : Twiddle_W_ex_i = 0;
 45 : Twiddle_W_ex_i = 0;
 46 : Twiddle_W_ex_i = 0;
 47 : Twiddle_W_ex_i = 0;
 48 : Twiddle_W_ex_i = 0;
 49 : Twiddle_W_ex_i = 0;
 50 : Twiddle_W_ex_i = 0;
 51 : Twiddle_W_ex_i = 0;
 52 : Twiddle_W_ex_i = 0;
 53 : Twiddle_W_ex_i = 0;
 54 : Twiddle_W_ex_i = 0;
 55 : Twiddle_W_ex_i = 0;
 56 : Twiddle_W_ex_i = 0;
 57 : Twiddle_W_ex_i = 0;
 58 : Twiddle_W_ex_i = 0;
 59 : Twiddle_W_ex_i = 0;
 60 : Twiddle_W_ex_i = 0;
 61 : Twiddle_W_ex_i = 0;
 62 : Twiddle_W_ex_i = 0;
 63 : Twiddle_W_ex_i = 0;
 64 : Twiddle_W_ex_i = 0;
 65 : Twiddle_W_ex_i = 0;
 66 : Twiddle_W_ex_i = 0;
 67 : Twiddle_W_ex_i = 0;
 68 : Twiddle_W_ex_i = 0;
 69 : Twiddle_W_ex_i = 0;
 70 : Twiddle_W_ex_i = 0;
 71 : Twiddle_W_ex_i = 0;
 72 : Twiddle_W_ex_i = 0;
 73 : Twiddle_W_ex_i = 0;
 74 : Twiddle_W_ex_i = 0;
 75 : Twiddle_W_ex_i = 0;
 76 : Twiddle_W_ex_i = 0;
 77 : Twiddle_W_ex_i = 0;
 78 : Twiddle_W_ex_i = 0;
 79 : Twiddle_W_ex_i = 0;
 80 : Twiddle_W_ex_i = 0;
 81 : Twiddle_W_ex_i = 0;
 82 : Twiddle_W_ex_i = 0;
 83 : Twiddle_W_ex_i = 0;
 84 : Twiddle_W_ex_i = 0;
 85 : Twiddle_W_ex_i = 0;
 86 : Twiddle_W_ex_i = 0;
 87 : Twiddle_W_ex_i = 0;
 88 : Twiddle_W_ex_i = 0;
 89 : Twiddle_W_ex_i = 0;
 90 : Twiddle_W_ex_i = 0;
 91 : Twiddle_W_ex_i = 0;
 92 : Twiddle_W_ex_i = 0;
 93 : Twiddle_W_ex_i = 0;
 94 : Twiddle_W_ex_i = 0;
 95 : Twiddle_W_ex_i = 0;
 96 : Twiddle_W_ex_i = 0;
 97 : Twiddle_W_ex_i = 0;
 98 : Twiddle_W_ex_i = 0;
 99 : Twiddle_W_ex_i = 0;
 100 : Twiddle_W_ex_i = 0;
 101 : Twiddle_W_ex_i = 0;
 102 : Twiddle_W_ex_i = 0;
 103 : Twiddle_W_ex_i = 0;
 104 : Twiddle_W_ex_i = 0;
 105 : Twiddle_W_ex_i = 0;
 106 : Twiddle_W_ex_i = 0;
 107 : Twiddle_W_ex_i = 0;
 108 : Twiddle_W_ex_i = 0;
 109 : Twiddle_W_ex_i = 0;
 110 : Twiddle_W_ex_i = 0;
 111 : Twiddle_W_ex_i = 0;
 112 : Twiddle_W_ex_i = 0;
 113 : Twiddle_W_ex_i = 0;
 114 : Twiddle_W_ex_i = 0;
 115 : Twiddle_W_ex_i = 0;
 116 : Twiddle_W_ex_i = 0;
 117 : Twiddle_W_ex_i = 0;
 118 : Twiddle_W_ex_i = 0;
 119 : Twiddle_W_ex_i = 0;
 120 : Twiddle_W_ex_i = 0;
 121 : Twiddle_W_ex_i = 0;
 122 : Twiddle_W_ex_i = 0;
 123 : Twiddle_W_ex_i = 0;
 124 : Twiddle_W_ex_i = 0;
 125 : Twiddle_W_ex_i = 0;
 126 : Twiddle_W_ex_i = 0;
 127 : Twiddle_W_ex_i = 0;
 128 : Twiddle_W_ex_i = 2;
 129 : Twiddle_W_ex_i = 0;
 130 : Twiddle_W_ex_i = 0;
 131 : Twiddle_W_ex_i = 0;
 132 : Twiddle_W_ex_i = 0;
 133 : Twiddle_W_ex_i = 0;
 134 : Twiddle_W_ex_i = 0;
 135 : Twiddle_W_ex_i = 0;
 136 : Twiddle_W_ex_i = 0;
 137 : Twiddle_W_ex_i = 0;
 138 : Twiddle_W_ex_i = 0;
 139 : Twiddle_W_ex_i = 0;
 140 : Twiddle_W_ex_i = 0;
 141 : Twiddle_W_ex_i = 0;
 142 : Twiddle_W_ex_i = 0;
 143 : Twiddle_W_ex_i = 0;
 144 : Twiddle_W_ex_i = 0;
 145 : Twiddle_W_ex_i = 0;
 146 : Twiddle_W_ex_i = 0;
 147 : Twiddle_W_ex_i = 0;
 148 : Twiddle_W_ex_i = 0;
 149 : Twiddle_W_ex_i = 0;
 150 : Twiddle_W_ex_i = 0;
 151 : Twiddle_W_ex_i = 0;
 152 : Twiddle_W_ex_i = 0;
 153 : Twiddle_W_ex_i = 0;
 154 : Twiddle_W_ex_i = 0;
 155 : Twiddle_W_ex_i = 0;
 156 : Twiddle_W_ex_i = 0;
 157 : Twiddle_W_ex_i = 0;
 158 : Twiddle_W_ex_i = 0;
 159 : Twiddle_W_ex_i = 0;
 160 : Twiddle_W_ex_i = 0;
 161 : Twiddle_W_ex_i = 0;
 162 : Twiddle_W_ex_i = 0;
 163 : Twiddle_W_ex_i = 0;
 164 : Twiddle_W_ex_i = 0;
 165 : Twiddle_W_ex_i = 0;
 166 : Twiddle_W_ex_i = 0;
 167 : Twiddle_W_ex_i = 0;
 168 : Twiddle_W_ex_i = 0;
 169 : Twiddle_W_ex_i = 0;
 170 : Twiddle_W_ex_i = 0;
 171 : Twiddle_W_ex_i = 0;
 172 : Twiddle_W_ex_i = 0;
 173 : Twiddle_W_ex_i = 0;
 174 : Twiddle_W_ex_i = 0;
 175 : Twiddle_W_ex_i = 0;
 176 : Twiddle_W_ex_i = 0;
 177 : Twiddle_W_ex_i = 0;
 178 : Twiddle_W_ex_i = 0;
 179 : Twiddle_W_ex_i = 0;
 180 : Twiddle_W_ex_i = 0;
 181 : Twiddle_W_ex_i = 0;
 182 : Twiddle_W_ex_i = 0;
 183 : Twiddle_W_ex_i = 0;
 184 : Twiddle_W_ex_i = 0;
 185 : Twiddle_W_ex_i = 0;
 186 : Twiddle_W_ex_i = 0;
 187 : Twiddle_W_ex_i = 0;
 188 : Twiddle_W_ex_i = 0;
 189 : Twiddle_W_ex_i = 0;
 190 : Twiddle_W_ex_i = 0;
 191 : Twiddle_W_ex_i = 0;
 192 : Twiddle_W_ex_i = 0;
 193 : Twiddle_W_ex_i = 0;
 194 : Twiddle_W_ex_i = 0;
 195 : Twiddle_W_ex_i = 0;
 196 : Twiddle_W_ex_i = 0;
 197 : Twiddle_W_ex_i = 0;
 198 : Twiddle_W_ex_i = 0;
 199 : Twiddle_W_ex_i = 0;
 200 : Twiddle_W_ex_i = 0;
 201 : Twiddle_W_ex_i = 0;
 202 : Twiddle_W_ex_i = 0;
 203 : Twiddle_W_ex_i = 0;
 204 : Twiddle_W_ex_i = 0;
 205 : Twiddle_W_ex_i = 0;
 206 : Twiddle_W_ex_i = 0;
 207 : Twiddle_W_ex_i = 0;
 208 : Twiddle_W_ex_i = 0;
 209 : Twiddle_W_ex_i = 0;
 210 : Twiddle_W_ex_i = 0;
 211 : Twiddle_W_ex_i = 0;
 212 : Twiddle_W_ex_i = 0;
 213 : Twiddle_W_ex_i = 0;
 214 : Twiddle_W_ex_i = 0;
 215 : Twiddle_W_ex_i = 0;
 216 : Twiddle_W_ex_i = 0;
 217 : Twiddle_W_ex_i = 0;
 218 : Twiddle_W_ex_i = 0;
 219 : Twiddle_W_ex_i = 0;
 220 : Twiddle_W_ex_i = 0;
 221 : Twiddle_W_ex_i = 0;
 222 : Twiddle_W_ex_i = 0;
 223 : Twiddle_W_ex_i = 0;
 224 : Twiddle_W_ex_i = 0;
 225 : Twiddle_W_ex_i = 0;
 226 : Twiddle_W_ex_i = 0;
 227 : Twiddle_W_ex_i = 0;
 228 : Twiddle_W_ex_i = 0;
 229 : Twiddle_W_ex_i = 0;
 230 : Twiddle_W_ex_i = 0;
 231 : Twiddle_W_ex_i = 0;
 232 : Twiddle_W_ex_i = 0;
 233 : Twiddle_W_ex_i = 0;
 234 : Twiddle_W_ex_i = 0;
 235 : Twiddle_W_ex_i = 0;
 236 : Twiddle_W_ex_i = 0;
 237 : Twiddle_W_ex_i = 0;
 238 : Twiddle_W_ex_i = 0;
 239 : Twiddle_W_ex_i = 0;
 240 : Twiddle_W_ex_i = 0;
 241 : Twiddle_W_ex_i = 0;
 242 : Twiddle_W_ex_i = 0;
 243 : Twiddle_W_ex_i = 0;
 244 : Twiddle_W_ex_i = 0;
 245 : Twiddle_W_ex_i = 0;
 246 : Twiddle_W_ex_i = 0;
 247 : Twiddle_W_ex_i = 0;
 248 : Twiddle_W_ex_i = 0;
 249 : Twiddle_W_ex_i = 0;
 250 : Twiddle_W_ex_i = 0;
 251 : Twiddle_W_ex_i = 0;
 252 : Twiddle_W_ex_i = 0;
 253 : Twiddle_W_ex_i = 0;
 254 : Twiddle_W_ex_i = 0;
 255 : Twiddle_W_ex_i = 0;
default : Twiddle_W_ex_i = 0;
endcase
endfunction
endmodule


module TWIDDLE_ST1(k, W_ex_r, W_r, W_ex_i, W_i);
input  [8:0]  k;
output [`W-1:0]  W_r, W_i;
output [1:0]   W_ex_r, W_ex_i;
assign W_r = Twiddle_W_r(k);
assign W_i = Twiddle_W_i(k);
assign W_ex_r = Twiddle_W_ex_r(k);
assign W_ex_i = Twiddle_W_ex_i(k);
function [`W-1:0] Twiddle_W_r;
input  [8:0]  k;
case(k)
 0 : Twiddle_W_r = 32604;
 1 : Twiddle_W_r = 32767;
 2 : Twiddle_W_r = 32765;
 3 : Twiddle_W_r = 32762;
 4 : Twiddle_W_r = 32758;
 5 : Twiddle_W_r = 32752;
 6 : Twiddle_W_r = 32745;
 7 : Twiddle_W_r = 32737;
 8 : Twiddle_W_r = 32728;
 9 : Twiddle_W_r = 32718;
 10 : Twiddle_W_r = 32706;
 11 : Twiddle_W_r = 32693;
 12 : Twiddle_W_r = 32679;
 13 : Twiddle_W_r = 32663;
 14 : Twiddle_W_r = 32647;
 15 : Twiddle_W_r = 32629;
 16 : Twiddle_W_r = 32610;
 17 : Twiddle_W_r = 32589;
 18 : Twiddle_W_r = 32568;
 19 : Twiddle_W_r = 32545;
 20 : Twiddle_W_r = 32521;
 21 : Twiddle_W_r = 32496;
 22 : Twiddle_W_r = 32469;
 23 : Twiddle_W_r = 32442;
 24 : Twiddle_W_r = 32413;
 25 : Twiddle_W_r = 32383;
 26 : Twiddle_W_r = 32351;
 27 : Twiddle_W_r = 32319;
 28 : Twiddle_W_r = 32285;
 29 : Twiddle_W_r = 32250;
 30 : Twiddle_W_r = 32214;
 31 : Twiddle_W_r = 32176;
 32 : Twiddle_W_r = 32138;
 33 : Twiddle_W_r = 32098;
 34 : Twiddle_W_r = 32057;
 35 : Twiddle_W_r = 32015;
 36 : Twiddle_W_r = 31971;
 37 : Twiddle_W_r = 31927;
 38 : Twiddle_W_r = 31881;
 39 : Twiddle_W_r = 31834;
 40 : Twiddle_W_r = 31785;
 41 : Twiddle_W_r = 31736;
 42 : Twiddle_W_r = 31685;
 43 : Twiddle_W_r = 31634;
 44 : Twiddle_W_r = 31581;
 45 : Twiddle_W_r = 31526;
 46 : Twiddle_W_r = 31471;
 47 : Twiddle_W_r = 31414;
 48 : Twiddle_W_r = 31357;
 49 : Twiddle_W_r = 31298;
 50 : Twiddle_W_r = 31237;
 51 : Twiddle_W_r = 31176;
 52 : Twiddle_W_r = 31114;
 53 : Twiddle_W_r = 31050;
 54 : Twiddle_W_r = 30985;
 55 : Twiddle_W_r = 30919;
 56 : Twiddle_W_r = 30852;
 57 : Twiddle_W_r = 30784;
 58 : Twiddle_W_r = 30714;
 59 : Twiddle_W_r = 30644;
 60 : Twiddle_W_r = 30572;
 61 : Twiddle_W_r = 30499;
 62 : Twiddle_W_r = 30425;
 63 : Twiddle_W_r = 30350;
 64 : Twiddle_W_r = 30273;
 65 : Twiddle_W_r = 30196;
 66 : Twiddle_W_r = 30117;
 67 : Twiddle_W_r = 30037;
 68 : Twiddle_W_r = 29956;
 69 : Twiddle_W_r = 29874;
 70 : Twiddle_W_r = 29791;
 71 : Twiddle_W_r = 29707;
 72 : Twiddle_W_r = 29621;
 73 : Twiddle_W_r = 29535;
 74 : Twiddle_W_r = 29447;
 75 : Twiddle_W_r = 29359;
 76 : Twiddle_W_r = 29269;
 77 : Twiddle_W_r = 29178;
 78 : Twiddle_W_r = 29086;
 79 : Twiddle_W_r = 28993;
 80 : Twiddle_W_r = 28898;
 81 : Twiddle_W_r = 28803;
 82 : Twiddle_W_r = 28707;
 83 : Twiddle_W_r = 28609;
 84 : Twiddle_W_r = 28511;
 85 : Twiddle_W_r = 28411;
 86 : Twiddle_W_r = 28310;
 87 : Twiddle_W_r = 28208;
 88 : Twiddle_W_r = 28106;
 89 : Twiddle_W_r = 28002;
 90 : Twiddle_W_r = 27897;
 91 : Twiddle_W_r = 27791;
 92 : Twiddle_W_r = 27684;
 93 : Twiddle_W_r = 27576;
 94 : Twiddle_W_r = 27466;
 95 : Twiddle_W_r = 27356;
 96 : Twiddle_W_r = 27245;
 97 : Twiddle_W_r = 27133;
 98 : Twiddle_W_r = 27020;
 99 : Twiddle_W_r = 26905;
 100 : Twiddle_W_r = 26790;
 101 : Twiddle_W_r = 26674;
 102 : Twiddle_W_r = 26557;
 103 : Twiddle_W_r = 26438;
 104 : Twiddle_W_r = 26319;
 105 : Twiddle_W_r = 26199;
 106 : Twiddle_W_r = 26077;
 107 : Twiddle_W_r = 25955;
 108 : Twiddle_W_r = 25832;
 109 : Twiddle_W_r = 25708;
 110 : Twiddle_W_r = 25583;
 111 : Twiddle_W_r = 25457;
 112 : Twiddle_W_r = 25330;
 113 : Twiddle_W_r = 25201;
 114 : Twiddle_W_r = 25073;
 115 : Twiddle_W_r = 24943;
 116 : Twiddle_W_r = 24812;
 117 : Twiddle_W_r = 24680;
 118 : Twiddle_W_r = 24547;
 119 : Twiddle_W_r = 24414;
 120 : Twiddle_W_r = 24279;
 121 : Twiddle_W_r = 24144;
 122 : Twiddle_W_r = 24007;
 123 : Twiddle_W_r = 23870;
 124 : Twiddle_W_r = 23732;
 125 : Twiddle_W_r = 23593;
 126 : Twiddle_W_r = 23453;
 127 : Twiddle_W_r = 23312;
 128 : Twiddle_W_r = 23170;
 129 : Twiddle_W_r = 23027;
 130 : Twiddle_W_r = 22884;
 131 : Twiddle_W_r = 22740;
 132 : Twiddle_W_r = 22594;
 133 : Twiddle_W_r = 22448;
 134 : Twiddle_W_r = 22301;
 135 : Twiddle_W_r = 22154;
 136 : Twiddle_W_r = 22005;
 137 : Twiddle_W_r = 21856;
 138 : Twiddle_W_r = 21706;
 139 : Twiddle_W_r = 21555;
 140 : Twiddle_W_r = 21403;
 141 : Twiddle_W_r = 21250;
 142 : Twiddle_W_r = 21097;
 143 : Twiddle_W_r = 20942;
 144 : Twiddle_W_r = 20787;
 145 : Twiddle_W_r = 20631;
 146 : Twiddle_W_r = 20475;
 147 : Twiddle_W_r = 20318;
 148 : Twiddle_W_r = 20159;
 149 : Twiddle_W_r = 20001;
 150 : Twiddle_W_r = 19841;
 151 : Twiddle_W_r = 19681;
 152 : Twiddle_W_r = 19519;
 153 : Twiddle_W_r = 19358;
 154 : Twiddle_W_r = 19195;
 155 : Twiddle_W_r = 19032;
 156 : Twiddle_W_r = 18868;
 157 : Twiddle_W_r = 18703;
 158 : Twiddle_W_r = 18537;
 159 : Twiddle_W_r = 18371;
 160 : Twiddle_W_r = 18204;
 161 : Twiddle_W_r = 18037;
 162 : Twiddle_W_r = 17869;
 163 : Twiddle_W_r = 17700;
 164 : Twiddle_W_r = 17530;
 165 : Twiddle_W_r = 17360;
 166 : Twiddle_W_r = 17189;
 167 : Twiddle_W_r = 17018;
 168 : Twiddle_W_r = 16846;
 169 : Twiddle_W_r = 16673;
 170 : Twiddle_W_r = 16499;
 171 : Twiddle_W_r = 16325;
 172 : Twiddle_W_r = 16151;
 173 : Twiddle_W_r = 15976;
 174 : Twiddle_W_r = 15800;
 175 : Twiddle_W_r = 15623;
 176 : Twiddle_W_r = 15446;
 177 : Twiddle_W_r = 15269;
 178 : Twiddle_W_r = 15090;
 179 : Twiddle_W_r = 14912;
 180 : Twiddle_W_r = 14732;
 181 : Twiddle_W_r = 14552;
 182 : Twiddle_W_r = 14372;
 183 : Twiddle_W_r = 14191;
 184 : Twiddle_W_r = 14010;
 185 : Twiddle_W_r = 13828;
 186 : Twiddle_W_r = 13645;
 187 : Twiddle_W_r = 13462;
 188 : Twiddle_W_r = 13278;
 189 : Twiddle_W_r = 13094;
 190 : Twiddle_W_r = 12910;
 191 : Twiddle_W_r = 12725;
 192 : Twiddle_W_r = 12539;
 193 : Twiddle_W_r = 12353;
 194 : Twiddle_W_r = 12167;
 195 : Twiddle_W_r = 11980;
 196 : Twiddle_W_r = 11793;
 197 : Twiddle_W_r = 11605;
 198 : Twiddle_W_r = 11416;
 199 : Twiddle_W_r = 11228;
 200 : Twiddle_W_r = 11039;
 201 : Twiddle_W_r = 10849;
 202 : Twiddle_W_r = 10659;
 203 : Twiddle_W_r = 10469;
 204 : Twiddle_W_r = 10278;
 205 : Twiddle_W_r = 10087;
 206 : Twiddle_W_r = 9896;
 207 : Twiddle_W_r = 9704;
 208 : Twiddle_W_r = 9512;
 209 : Twiddle_W_r = 9319;
 210 : Twiddle_W_r = 9126;
 211 : Twiddle_W_r = 8933;
 212 : Twiddle_W_r = 8739;
 213 : Twiddle_W_r = 8545;
 214 : Twiddle_W_r = 8351;
 215 : Twiddle_W_r = 8156;
 216 : Twiddle_W_r = 7961;
 217 : Twiddle_W_r = 7766;
 218 : Twiddle_W_r = 7571;
 219 : Twiddle_W_r = 7375;
 220 : Twiddle_W_r = 7179;
 221 : Twiddle_W_r = 6983;
 222 : Twiddle_W_r = 6786;
 223 : Twiddle_W_r = 6589;
 224 : Twiddle_W_r = 6392;
 225 : Twiddle_W_r = 6195;
 226 : Twiddle_W_r = 5997;
 227 : Twiddle_W_r = 5800;
 228 : Twiddle_W_r = 5602;
 229 : Twiddle_W_r = 5403;
 230 : Twiddle_W_r = 5205;
 231 : Twiddle_W_r = 5006;
 232 : Twiddle_W_r = 4808;
 233 : Twiddle_W_r = 4609;
 234 : Twiddle_W_r = 4409;
 235 : Twiddle_W_r = 4210;
 236 : Twiddle_W_r = 4011;
 237 : Twiddle_W_r = 3811;
 238 : Twiddle_W_r = 3611;
 239 : Twiddle_W_r = 3411;
 240 : Twiddle_W_r = 3211;
 241 : Twiddle_W_r = 3011;
 242 : Twiddle_W_r = 2811;
 243 : Twiddle_W_r = 2611;
 244 : Twiddle_W_r = 2410;
 245 : Twiddle_W_r = 2210;
 246 : Twiddle_W_r = 2009;
 247 : Twiddle_W_r = 1808;
 248 : Twiddle_W_r = 1607;
 249 : Twiddle_W_r = 1407;
 250 : Twiddle_W_r = 1206;
 251 : Twiddle_W_r = 1005;
 252 : Twiddle_W_r = 804;
 253 : Twiddle_W_r = 603;
 254 : Twiddle_W_r = 402;
 255 : Twiddle_W_r = 201;
 256 : Twiddle_W_r = 0;
 257 : Twiddle_W_r = 65334;
 258 : Twiddle_W_r = 65133;
 259 : Twiddle_W_r = 64932;
 260 : Twiddle_W_r = 64731;
 261 : Twiddle_W_r = 64530;
 262 : Twiddle_W_r = 64329;
 263 : Twiddle_W_r = 64128;
 264 : Twiddle_W_r = 63928;
 265 : Twiddle_W_r = 63727;
 266 : Twiddle_W_r = 63526;
 267 : Twiddle_W_r = 63325;
 268 : Twiddle_W_r = 63125;
 269 : Twiddle_W_r = 62924;
 270 : Twiddle_W_r = 62724;
 271 : Twiddle_W_r = 62524;
 272 : Twiddle_W_r = 62324;
 273 : Twiddle_W_r = 62124;
 274 : Twiddle_W_r = 61924;
 275 : Twiddle_W_r = 61724;
 276 : Twiddle_W_r = 61524;
 277 : Twiddle_W_r = 61325;
 278 : Twiddle_W_r = 61126;
 279 : Twiddle_W_r = 60926;
 280 : Twiddle_W_r = 60727;
 281 : Twiddle_W_r = 60529;
 282 : Twiddle_W_r = 60330;
 283 : Twiddle_W_r = 60132;
 284 : Twiddle_W_r = 59933;
 285 : Twiddle_W_r = 59735;
 286 : Twiddle_W_r = 59538;
 287 : Twiddle_W_r = 59340;
 288 : Twiddle_W_r = 59143;
 289 : Twiddle_W_r = 58946;
 290 : Twiddle_W_r = 58749;
 291 : Twiddle_W_r = 58552;
 292 : Twiddle_W_r = 58356;
 293 : Twiddle_W_r = 58160;
 294 : Twiddle_W_r = 57964;
 295 : Twiddle_W_r = 57769;
 296 : Twiddle_W_r = 57574;
 297 : Twiddle_W_r = 57379;
 298 : Twiddle_W_r = 57184;
 299 : Twiddle_W_r = 56990;
 300 : Twiddle_W_r = 56796;
 301 : Twiddle_W_r = 56602;
 302 : Twiddle_W_r = 56409;
 303 : Twiddle_W_r = 56216;
 304 : Twiddle_W_r = 56023;
 305 : Twiddle_W_r = 55831;
 306 : Twiddle_W_r = 55639;
 307 : Twiddle_W_r = 55448;
 308 : Twiddle_W_r = 55257;
 309 : Twiddle_W_r = 55066;
 310 : Twiddle_W_r = 54876;
 311 : Twiddle_W_r = 54686;
 312 : Twiddle_W_r = 54496;
 313 : Twiddle_W_r = 54307;
 314 : Twiddle_W_r = 54119;
 315 : Twiddle_W_r = 53930;
 316 : Twiddle_W_r = 53742;
 317 : Twiddle_W_r = 53555;
 318 : Twiddle_W_r = 53368;
 319 : Twiddle_W_r = 53182;
 320 : Twiddle_W_r = 52996;
 321 : Twiddle_W_r = 52810;
 322 : Twiddle_W_r = 52625;
 323 : Twiddle_W_r = 52441;
 324 : Twiddle_W_r = 52257;
 325 : Twiddle_W_r = 52073;
 326 : Twiddle_W_r = 51890;
 327 : Twiddle_W_r = 51707;
 328 : Twiddle_W_r = 51525;
 329 : Twiddle_W_r = 51344;
 330 : Twiddle_W_r = 51163;
 331 : Twiddle_W_r = 50983;
 332 : Twiddle_W_r = 50803;
 333 : Twiddle_W_r = 50623;
 334 : Twiddle_W_r = 50445;
 335 : Twiddle_W_r = 50266;
 336 : Twiddle_W_r = 50089;
 337 : Twiddle_W_r = 49912;
 338 : Twiddle_W_r = 49735;
 339 : Twiddle_W_r = 49559;
 340 : Twiddle_W_r = 49384;
 341 : Twiddle_W_r = 49210;
 342 : Twiddle_W_r = 49036;
 343 : Twiddle_W_r = 48862;
 344 : Twiddle_W_r = 48689;
 345 : Twiddle_W_r = 48517;
 346 : Twiddle_W_r = 48346;
 347 : Twiddle_W_r = 48175;
 348 : Twiddle_W_r = 48005;
 349 : Twiddle_W_r = 47835;
 350 : Twiddle_W_r = 47666;
 351 : Twiddle_W_r = 47498;
 352 : Twiddle_W_r = 47331;
 353 : Twiddle_W_r = 47164;
 354 : Twiddle_W_r = 46998;
 355 : Twiddle_W_r = 46832;
 356 : Twiddle_W_r = 46667;
 357 : Twiddle_W_r = 46503;
 358 : Twiddle_W_r = 46340;
 359 : Twiddle_W_r = 46177;
 360 : Twiddle_W_r = 46016;
 361 : Twiddle_W_r = 45854;
 362 : Twiddle_W_r = 45694;
 363 : Twiddle_W_r = 45534;
 364 : Twiddle_W_r = 45376;
 365 : Twiddle_W_r = 45217;
 366 : Twiddle_W_r = 45060;
 367 : Twiddle_W_r = 44904;
 368 : Twiddle_W_r = 44748;
 369 : Twiddle_W_r = 44593;
 370 : Twiddle_W_r = 44438;
 371 : Twiddle_W_r = 44285;
 372 : Twiddle_W_r = 44132;
 373 : Twiddle_W_r = 43980;
 374 : Twiddle_W_r = 43829;
 375 : Twiddle_W_r = 43679;
 376 : Twiddle_W_r = 43530;
 377 : Twiddle_W_r = 43381;
 378 : Twiddle_W_r = 43234;
 379 : Twiddle_W_r = 43087;
 380 : Twiddle_W_r = 42941;
 381 : Twiddle_W_r = 42795;
 382 : Twiddle_W_r = 42651;
 383 : Twiddle_W_r = 42508;
 384 : Twiddle_W_r = 42365;
 385 : Twiddle_W_r = 42223;
 386 : Twiddle_W_r = 42082;
 387 : Twiddle_W_r = 41942;
 388 : Twiddle_W_r = 41803;
 389 : Twiddle_W_r = 41665;
 390 : Twiddle_W_r = 41528;
 391 : Twiddle_W_r = 41391;
 392 : Twiddle_W_r = 41256;
 393 : Twiddle_W_r = 41121;
 394 : Twiddle_W_r = 40988;
 395 : Twiddle_W_r = 40855;
 396 : Twiddle_W_r = 40723;
 397 : Twiddle_W_r = 40592;
 398 : Twiddle_W_r = 40462;
 399 : Twiddle_W_r = 40334;
 400 : Twiddle_W_r = 40205;
 401 : Twiddle_W_r = 40078;
 402 : Twiddle_W_r = 39952;
 403 : Twiddle_W_r = 39827;
 404 : Twiddle_W_r = 39703;
 405 : Twiddle_W_r = 39580;
 406 : Twiddle_W_r = 39458;
 407 : Twiddle_W_r = 39336;
 408 : Twiddle_W_r = 39216;
 409 : Twiddle_W_r = 39097;
 410 : Twiddle_W_r = 38978;
 411 : Twiddle_W_r = 38861;
 412 : Twiddle_W_r = 38745;
 413 : Twiddle_W_r = 38630;
 414 : Twiddle_W_r = 38515;
 415 : Twiddle_W_r = 38402;
 416 : Twiddle_W_r = 38290;
 417 : Twiddle_W_r = 38179;
 418 : Twiddle_W_r = 38069;
 419 : Twiddle_W_r = 37959;
 420 : Twiddle_W_r = 37851;
 421 : Twiddle_W_r = 37744;
 422 : Twiddle_W_r = 37638;
 423 : Twiddle_W_r = 37533;
 424 : Twiddle_W_r = 37429;
 425 : Twiddle_W_r = 37327;
 426 : Twiddle_W_r = 37225;
 427 : Twiddle_W_r = 37124;
 428 : Twiddle_W_r = 37024;
 429 : Twiddle_W_r = 36926;
 430 : Twiddle_W_r = 36828;
 431 : Twiddle_W_r = 36732;
 432 : Twiddle_W_r = 36637;
 433 : Twiddle_W_r = 36542;
 434 : Twiddle_W_r = 36449;
 435 : Twiddle_W_r = 36357;
 436 : Twiddle_W_r = 36266;
 437 : Twiddle_W_r = 36176;
 438 : Twiddle_W_r = 36088;
 439 : Twiddle_W_r = 36000;
 440 : Twiddle_W_r = 35914;
 441 : Twiddle_W_r = 35828;
 442 : Twiddle_W_r = 35744;
 443 : Twiddle_W_r = 35661;
 444 : Twiddle_W_r = 35579;
 445 : Twiddle_W_r = 35498;
 446 : Twiddle_W_r = 35418;
 447 : Twiddle_W_r = 35339;
 448 : Twiddle_W_r = 35262;
 449 : Twiddle_W_r = 35185;
 450 : Twiddle_W_r = 35110;
 451 : Twiddle_W_r = 35036;
 452 : Twiddle_W_r = 34963;
 453 : Twiddle_W_r = 34891;
 454 : Twiddle_W_r = 34821;
 455 : Twiddle_W_r = 34751;
 456 : Twiddle_W_r = 34683;
 457 : Twiddle_W_r = 34616;
 458 : Twiddle_W_r = 34550;
 459 : Twiddle_W_r = 34485;
 460 : Twiddle_W_r = 34421;
 461 : Twiddle_W_r = 34359;
 462 : Twiddle_W_r = 34298;
 463 : Twiddle_W_r = 34237;
 464 : Twiddle_W_r = 34178;
 465 : Twiddle_W_r = 34121;
 466 : Twiddle_W_r = 34064;
 467 : Twiddle_W_r = 34009;
 468 : Twiddle_W_r = 33954;
 469 : Twiddle_W_r = 33901;
 470 : Twiddle_W_r = 33850;
 471 : Twiddle_W_r = 33799;
 472 : Twiddle_W_r = 33750;
 473 : Twiddle_W_r = 33701;
 474 : Twiddle_W_r = 33654;
 475 : Twiddle_W_r = 33608;
 476 : Twiddle_W_r = 33564;
 477 : Twiddle_W_r = 33520;
 478 : Twiddle_W_r = 33478;
 479 : Twiddle_W_r = 33437;
 480 : Twiddle_W_r = 33397;
 481 : Twiddle_W_r = 33359;
 482 : Twiddle_W_r = 33321;
 483 : Twiddle_W_r = 33285;
 484 : Twiddle_W_r = 33250;
 485 : Twiddle_W_r = 33216;
 486 : Twiddle_W_r = 33184;
 487 : Twiddle_W_r = 33152;
 488 : Twiddle_W_r = 33122;
 489 : Twiddle_W_r = 33093;
 490 : Twiddle_W_r = 33066;
 491 : Twiddle_W_r = 33039;
 492 : Twiddle_W_r = 33014;
 493 : Twiddle_W_r = 32990;
 494 : Twiddle_W_r = 32967;
 495 : Twiddle_W_r = 32946;
 496 : Twiddle_W_r = 32925;
 497 : Twiddle_W_r = 32906;
 498 : Twiddle_W_r = 32888;
 499 : Twiddle_W_r = 32872;
 500 : Twiddle_W_r = 32856;
 501 : Twiddle_W_r = 32842;
 502 : Twiddle_W_r = 32829;
 503 : Twiddle_W_r = 32817;
 504 : Twiddle_W_r = 32807;
 505 : Twiddle_W_r = 32798;
 506 : Twiddle_W_r = 32790;
 507 : Twiddle_W_r = 32783;
 508 : Twiddle_W_r = 32777;
 509 : Twiddle_W_r = 32773;
 510 : Twiddle_W_r = 32770;
 511 : Twiddle_W_r = 32768;
default : Twiddle_W_r = 0;
endcase
endfunction
function [`W-1:0] Twiddle_W_i;
input  [8:0]  k;
case(k)
 0 : Twiddle_W_i = 0;
 1 : Twiddle_W_i = 65334;
 2 : Twiddle_W_i = 65133;
 3 : Twiddle_W_i = 64932;
 4 : Twiddle_W_i = 64731;
 5 : Twiddle_W_i = 64530;
 6 : Twiddle_W_i = 64329;
 7 : Twiddle_W_i = 64128;
 8 : Twiddle_W_i = 63928;
 9 : Twiddle_W_i = 63727;
 10 : Twiddle_W_i = 63526;
 11 : Twiddle_W_i = 63325;
 12 : Twiddle_W_i = 63125;
 13 : Twiddle_W_i = 62924;
 14 : Twiddle_W_i = 62724;
 15 : Twiddle_W_i = 62524;
 16 : Twiddle_W_i = 62324;
 17 : Twiddle_W_i = 62124;
 18 : Twiddle_W_i = 61924;
 19 : Twiddle_W_i = 61724;
 20 : Twiddle_W_i = 61524;
 21 : Twiddle_W_i = 61325;
 22 : Twiddle_W_i = 61126;
 23 : Twiddle_W_i = 60926;
 24 : Twiddle_W_i = 60727;
 25 : Twiddle_W_i = 60529;
 26 : Twiddle_W_i = 60330;
 27 : Twiddle_W_i = 60132;
 28 : Twiddle_W_i = 59933;
 29 : Twiddle_W_i = 59735;
 30 : Twiddle_W_i = 59538;
 31 : Twiddle_W_i = 59340;
 32 : Twiddle_W_i = 59143;
 33 : Twiddle_W_i = 58946;
 34 : Twiddle_W_i = 58749;
 35 : Twiddle_W_i = 58552;
 36 : Twiddle_W_i = 58356;
 37 : Twiddle_W_i = 58160;
 38 : Twiddle_W_i = 57964;
 39 : Twiddle_W_i = 57769;
 40 : Twiddle_W_i = 57574;
 41 : Twiddle_W_i = 57379;
 42 : Twiddle_W_i = 57184;
 43 : Twiddle_W_i = 56990;
 44 : Twiddle_W_i = 56796;
 45 : Twiddle_W_i = 56602;
 46 : Twiddle_W_i = 56409;
 47 : Twiddle_W_i = 56216;
 48 : Twiddle_W_i = 56023;
 49 : Twiddle_W_i = 55831;
 50 : Twiddle_W_i = 55639;
 51 : Twiddle_W_i = 55448;
 52 : Twiddle_W_i = 55257;
 53 : Twiddle_W_i = 55066;
 54 : Twiddle_W_i = 54876;
 55 : Twiddle_W_i = 54686;
 56 : Twiddle_W_i = 54496;
 57 : Twiddle_W_i = 54307;
 58 : Twiddle_W_i = 54119;
 59 : Twiddle_W_i = 53930;
 60 : Twiddle_W_i = 53742;
 61 : Twiddle_W_i = 53555;
 62 : Twiddle_W_i = 53368;
 63 : Twiddle_W_i = 53182;
 64 : Twiddle_W_i = 52996;
 65 : Twiddle_W_i = 52810;
 66 : Twiddle_W_i = 52625;
 67 : Twiddle_W_i = 52441;
 68 : Twiddle_W_i = 52257;
 69 : Twiddle_W_i = 52073;
 70 : Twiddle_W_i = 51890;
 71 : Twiddle_W_i = 51707;
 72 : Twiddle_W_i = 51525;
 73 : Twiddle_W_i = 51344;
 74 : Twiddle_W_i = 51163;
 75 : Twiddle_W_i = 50983;
 76 : Twiddle_W_i = 50803;
 77 : Twiddle_W_i = 50623;
 78 : Twiddle_W_i = 50445;
 79 : Twiddle_W_i = 50266;
 80 : Twiddle_W_i = 50089;
 81 : Twiddle_W_i = 49912;
 82 : Twiddle_W_i = 49735;
 83 : Twiddle_W_i = 49559;
 84 : Twiddle_W_i = 49384;
 85 : Twiddle_W_i = 49210;
 86 : Twiddle_W_i = 49036;
 87 : Twiddle_W_i = 48862;
 88 : Twiddle_W_i = 48689;
 89 : Twiddle_W_i = 48517;
 90 : Twiddle_W_i = 48346;
 91 : Twiddle_W_i = 48175;
 92 : Twiddle_W_i = 48005;
 93 : Twiddle_W_i = 47835;
 94 : Twiddle_W_i = 47666;
 95 : Twiddle_W_i = 47498;
 96 : Twiddle_W_i = 47331;
 97 : Twiddle_W_i = 47164;
 98 : Twiddle_W_i = 46998;
 99 : Twiddle_W_i = 46832;
 100 : Twiddle_W_i = 46667;
 101 : Twiddle_W_i = 46503;
 102 : Twiddle_W_i = 46340;
 103 : Twiddle_W_i = 46177;
 104 : Twiddle_W_i = 46016;
 105 : Twiddle_W_i = 45854;
 106 : Twiddle_W_i = 45694;
 107 : Twiddle_W_i = 45534;
 108 : Twiddle_W_i = 45376;
 109 : Twiddle_W_i = 45217;
 110 : Twiddle_W_i = 45060;
 111 : Twiddle_W_i = 44904;
 112 : Twiddle_W_i = 44748;
 113 : Twiddle_W_i = 44593;
 114 : Twiddle_W_i = 44438;
 115 : Twiddle_W_i = 44285;
 116 : Twiddle_W_i = 44132;
 117 : Twiddle_W_i = 43980;
 118 : Twiddle_W_i = 43829;
 119 : Twiddle_W_i = 43679;
 120 : Twiddle_W_i = 43530;
 121 : Twiddle_W_i = 43381;
 122 : Twiddle_W_i = 43234;
 123 : Twiddle_W_i = 43087;
 124 : Twiddle_W_i = 42941;
 125 : Twiddle_W_i = 42795;
 126 : Twiddle_W_i = 42651;
 127 : Twiddle_W_i = 42508;
 128 : Twiddle_W_i = 42365;
 129 : Twiddle_W_i = 42223;
 130 : Twiddle_W_i = 42082;
 131 : Twiddle_W_i = 41942;
 132 : Twiddle_W_i = 41803;
 133 : Twiddle_W_i = 41665;
 134 : Twiddle_W_i = 41528;
 135 : Twiddle_W_i = 41391;
 136 : Twiddle_W_i = 41256;
 137 : Twiddle_W_i = 41121;
 138 : Twiddle_W_i = 40988;
 139 : Twiddle_W_i = 40855;
 140 : Twiddle_W_i = 40723;
 141 : Twiddle_W_i = 40592;
 142 : Twiddle_W_i = 40462;
 143 : Twiddle_W_i = 40334;
 144 : Twiddle_W_i = 40205;
 145 : Twiddle_W_i = 40078;
 146 : Twiddle_W_i = 39952;
 147 : Twiddle_W_i = 39827;
 148 : Twiddle_W_i = 39703;
 149 : Twiddle_W_i = 39580;
 150 : Twiddle_W_i = 39458;
 151 : Twiddle_W_i = 39336;
 152 : Twiddle_W_i = 39216;
 153 : Twiddle_W_i = 39097;
 154 : Twiddle_W_i = 38978;
 155 : Twiddle_W_i = 38861;
 156 : Twiddle_W_i = 38745;
 157 : Twiddle_W_i = 38630;
 158 : Twiddle_W_i = 38515;
 159 : Twiddle_W_i = 38402;
 160 : Twiddle_W_i = 38290;
 161 : Twiddle_W_i = 38179;
 162 : Twiddle_W_i = 38069;
 163 : Twiddle_W_i = 37959;
 164 : Twiddle_W_i = 37851;
 165 : Twiddle_W_i = 37744;
 166 : Twiddle_W_i = 37638;
 167 : Twiddle_W_i = 37533;
 168 : Twiddle_W_i = 37429;
 169 : Twiddle_W_i = 37327;
 170 : Twiddle_W_i = 37225;
 171 : Twiddle_W_i = 37124;
 172 : Twiddle_W_i = 37024;
 173 : Twiddle_W_i = 36926;
 174 : Twiddle_W_i = 36828;
 175 : Twiddle_W_i = 36732;
 176 : Twiddle_W_i = 36637;
 177 : Twiddle_W_i = 36542;
 178 : Twiddle_W_i = 36449;
 179 : Twiddle_W_i = 36357;
 180 : Twiddle_W_i = 36266;
 181 : Twiddle_W_i = 36176;
 182 : Twiddle_W_i = 36088;
 183 : Twiddle_W_i = 36000;
 184 : Twiddle_W_i = 35914;
 185 : Twiddle_W_i = 35828;
 186 : Twiddle_W_i = 35744;
 187 : Twiddle_W_i = 35661;
 188 : Twiddle_W_i = 35579;
 189 : Twiddle_W_i = 35498;
 190 : Twiddle_W_i = 35418;
 191 : Twiddle_W_i = 35339;
 192 : Twiddle_W_i = 35262;
 193 : Twiddle_W_i = 35185;
 194 : Twiddle_W_i = 35110;
 195 : Twiddle_W_i = 35036;
 196 : Twiddle_W_i = 34963;
 197 : Twiddle_W_i = 34891;
 198 : Twiddle_W_i = 34821;
 199 : Twiddle_W_i = 34751;
 200 : Twiddle_W_i = 34683;
 201 : Twiddle_W_i = 34616;
 202 : Twiddle_W_i = 34550;
 203 : Twiddle_W_i = 34485;
 204 : Twiddle_W_i = 34421;
 205 : Twiddle_W_i = 34359;
 206 : Twiddle_W_i = 34298;
 207 : Twiddle_W_i = 34237;
 208 : Twiddle_W_i = 34178;
 209 : Twiddle_W_i = 34121;
 210 : Twiddle_W_i = 34064;
 211 : Twiddle_W_i = 34009;
 212 : Twiddle_W_i = 33954;
 213 : Twiddle_W_i = 33901;
 214 : Twiddle_W_i = 33850;
 215 : Twiddle_W_i = 33799;
 216 : Twiddle_W_i = 33750;
 217 : Twiddle_W_i = 33701;
 218 : Twiddle_W_i = 33654;
 219 : Twiddle_W_i = 33608;
 220 : Twiddle_W_i = 33564;
 221 : Twiddle_W_i = 33520;
 222 : Twiddle_W_i = 33478;
 223 : Twiddle_W_i = 33437;
 224 : Twiddle_W_i = 33397;
 225 : Twiddle_W_i = 33359;
 226 : Twiddle_W_i = 33321;
 227 : Twiddle_W_i = 33285;
 228 : Twiddle_W_i = 33250;
 229 : Twiddle_W_i = 33216;
 230 : Twiddle_W_i = 33184;
 231 : Twiddle_W_i = 33152;
 232 : Twiddle_W_i = 33122;
 233 : Twiddle_W_i = 33093;
 234 : Twiddle_W_i = 33066;
 235 : Twiddle_W_i = 33039;
 236 : Twiddle_W_i = 33014;
 237 : Twiddle_W_i = 32990;
 238 : Twiddle_W_i = 32967;
 239 : Twiddle_W_i = 32946;
 240 : Twiddle_W_i = 32925;
 241 : Twiddle_W_i = 32906;
 242 : Twiddle_W_i = 32888;
 243 : Twiddle_W_i = 32872;
 244 : Twiddle_W_i = 32856;
 245 : Twiddle_W_i = 32842;
 246 : Twiddle_W_i = 32829;
 247 : Twiddle_W_i = 32817;
 248 : Twiddle_W_i = 32807;
 249 : Twiddle_W_i = 32798;
 250 : Twiddle_W_i = 32790;
 251 : Twiddle_W_i = 32783;
 252 : Twiddle_W_i = 32777;
 253 : Twiddle_W_i = 32773;
 254 : Twiddle_W_i = 32770;
 255 : Twiddle_W_i = 32768;
 256 : Twiddle_W_i = 32931;
 257 : Twiddle_W_i = 32768;
 258 : Twiddle_W_i = 32770;
 259 : Twiddle_W_i = 32773;
 260 : Twiddle_W_i = 32777;
 261 : Twiddle_W_i = 32783;
 262 : Twiddle_W_i = 32790;
 263 : Twiddle_W_i = 32798;
 264 : Twiddle_W_i = 32807;
 265 : Twiddle_W_i = 32817;
 266 : Twiddle_W_i = 32829;
 267 : Twiddle_W_i = 32842;
 268 : Twiddle_W_i = 32856;
 269 : Twiddle_W_i = 32872;
 270 : Twiddle_W_i = 32888;
 271 : Twiddle_W_i = 32906;
 272 : Twiddle_W_i = 32925;
 273 : Twiddle_W_i = 32946;
 274 : Twiddle_W_i = 32967;
 275 : Twiddle_W_i = 32990;
 276 : Twiddle_W_i = 33014;
 277 : Twiddle_W_i = 33039;
 278 : Twiddle_W_i = 33066;
 279 : Twiddle_W_i = 33093;
 280 : Twiddle_W_i = 33122;
 281 : Twiddle_W_i = 33152;
 282 : Twiddle_W_i = 33184;
 283 : Twiddle_W_i = 33216;
 284 : Twiddle_W_i = 33250;
 285 : Twiddle_W_i = 33285;
 286 : Twiddle_W_i = 33321;
 287 : Twiddle_W_i = 33359;
 288 : Twiddle_W_i = 33397;
 289 : Twiddle_W_i = 33437;
 290 : Twiddle_W_i = 33478;
 291 : Twiddle_W_i = 33520;
 292 : Twiddle_W_i = 33564;
 293 : Twiddle_W_i = 33608;
 294 : Twiddle_W_i = 33654;
 295 : Twiddle_W_i = 33701;
 296 : Twiddle_W_i = 33750;
 297 : Twiddle_W_i = 33799;
 298 : Twiddle_W_i = 33850;
 299 : Twiddle_W_i = 33901;
 300 : Twiddle_W_i = 33954;
 301 : Twiddle_W_i = 34009;
 302 : Twiddle_W_i = 34064;
 303 : Twiddle_W_i = 34121;
 304 : Twiddle_W_i = 34178;
 305 : Twiddle_W_i = 34237;
 306 : Twiddle_W_i = 34298;
 307 : Twiddle_W_i = 34359;
 308 : Twiddle_W_i = 34421;
 309 : Twiddle_W_i = 34485;
 310 : Twiddle_W_i = 34550;
 311 : Twiddle_W_i = 34616;
 312 : Twiddle_W_i = 34683;
 313 : Twiddle_W_i = 34751;
 314 : Twiddle_W_i = 34821;
 315 : Twiddle_W_i = 34891;
 316 : Twiddle_W_i = 34963;
 317 : Twiddle_W_i = 35036;
 318 : Twiddle_W_i = 35110;
 319 : Twiddle_W_i = 35185;
 320 : Twiddle_W_i = 35262;
 321 : Twiddle_W_i = 35339;
 322 : Twiddle_W_i = 35418;
 323 : Twiddle_W_i = 35498;
 324 : Twiddle_W_i = 35579;
 325 : Twiddle_W_i = 35661;
 326 : Twiddle_W_i = 35744;
 327 : Twiddle_W_i = 35828;
 328 : Twiddle_W_i = 35914;
 329 : Twiddle_W_i = 36000;
 330 : Twiddle_W_i = 36088;
 331 : Twiddle_W_i = 36176;
 332 : Twiddle_W_i = 36266;
 333 : Twiddle_W_i = 36357;
 334 : Twiddle_W_i = 36449;
 335 : Twiddle_W_i = 36542;
 336 : Twiddle_W_i = 36637;
 337 : Twiddle_W_i = 36732;
 338 : Twiddle_W_i = 36828;
 339 : Twiddle_W_i = 36926;
 340 : Twiddle_W_i = 37024;
 341 : Twiddle_W_i = 37124;
 342 : Twiddle_W_i = 37225;
 343 : Twiddle_W_i = 37327;
 344 : Twiddle_W_i = 37429;
 345 : Twiddle_W_i = 37533;
 346 : Twiddle_W_i = 37638;
 347 : Twiddle_W_i = 37744;
 348 : Twiddle_W_i = 37851;
 349 : Twiddle_W_i = 37959;
 350 : Twiddle_W_i = 38069;
 351 : Twiddle_W_i = 38179;
 352 : Twiddle_W_i = 38290;
 353 : Twiddle_W_i = 38402;
 354 : Twiddle_W_i = 38515;
 355 : Twiddle_W_i = 38630;
 356 : Twiddle_W_i = 38745;
 357 : Twiddle_W_i = 38861;
 358 : Twiddle_W_i = 38978;
 359 : Twiddle_W_i = 39097;
 360 : Twiddle_W_i = 39216;
 361 : Twiddle_W_i = 39336;
 362 : Twiddle_W_i = 39458;
 363 : Twiddle_W_i = 39580;
 364 : Twiddle_W_i = 39703;
 365 : Twiddle_W_i = 39827;
 366 : Twiddle_W_i = 39952;
 367 : Twiddle_W_i = 40078;
 368 : Twiddle_W_i = 40205;
 369 : Twiddle_W_i = 40334;
 370 : Twiddle_W_i = 40462;
 371 : Twiddle_W_i = 40592;
 372 : Twiddle_W_i = 40723;
 373 : Twiddle_W_i = 40855;
 374 : Twiddle_W_i = 40988;
 375 : Twiddle_W_i = 41121;
 376 : Twiddle_W_i = 41256;
 377 : Twiddle_W_i = 41391;
 378 : Twiddle_W_i = 41528;
 379 : Twiddle_W_i = 41665;
 380 : Twiddle_W_i = 41803;
 381 : Twiddle_W_i = 41942;
 382 : Twiddle_W_i = 42082;
 383 : Twiddle_W_i = 42223;
 384 : Twiddle_W_i = 42365;
 385 : Twiddle_W_i = 42508;
 386 : Twiddle_W_i = 42651;
 387 : Twiddle_W_i = 42795;
 388 : Twiddle_W_i = 42941;
 389 : Twiddle_W_i = 43087;
 390 : Twiddle_W_i = 43234;
 391 : Twiddle_W_i = 43381;
 392 : Twiddle_W_i = 43530;
 393 : Twiddle_W_i = 43679;
 394 : Twiddle_W_i = 43829;
 395 : Twiddle_W_i = 43980;
 396 : Twiddle_W_i = 44132;
 397 : Twiddle_W_i = 44285;
 398 : Twiddle_W_i = 44438;
 399 : Twiddle_W_i = 44593;
 400 : Twiddle_W_i = 44748;
 401 : Twiddle_W_i = 44904;
 402 : Twiddle_W_i = 45060;
 403 : Twiddle_W_i = 45217;
 404 : Twiddle_W_i = 45376;
 405 : Twiddle_W_i = 45534;
 406 : Twiddle_W_i = 45694;
 407 : Twiddle_W_i = 45854;
 408 : Twiddle_W_i = 46016;
 409 : Twiddle_W_i = 46177;
 410 : Twiddle_W_i = 46340;
 411 : Twiddle_W_i = 46503;
 412 : Twiddle_W_i = 46667;
 413 : Twiddle_W_i = 46832;
 414 : Twiddle_W_i = 46998;
 415 : Twiddle_W_i = 47164;
 416 : Twiddle_W_i = 47331;
 417 : Twiddle_W_i = 47498;
 418 : Twiddle_W_i = 47666;
 419 : Twiddle_W_i = 47835;
 420 : Twiddle_W_i = 48005;
 421 : Twiddle_W_i = 48175;
 422 : Twiddle_W_i = 48346;
 423 : Twiddle_W_i = 48517;
 424 : Twiddle_W_i = 48689;
 425 : Twiddle_W_i = 48862;
 426 : Twiddle_W_i = 49036;
 427 : Twiddle_W_i = 49210;
 428 : Twiddle_W_i = 49384;
 429 : Twiddle_W_i = 49559;
 430 : Twiddle_W_i = 49735;
 431 : Twiddle_W_i = 49912;
 432 : Twiddle_W_i = 50089;
 433 : Twiddle_W_i = 50266;
 434 : Twiddle_W_i = 50445;
 435 : Twiddle_W_i = 50623;
 436 : Twiddle_W_i = 50803;
 437 : Twiddle_W_i = 50983;
 438 : Twiddle_W_i = 51163;
 439 : Twiddle_W_i = 51344;
 440 : Twiddle_W_i = 51525;
 441 : Twiddle_W_i = 51707;
 442 : Twiddle_W_i = 51890;
 443 : Twiddle_W_i = 52073;
 444 : Twiddle_W_i = 52257;
 445 : Twiddle_W_i = 52441;
 446 : Twiddle_W_i = 52625;
 447 : Twiddle_W_i = 52810;
 448 : Twiddle_W_i = 52996;
 449 : Twiddle_W_i = 53182;
 450 : Twiddle_W_i = 53368;
 451 : Twiddle_W_i = 53555;
 452 : Twiddle_W_i = 53742;
 453 : Twiddle_W_i = 53930;
 454 : Twiddle_W_i = 54119;
 455 : Twiddle_W_i = 54307;
 456 : Twiddle_W_i = 54496;
 457 : Twiddle_W_i = 54686;
 458 : Twiddle_W_i = 54876;
 459 : Twiddle_W_i = 55066;
 460 : Twiddle_W_i = 55257;
 461 : Twiddle_W_i = 55448;
 462 : Twiddle_W_i = 55639;
 463 : Twiddle_W_i = 55831;
 464 : Twiddle_W_i = 56023;
 465 : Twiddle_W_i = 56216;
 466 : Twiddle_W_i = 56409;
 467 : Twiddle_W_i = 56602;
 468 : Twiddle_W_i = 56796;
 469 : Twiddle_W_i = 56990;
 470 : Twiddle_W_i = 57184;
 471 : Twiddle_W_i = 57379;
 472 : Twiddle_W_i = 57574;
 473 : Twiddle_W_i = 57769;
 474 : Twiddle_W_i = 57964;
 475 : Twiddle_W_i = 58160;
 476 : Twiddle_W_i = 58356;
 477 : Twiddle_W_i = 58552;
 478 : Twiddle_W_i = 58749;
 479 : Twiddle_W_i = 58946;
 480 : Twiddle_W_i = 59143;
 481 : Twiddle_W_i = 59340;
 482 : Twiddle_W_i = 59538;
 483 : Twiddle_W_i = 59735;
 484 : Twiddle_W_i = 59933;
 485 : Twiddle_W_i = 60132;
 486 : Twiddle_W_i = 60330;
 487 : Twiddle_W_i = 60529;
 488 : Twiddle_W_i = 60727;
 489 : Twiddle_W_i = 60926;
 490 : Twiddle_W_i = 61126;
 491 : Twiddle_W_i = 61325;
 492 : Twiddle_W_i = 61524;
 493 : Twiddle_W_i = 61724;
 494 : Twiddle_W_i = 61924;
 495 : Twiddle_W_i = 62124;
 496 : Twiddle_W_i = 62324;
 497 : Twiddle_W_i = 62524;
 498 : Twiddle_W_i = 62724;
 499 : Twiddle_W_i = 62924;
 500 : Twiddle_W_i = 63125;
 501 : Twiddle_W_i = 63325;
 502 : Twiddle_W_i = 63526;
 503 : Twiddle_W_i = 63727;
 504 : Twiddle_W_i = 63928;
 505 : Twiddle_W_i = 64128;
 506 : Twiddle_W_i = 64329;
 507 : Twiddle_W_i = 64530;
 508 : Twiddle_W_i = 64731;
 509 : Twiddle_W_i = 64932;
 510 : Twiddle_W_i = 65133;
 511 : Twiddle_W_i = 65334;
default : Twiddle_W_i = 0;
endcase
endfunction
function [1:0] Twiddle_W_ex_r;
input  [8:0]  k;
case(k)
 0 : Twiddle_W_ex_r = 1;
 1 : Twiddle_W_ex_r = 0;
 2 : Twiddle_W_ex_r = 0;
 3 : Twiddle_W_ex_r = 0;
 4 : Twiddle_W_ex_r = 0;
 5 : Twiddle_W_ex_r = 0;
 6 : Twiddle_W_ex_r = 0;
 7 : Twiddle_W_ex_r = 0;
 8 : Twiddle_W_ex_r = 0;
 9 : Twiddle_W_ex_r = 0;
 10 : Twiddle_W_ex_r = 0;
 11 : Twiddle_W_ex_r = 0;
 12 : Twiddle_W_ex_r = 0;
 13 : Twiddle_W_ex_r = 0;
 14 : Twiddle_W_ex_r = 0;
 15 : Twiddle_W_ex_r = 0;
 16 : Twiddle_W_ex_r = 0;
 17 : Twiddle_W_ex_r = 0;
 18 : Twiddle_W_ex_r = 0;
 19 : Twiddle_W_ex_r = 0;
 20 : Twiddle_W_ex_r = 0;
 21 : Twiddle_W_ex_r = 0;
 22 : Twiddle_W_ex_r = 0;
 23 : Twiddle_W_ex_r = 0;
 24 : Twiddle_W_ex_r = 0;
 25 : Twiddle_W_ex_r = 0;
 26 : Twiddle_W_ex_r = 0;
 27 : Twiddle_W_ex_r = 0;
 28 : Twiddle_W_ex_r = 0;
 29 : Twiddle_W_ex_r = 0;
 30 : Twiddle_W_ex_r = 0;
 31 : Twiddle_W_ex_r = 0;
 32 : Twiddle_W_ex_r = 0;
 33 : Twiddle_W_ex_r = 0;
 34 : Twiddle_W_ex_r = 0;
 35 : Twiddle_W_ex_r = 0;
 36 : Twiddle_W_ex_r = 0;
 37 : Twiddle_W_ex_r = 0;
 38 : Twiddle_W_ex_r = 0;
 39 : Twiddle_W_ex_r = 0;
 40 : Twiddle_W_ex_r = 0;
 41 : Twiddle_W_ex_r = 0;
 42 : Twiddle_W_ex_r = 0;
 43 : Twiddle_W_ex_r = 0;
 44 : Twiddle_W_ex_r = 0;
 45 : Twiddle_W_ex_r = 0;
 46 : Twiddle_W_ex_r = 0;
 47 : Twiddle_W_ex_r = 0;
 48 : Twiddle_W_ex_r = 0;
 49 : Twiddle_W_ex_r = 0;
 50 : Twiddle_W_ex_r = 0;
 51 : Twiddle_W_ex_r = 0;
 52 : Twiddle_W_ex_r = 0;
 53 : Twiddle_W_ex_r = 0;
 54 : Twiddle_W_ex_r = 0;
 55 : Twiddle_W_ex_r = 0;
 56 : Twiddle_W_ex_r = 0;
 57 : Twiddle_W_ex_r = 0;
 58 : Twiddle_W_ex_r = 0;
 59 : Twiddle_W_ex_r = 0;
 60 : Twiddle_W_ex_r = 0;
 61 : Twiddle_W_ex_r = 0;
 62 : Twiddle_W_ex_r = 0;
 63 : Twiddle_W_ex_r = 0;
 64 : Twiddle_W_ex_r = 0;
 65 : Twiddle_W_ex_r = 0;
 66 : Twiddle_W_ex_r = 0;
 67 : Twiddle_W_ex_r = 0;
 68 : Twiddle_W_ex_r = 0;
 69 : Twiddle_W_ex_r = 0;
 70 : Twiddle_W_ex_r = 0;
 71 : Twiddle_W_ex_r = 0;
 72 : Twiddle_W_ex_r = 0;
 73 : Twiddle_W_ex_r = 0;
 74 : Twiddle_W_ex_r = 0;
 75 : Twiddle_W_ex_r = 0;
 76 : Twiddle_W_ex_r = 0;
 77 : Twiddle_W_ex_r = 0;
 78 : Twiddle_W_ex_r = 0;
 79 : Twiddle_W_ex_r = 0;
 80 : Twiddle_W_ex_r = 0;
 81 : Twiddle_W_ex_r = 0;
 82 : Twiddle_W_ex_r = 0;
 83 : Twiddle_W_ex_r = 0;
 84 : Twiddle_W_ex_r = 0;
 85 : Twiddle_W_ex_r = 0;
 86 : Twiddle_W_ex_r = 0;
 87 : Twiddle_W_ex_r = 0;
 88 : Twiddle_W_ex_r = 0;
 89 : Twiddle_W_ex_r = 0;
 90 : Twiddle_W_ex_r = 0;
 91 : Twiddle_W_ex_r = 0;
 92 : Twiddle_W_ex_r = 0;
 93 : Twiddle_W_ex_r = 0;
 94 : Twiddle_W_ex_r = 0;
 95 : Twiddle_W_ex_r = 0;
 96 : Twiddle_W_ex_r = 0;
 97 : Twiddle_W_ex_r = 0;
 98 : Twiddle_W_ex_r = 0;
 99 : Twiddle_W_ex_r = 0;
 100 : Twiddle_W_ex_r = 0;
 101 : Twiddle_W_ex_r = 0;
 102 : Twiddle_W_ex_r = 0;
 103 : Twiddle_W_ex_r = 0;
 104 : Twiddle_W_ex_r = 0;
 105 : Twiddle_W_ex_r = 0;
 106 : Twiddle_W_ex_r = 0;
 107 : Twiddle_W_ex_r = 0;
 108 : Twiddle_W_ex_r = 0;
 109 : Twiddle_W_ex_r = 0;
 110 : Twiddle_W_ex_r = 0;
 111 : Twiddle_W_ex_r = 0;
 112 : Twiddle_W_ex_r = 0;
 113 : Twiddle_W_ex_r = 0;
 114 : Twiddle_W_ex_r = 0;
 115 : Twiddle_W_ex_r = 0;
 116 : Twiddle_W_ex_r = 0;
 117 : Twiddle_W_ex_r = 0;
 118 : Twiddle_W_ex_r = 0;
 119 : Twiddle_W_ex_r = 0;
 120 : Twiddle_W_ex_r = 0;
 121 : Twiddle_W_ex_r = 0;
 122 : Twiddle_W_ex_r = 0;
 123 : Twiddle_W_ex_r = 0;
 124 : Twiddle_W_ex_r = 0;
 125 : Twiddle_W_ex_r = 0;
 126 : Twiddle_W_ex_r = 0;
 127 : Twiddle_W_ex_r = 0;
 128 : Twiddle_W_ex_r = 0;
 129 : Twiddle_W_ex_r = 0;
 130 : Twiddle_W_ex_r = 0;
 131 : Twiddle_W_ex_r = 0;
 132 : Twiddle_W_ex_r = 0;
 133 : Twiddle_W_ex_r = 0;
 134 : Twiddle_W_ex_r = 0;
 135 : Twiddle_W_ex_r = 0;
 136 : Twiddle_W_ex_r = 0;
 137 : Twiddle_W_ex_r = 0;
 138 : Twiddle_W_ex_r = 0;
 139 : Twiddle_W_ex_r = 0;
 140 : Twiddle_W_ex_r = 0;
 141 : Twiddle_W_ex_r = 0;
 142 : Twiddle_W_ex_r = 0;
 143 : Twiddle_W_ex_r = 0;
 144 : Twiddle_W_ex_r = 0;
 145 : Twiddle_W_ex_r = 0;
 146 : Twiddle_W_ex_r = 0;
 147 : Twiddle_W_ex_r = 0;
 148 : Twiddle_W_ex_r = 0;
 149 : Twiddle_W_ex_r = 0;
 150 : Twiddle_W_ex_r = 0;
 151 : Twiddle_W_ex_r = 0;
 152 : Twiddle_W_ex_r = 0;
 153 : Twiddle_W_ex_r = 0;
 154 : Twiddle_W_ex_r = 0;
 155 : Twiddle_W_ex_r = 0;
 156 : Twiddle_W_ex_r = 0;
 157 : Twiddle_W_ex_r = 0;
 158 : Twiddle_W_ex_r = 0;
 159 : Twiddle_W_ex_r = 0;
 160 : Twiddle_W_ex_r = 0;
 161 : Twiddle_W_ex_r = 0;
 162 : Twiddle_W_ex_r = 0;
 163 : Twiddle_W_ex_r = 0;
 164 : Twiddle_W_ex_r = 0;
 165 : Twiddle_W_ex_r = 0;
 166 : Twiddle_W_ex_r = 0;
 167 : Twiddle_W_ex_r = 0;
 168 : Twiddle_W_ex_r = 0;
 169 : Twiddle_W_ex_r = 0;
 170 : Twiddle_W_ex_r = 0;
 171 : Twiddle_W_ex_r = 0;
 172 : Twiddle_W_ex_r = 0;
 173 : Twiddle_W_ex_r = 0;
 174 : Twiddle_W_ex_r = 0;
 175 : Twiddle_W_ex_r = 0;
 176 : Twiddle_W_ex_r = 0;
 177 : Twiddle_W_ex_r = 0;
 178 : Twiddle_W_ex_r = 0;
 179 : Twiddle_W_ex_r = 0;
 180 : Twiddle_W_ex_r = 0;
 181 : Twiddle_W_ex_r = 0;
 182 : Twiddle_W_ex_r = 0;
 183 : Twiddle_W_ex_r = 0;
 184 : Twiddle_W_ex_r = 0;
 185 : Twiddle_W_ex_r = 0;
 186 : Twiddle_W_ex_r = 0;
 187 : Twiddle_W_ex_r = 0;
 188 : Twiddle_W_ex_r = 0;
 189 : Twiddle_W_ex_r = 0;
 190 : Twiddle_W_ex_r = 0;
 191 : Twiddle_W_ex_r = 0;
 192 : Twiddle_W_ex_r = 0;
 193 : Twiddle_W_ex_r = 0;
 194 : Twiddle_W_ex_r = 0;
 195 : Twiddle_W_ex_r = 0;
 196 : Twiddle_W_ex_r = 0;
 197 : Twiddle_W_ex_r = 0;
 198 : Twiddle_W_ex_r = 0;
 199 : Twiddle_W_ex_r = 0;
 200 : Twiddle_W_ex_r = 0;
 201 : Twiddle_W_ex_r = 0;
 202 : Twiddle_W_ex_r = 0;
 203 : Twiddle_W_ex_r = 0;
 204 : Twiddle_W_ex_r = 0;
 205 : Twiddle_W_ex_r = 0;
 206 : Twiddle_W_ex_r = 0;
 207 : Twiddle_W_ex_r = 0;
 208 : Twiddle_W_ex_r = 0;
 209 : Twiddle_W_ex_r = 0;
 210 : Twiddle_W_ex_r = 0;
 211 : Twiddle_W_ex_r = 0;
 212 : Twiddle_W_ex_r = 0;
 213 : Twiddle_W_ex_r = 0;
 214 : Twiddle_W_ex_r = 0;
 215 : Twiddle_W_ex_r = 0;
 216 : Twiddle_W_ex_r = 0;
 217 : Twiddle_W_ex_r = 0;
 218 : Twiddle_W_ex_r = 0;
 219 : Twiddle_W_ex_r = 0;
 220 : Twiddle_W_ex_r = 0;
 221 : Twiddle_W_ex_r = 0;
 222 : Twiddle_W_ex_r = 0;
 223 : Twiddle_W_ex_r = 0;
 224 : Twiddle_W_ex_r = 0;
 225 : Twiddle_W_ex_r = 0;
 226 : Twiddle_W_ex_r = 0;
 227 : Twiddle_W_ex_r = 0;
 228 : Twiddle_W_ex_r = 0;
 229 : Twiddle_W_ex_r = 0;
 230 : Twiddle_W_ex_r = 0;
 231 : Twiddle_W_ex_r = 0;
 232 : Twiddle_W_ex_r = 0;
 233 : Twiddle_W_ex_r = 0;
 234 : Twiddle_W_ex_r = 0;
 235 : Twiddle_W_ex_r = 0;
 236 : Twiddle_W_ex_r = 0;
 237 : Twiddle_W_ex_r = 0;
 238 : Twiddle_W_ex_r = 0;
 239 : Twiddle_W_ex_r = 0;
 240 : Twiddle_W_ex_r = 0;
 241 : Twiddle_W_ex_r = 0;
 242 : Twiddle_W_ex_r = 0;
 243 : Twiddle_W_ex_r = 0;
 244 : Twiddle_W_ex_r = 0;
 245 : Twiddle_W_ex_r = 0;
 246 : Twiddle_W_ex_r = 0;
 247 : Twiddle_W_ex_r = 0;
 248 : Twiddle_W_ex_r = 0;
 249 : Twiddle_W_ex_r = 0;
 250 : Twiddle_W_ex_r = 0;
 251 : Twiddle_W_ex_r = 0;
 252 : Twiddle_W_ex_r = 0;
 253 : Twiddle_W_ex_r = 0;
 254 : Twiddle_W_ex_r = 0;
 255 : Twiddle_W_ex_r = 0;
 256 : Twiddle_W_ex_r = 0;
 257 : Twiddle_W_ex_r = 0;
 258 : Twiddle_W_ex_r = 0;
 259 : Twiddle_W_ex_r = 0;
 260 : Twiddle_W_ex_r = 0;
 261 : Twiddle_W_ex_r = 0;
 262 : Twiddle_W_ex_r = 0;
 263 : Twiddle_W_ex_r = 0;
 264 : Twiddle_W_ex_r = 0;
 265 : Twiddle_W_ex_r = 0;
 266 : Twiddle_W_ex_r = 0;
 267 : Twiddle_W_ex_r = 0;
 268 : Twiddle_W_ex_r = 0;
 269 : Twiddle_W_ex_r = 0;
 270 : Twiddle_W_ex_r = 0;
 271 : Twiddle_W_ex_r = 0;
 272 : Twiddle_W_ex_r = 0;
 273 : Twiddle_W_ex_r = 0;
 274 : Twiddle_W_ex_r = 0;
 275 : Twiddle_W_ex_r = 0;
 276 : Twiddle_W_ex_r = 0;
 277 : Twiddle_W_ex_r = 0;
 278 : Twiddle_W_ex_r = 0;
 279 : Twiddle_W_ex_r = 0;
 280 : Twiddle_W_ex_r = 0;
 281 : Twiddle_W_ex_r = 0;
 282 : Twiddle_W_ex_r = 0;
 283 : Twiddle_W_ex_r = 0;
 284 : Twiddle_W_ex_r = 0;
 285 : Twiddle_W_ex_r = 0;
 286 : Twiddle_W_ex_r = 0;
 287 : Twiddle_W_ex_r = 0;
 288 : Twiddle_W_ex_r = 0;
 289 : Twiddle_W_ex_r = 0;
 290 : Twiddle_W_ex_r = 0;
 291 : Twiddle_W_ex_r = 0;
 292 : Twiddle_W_ex_r = 0;
 293 : Twiddle_W_ex_r = 0;
 294 : Twiddle_W_ex_r = 0;
 295 : Twiddle_W_ex_r = 0;
 296 : Twiddle_W_ex_r = 0;
 297 : Twiddle_W_ex_r = 0;
 298 : Twiddle_W_ex_r = 0;
 299 : Twiddle_W_ex_r = 0;
 300 : Twiddle_W_ex_r = 0;
 301 : Twiddle_W_ex_r = 0;
 302 : Twiddle_W_ex_r = 0;
 303 : Twiddle_W_ex_r = 0;
 304 : Twiddle_W_ex_r = 0;
 305 : Twiddle_W_ex_r = 0;
 306 : Twiddle_W_ex_r = 0;
 307 : Twiddle_W_ex_r = 0;
 308 : Twiddle_W_ex_r = 0;
 309 : Twiddle_W_ex_r = 0;
 310 : Twiddle_W_ex_r = 0;
 311 : Twiddle_W_ex_r = 0;
 312 : Twiddle_W_ex_r = 0;
 313 : Twiddle_W_ex_r = 0;
 314 : Twiddle_W_ex_r = 0;
 315 : Twiddle_W_ex_r = 0;
 316 : Twiddle_W_ex_r = 0;
 317 : Twiddle_W_ex_r = 0;
 318 : Twiddle_W_ex_r = 0;
 319 : Twiddle_W_ex_r = 0;
 320 : Twiddle_W_ex_r = 0;
 321 : Twiddle_W_ex_r = 0;
 322 : Twiddle_W_ex_r = 0;
 323 : Twiddle_W_ex_r = 0;
 324 : Twiddle_W_ex_r = 0;
 325 : Twiddle_W_ex_r = 0;
 326 : Twiddle_W_ex_r = 0;
 327 : Twiddle_W_ex_r = 0;
 328 : Twiddle_W_ex_r = 0;
 329 : Twiddle_W_ex_r = 0;
 330 : Twiddle_W_ex_r = 0;
 331 : Twiddle_W_ex_r = 0;
 332 : Twiddle_W_ex_r = 0;
 333 : Twiddle_W_ex_r = 0;
 334 : Twiddle_W_ex_r = 0;
 335 : Twiddle_W_ex_r = 0;
 336 : Twiddle_W_ex_r = 0;
 337 : Twiddle_W_ex_r = 0;
 338 : Twiddle_W_ex_r = 0;
 339 : Twiddle_W_ex_r = 0;
 340 : Twiddle_W_ex_r = 0;
 341 : Twiddle_W_ex_r = 0;
 342 : Twiddle_W_ex_r = 0;
 343 : Twiddle_W_ex_r = 0;
 344 : Twiddle_W_ex_r = 0;
 345 : Twiddle_W_ex_r = 0;
 346 : Twiddle_W_ex_r = 0;
 347 : Twiddle_W_ex_r = 0;
 348 : Twiddle_W_ex_r = 0;
 349 : Twiddle_W_ex_r = 0;
 350 : Twiddle_W_ex_r = 0;
 351 : Twiddle_W_ex_r = 0;
 352 : Twiddle_W_ex_r = 0;
 353 : Twiddle_W_ex_r = 0;
 354 : Twiddle_W_ex_r = 0;
 355 : Twiddle_W_ex_r = 0;
 356 : Twiddle_W_ex_r = 0;
 357 : Twiddle_W_ex_r = 0;
 358 : Twiddle_W_ex_r = 0;
 359 : Twiddle_W_ex_r = 0;
 360 : Twiddle_W_ex_r = 0;
 361 : Twiddle_W_ex_r = 0;
 362 : Twiddle_W_ex_r = 0;
 363 : Twiddle_W_ex_r = 0;
 364 : Twiddle_W_ex_r = 0;
 365 : Twiddle_W_ex_r = 0;
 366 : Twiddle_W_ex_r = 0;
 367 : Twiddle_W_ex_r = 0;
 368 : Twiddle_W_ex_r = 0;
 369 : Twiddle_W_ex_r = 0;
 370 : Twiddle_W_ex_r = 0;
 371 : Twiddle_W_ex_r = 0;
 372 : Twiddle_W_ex_r = 0;
 373 : Twiddle_W_ex_r = 0;
 374 : Twiddle_W_ex_r = 0;
 375 : Twiddle_W_ex_r = 0;
 376 : Twiddle_W_ex_r = 0;
 377 : Twiddle_W_ex_r = 0;
 378 : Twiddle_W_ex_r = 0;
 379 : Twiddle_W_ex_r = 0;
 380 : Twiddle_W_ex_r = 0;
 381 : Twiddle_W_ex_r = 0;
 382 : Twiddle_W_ex_r = 0;
 383 : Twiddle_W_ex_r = 0;
 384 : Twiddle_W_ex_r = 0;
 385 : Twiddle_W_ex_r = 0;
 386 : Twiddle_W_ex_r = 0;
 387 : Twiddle_W_ex_r = 0;
 388 : Twiddle_W_ex_r = 0;
 389 : Twiddle_W_ex_r = 0;
 390 : Twiddle_W_ex_r = 0;
 391 : Twiddle_W_ex_r = 0;
 392 : Twiddle_W_ex_r = 0;
 393 : Twiddle_W_ex_r = 0;
 394 : Twiddle_W_ex_r = 0;
 395 : Twiddle_W_ex_r = 0;
 396 : Twiddle_W_ex_r = 0;
 397 : Twiddle_W_ex_r = 0;
 398 : Twiddle_W_ex_r = 0;
 399 : Twiddle_W_ex_r = 0;
 400 : Twiddle_W_ex_r = 0;
 401 : Twiddle_W_ex_r = 0;
 402 : Twiddle_W_ex_r = 0;
 403 : Twiddle_W_ex_r = 0;
 404 : Twiddle_W_ex_r = 0;
 405 : Twiddle_W_ex_r = 0;
 406 : Twiddle_W_ex_r = 0;
 407 : Twiddle_W_ex_r = 0;
 408 : Twiddle_W_ex_r = 0;
 409 : Twiddle_W_ex_r = 0;
 410 : Twiddle_W_ex_r = 0;
 411 : Twiddle_W_ex_r = 0;
 412 : Twiddle_W_ex_r = 0;
 413 : Twiddle_W_ex_r = 0;
 414 : Twiddle_W_ex_r = 0;
 415 : Twiddle_W_ex_r = 0;
 416 : Twiddle_W_ex_r = 0;
 417 : Twiddle_W_ex_r = 0;
 418 : Twiddle_W_ex_r = 0;
 419 : Twiddle_W_ex_r = 0;
 420 : Twiddle_W_ex_r = 0;
 421 : Twiddle_W_ex_r = 0;
 422 : Twiddle_W_ex_r = 0;
 423 : Twiddle_W_ex_r = 0;
 424 : Twiddle_W_ex_r = 0;
 425 : Twiddle_W_ex_r = 0;
 426 : Twiddle_W_ex_r = 0;
 427 : Twiddle_W_ex_r = 0;
 428 : Twiddle_W_ex_r = 0;
 429 : Twiddle_W_ex_r = 0;
 430 : Twiddle_W_ex_r = 0;
 431 : Twiddle_W_ex_r = 0;
 432 : Twiddle_W_ex_r = 0;
 433 : Twiddle_W_ex_r = 0;
 434 : Twiddle_W_ex_r = 0;
 435 : Twiddle_W_ex_r = 0;
 436 : Twiddle_W_ex_r = 0;
 437 : Twiddle_W_ex_r = 0;
 438 : Twiddle_W_ex_r = 0;
 439 : Twiddle_W_ex_r = 0;
 440 : Twiddle_W_ex_r = 0;
 441 : Twiddle_W_ex_r = 0;
 442 : Twiddle_W_ex_r = 0;
 443 : Twiddle_W_ex_r = 0;
 444 : Twiddle_W_ex_r = 0;
 445 : Twiddle_W_ex_r = 0;
 446 : Twiddle_W_ex_r = 0;
 447 : Twiddle_W_ex_r = 0;
 448 : Twiddle_W_ex_r = 0;
 449 : Twiddle_W_ex_r = 0;
 450 : Twiddle_W_ex_r = 0;
 451 : Twiddle_W_ex_r = 0;
 452 : Twiddle_W_ex_r = 0;
 453 : Twiddle_W_ex_r = 0;
 454 : Twiddle_W_ex_r = 0;
 455 : Twiddle_W_ex_r = 0;
 456 : Twiddle_W_ex_r = 0;
 457 : Twiddle_W_ex_r = 0;
 458 : Twiddle_W_ex_r = 0;
 459 : Twiddle_W_ex_r = 0;
 460 : Twiddle_W_ex_r = 0;
 461 : Twiddle_W_ex_r = 0;
 462 : Twiddle_W_ex_r = 0;
 463 : Twiddle_W_ex_r = 0;
 464 : Twiddle_W_ex_r = 0;
 465 : Twiddle_W_ex_r = 0;
 466 : Twiddle_W_ex_r = 0;
 467 : Twiddle_W_ex_r = 0;
 468 : Twiddle_W_ex_r = 0;
 469 : Twiddle_W_ex_r = 0;
 470 : Twiddle_W_ex_r = 0;
 471 : Twiddle_W_ex_r = 0;
 472 : Twiddle_W_ex_r = 0;
 473 : Twiddle_W_ex_r = 0;
 474 : Twiddle_W_ex_r = 0;
 475 : Twiddle_W_ex_r = 0;
 476 : Twiddle_W_ex_r = 0;
 477 : Twiddle_W_ex_r = 0;
 478 : Twiddle_W_ex_r = 0;
 479 : Twiddle_W_ex_r = 0;
 480 : Twiddle_W_ex_r = 0;
 481 : Twiddle_W_ex_r = 0;
 482 : Twiddle_W_ex_r = 0;
 483 : Twiddle_W_ex_r = 0;
 484 : Twiddle_W_ex_r = 0;
 485 : Twiddle_W_ex_r = 0;
 486 : Twiddle_W_ex_r = 0;
 487 : Twiddle_W_ex_r = 0;
 488 : Twiddle_W_ex_r = 0;
 489 : Twiddle_W_ex_r = 0;
 490 : Twiddle_W_ex_r = 0;
 491 : Twiddle_W_ex_r = 0;
 492 : Twiddle_W_ex_r = 0;
 493 : Twiddle_W_ex_r = 0;
 494 : Twiddle_W_ex_r = 0;
 495 : Twiddle_W_ex_r = 0;
 496 : Twiddle_W_ex_r = 0;
 497 : Twiddle_W_ex_r = 0;
 498 : Twiddle_W_ex_r = 0;
 499 : Twiddle_W_ex_r = 0;
 500 : Twiddle_W_ex_r = 0;
 501 : Twiddle_W_ex_r = 0;
 502 : Twiddle_W_ex_r = 0;
 503 : Twiddle_W_ex_r = 0;
 504 : Twiddle_W_ex_r = 0;
 505 : Twiddle_W_ex_r = 0;
 506 : Twiddle_W_ex_r = 0;
 507 : Twiddle_W_ex_r = 0;
 508 : Twiddle_W_ex_r = 0;
 509 : Twiddle_W_ex_r = 0;
 510 : Twiddle_W_ex_r = 0;
 511 : Twiddle_W_ex_r = 0;
default : Twiddle_W_ex_r = 0;
endcase
endfunction
function [1:0] Twiddle_W_ex_i;
input  [8:0]  k;
case(k)
 0 : Twiddle_W_ex_i = 0;
 1 : Twiddle_W_ex_i = 0;
 2 : Twiddle_W_ex_i = 0;
 3 : Twiddle_W_ex_i = 0;
 4 : Twiddle_W_ex_i = 0;
 5 : Twiddle_W_ex_i = 0;
 6 : Twiddle_W_ex_i = 0;
 7 : Twiddle_W_ex_i = 0;
 8 : Twiddle_W_ex_i = 0;
 9 : Twiddle_W_ex_i = 0;
 10 : Twiddle_W_ex_i = 0;
 11 : Twiddle_W_ex_i = 0;
 12 : Twiddle_W_ex_i = 0;
 13 : Twiddle_W_ex_i = 0;
 14 : Twiddle_W_ex_i = 0;
 15 : Twiddle_W_ex_i = 0;
 16 : Twiddle_W_ex_i = 0;
 17 : Twiddle_W_ex_i = 0;
 18 : Twiddle_W_ex_i = 0;
 19 : Twiddle_W_ex_i = 0;
 20 : Twiddle_W_ex_i = 0;
 21 : Twiddle_W_ex_i = 0;
 22 : Twiddle_W_ex_i = 0;
 23 : Twiddle_W_ex_i = 0;
 24 : Twiddle_W_ex_i = 0;
 25 : Twiddle_W_ex_i = 0;
 26 : Twiddle_W_ex_i = 0;
 27 : Twiddle_W_ex_i = 0;
 28 : Twiddle_W_ex_i = 0;
 29 : Twiddle_W_ex_i = 0;
 30 : Twiddle_W_ex_i = 0;
 31 : Twiddle_W_ex_i = 0;
 32 : Twiddle_W_ex_i = 0;
 33 : Twiddle_W_ex_i = 0;
 34 : Twiddle_W_ex_i = 0;
 35 : Twiddle_W_ex_i = 0;
 36 : Twiddle_W_ex_i = 0;
 37 : Twiddle_W_ex_i = 0;
 38 : Twiddle_W_ex_i = 0;
 39 : Twiddle_W_ex_i = 0;
 40 : Twiddle_W_ex_i = 0;
 41 : Twiddle_W_ex_i = 0;
 42 : Twiddle_W_ex_i = 0;
 43 : Twiddle_W_ex_i = 0;
 44 : Twiddle_W_ex_i = 0;
 45 : Twiddle_W_ex_i = 0;
 46 : Twiddle_W_ex_i = 0;
 47 : Twiddle_W_ex_i = 0;
 48 : Twiddle_W_ex_i = 0;
 49 : Twiddle_W_ex_i = 0;
 50 : Twiddle_W_ex_i = 0;
 51 : Twiddle_W_ex_i = 0;
 52 : Twiddle_W_ex_i = 0;
 53 : Twiddle_W_ex_i = 0;
 54 : Twiddle_W_ex_i = 0;
 55 : Twiddle_W_ex_i = 0;
 56 : Twiddle_W_ex_i = 0;
 57 : Twiddle_W_ex_i = 0;
 58 : Twiddle_W_ex_i = 0;
 59 : Twiddle_W_ex_i = 0;
 60 : Twiddle_W_ex_i = 0;
 61 : Twiddle_W_ex_i = 0;
 62 : Twiddle_W_ex_i = 0;
 63 : Twiddle_W_ex_i = 0;
 64 : Twiddle_W_ex_i = 0;
 65 : Twiddle_W_ex_i = 0;
 66 : Twiddle_W_ex_i = 0;
 67 : Twiddle_W_ex_i = 0;
 68 : Twiddle_W_ex_i = 0;
 69 : Twiddle_W_ex_i = 0;
 70 : Twiddle_W_ex_i = 0;
 71 : Twiddle_W_ex_i = 0;
 72 : Twiddle_W_ex_i = 0;
 73 : Twiddle_W_ex_i = 0;
 74 : Twiddle_W_ex_i = 0;
 75 : Twiddle_W_ex_i = 0;
 76 : Twiddle_W_ex_i = 0;
 77 : Twiddle_W_ex_i = 0;
 78 : Twiddle_W_ex_i = 0;
 79 : Twiddle_W_ex_i = 0;
 80 : Twiddle_W_ex_i = 0;
 81 : Twiddle_W_ex_i = 0;
 82 : Twiddle_W_ex_i = 0;
 83 : Twiddle_W_ex_i = 0;
 84 : Twiddle_W_ex_i = 0;
 85 : Twiddle_W_ex_i = 0;
 86 : Twiddle_W_ex_i = 0;
 87 : Twiddle_W_ex_i = 0;
 88 : Twiddle_W_ex_i = 0;
 89 : Twiddle_W_ex_i = 0;
 90 : Twiddle_W_ex_i = 0;
 91 : Twiddle_W_ex_i = 0;
 92 : Twiddle_W_ex_i = 0;
 93 : Twiddle_W_ex_i = 0;
 94 : Twiddle_W_ex_i = 0;
 95 : Twiddle_W_ex_i = 0;
 96 : Twiddle_W_ex_i = 0;
 97 : Twiddle_W_ex_i = 0;
 98 : Twiddle_W_ex_i = 0;
 99 : Twiddle_W_ex_i = 0;
 100 : Twiddle_W_ex_i = 0;
 101 : Twiddle_W_ex_i = 0;
 102 : Twiddle_W_ex_i = 0;
 103 : Twiddle_W_ex_i = 0;
 104 : Twiddle_W_ex_i = 0;
 105 : Twiddle_W_ex_i = 0;
 106 : Twiddle_W_ex_i = 0;
 107 : Twiddle_W_ex_i = 0;
 108 : Twiddle_W_ex_i = 0;
 109 : Twiddle_W_ex_i = 0;
 110 : Twiddle_W_ex_i = 0;
 111 : Twiddle_W_ex_i = 0;
 112 : Twiddle_W_ex_i = 0;
 113 : Twiddle_W_ex_i = 0;
 114 : Twiddle_W_ex_i = 0;
 115 : Twiddle_W_ex_i = 0;
 116 : Twiddle_W_ex_i = 0;
 117 : Twiddle_W_ex_i = 0;
 118 : Twiddle_W_ex_i = 0;
 119 : Twiddle_W_ex_i = 0;
 120 : Twiddle_W_ex_i = 0;
 121 : Twiddle_W_ex_i = 0;
 122 : Twiddle_W_ex_i = 0;
 123 : Twiddle_W_ex_i = 0;
 124 : Twiddle_W_ex_i = 0;
 125 : Twiddle_W_ex_i = 0;
 126 : Twiddle_W_ex_i = 0;
 127 : Twiddle_W_ex_i = 0;
 128 : Twiddle_W_ex_i = 0;
 129 : Twiddle_W_ex_i = 0;
 130 : Twiddle_W_ex_i = 0;
 131 : Twiddle_W_ex_i = 0;
 132 : Twiddle_W_ex_i = 0;
 133 : Twiddle_W_ex_i = 0;
 134 : Twiddle_W_ex_i = 0;
 135 : Twiddle_W_ex_i = 0;
 136 : Twiddle_W_ex_i = 0;
 137 : Twiddle_W_ex_i = 0;
 138 : Twiddle_W_ex_i = 0;
 139 : Twiddle_W_ex_i = 0;
 140 : Twiddle_W_ex_i = 0;
 141 : Twiddle_W_ex_i = 0;
 142 : Twiddle_W_ex_i = 0;
 143 : Twiddle_W_ex_i = 0;
 144 : Twiddle_W_ex_i = 0;
 145 : Twiddle_W_ex_i = 0;
 146 : Twiddle_W_ex_i = 0;
 147 : Twiddle_W_ex_i = 0;
 148 : Twiddle_W_ex_i = 0;
 149 : Twiddle_W_ex_i = 0;
 150 : Twiddle_W_ex_i = 0;
 151 : Twiddle_W_ex_i = 0;
 152 : Twiddle_W_ex_i = 0;
 153 : Twiddle_W_ex_i = 0;
 154 : Twiddle_W_ex_i = 0;
 155 : Twiddle_W_ex_i = 0;
 156 : Twiddle_W_ex_i = 0;
 157 : Twiddle_W_ex_i = 0;
 158 : Twiddle_W_ex_i = 0;
 159 : Twiddle_W_ex_i = 0;
 160 : Twiddle_W_ex_i = 0;
 161 : Twiddle_W_ex_i = 0;
 162 : Twiddle_W_ex_i = 0;
 163 : Twiddle_W_ex_i = 0;
 164 : Twiddle_W_ex_i = 0;
 165 : Twiddle_W_ex_i = 0;
 166 : Twiddle_W_ex_i = 0;
 167 : Twiddle_W_ex_i = 0;
 168 : Twiddle_W_ex_i = 0;
 169 : Twiddle_W_ex_i = 0;
 170 : Twiddle_W_ex_i = 0;
 171 : Twiddle_W_ex_i = 0;
 172 : Twiddle_W_ex_i = 0;
 173 : Twiddle_W_ex_i = 0;
 174 : Twiddle_W_ex_i = 0;
 175 : Twiddle_W_ex_i = 0;
 176 : Twiddle_W_ex_i = 0;
 177 : Twiddle_W_ex_i = 0;
 178 : Twiddle_W_ex_i = 0;
 179 : Twiddle_W_ex_i = 0;
 180 : Twiddle_W_ex_i = 0;
 181 : Twiddle_W_ex_i = 0;
 182 : Twiddle_W_ex_i = 0;
 183 : Twiddle_W_ex_i = 0;
 184 : Twiddle_W_ex_i = 0;
 185 : Twiddle_W_ex_i = 0;
 186 : Twiddle_W_ex_i = 0;
 187 : Twiddle_W_ex_i = 0;
 188 : Twiddle_W_ex_i = 0;
 189 : Twiddle_W_ex_i = 0;
 190 : Twiddle_W_ex_i = 0;
 191 : Twiddle_W_ex_i = 0;
 192 : Twiddle_W_ex_i = 0;
 193 : Twiddle_W_ex_i = 0;
 194 : Twiddle_W_ex_i = 0;
 195 : Twiddle_W_ex_i = 0;
 196 : Twiddle_W_ex_i = 0;
 197 : Twiddle_W_ex_i = 0;
 198 : Twiddle_W_ex_i = 0;
 199 : Twiddle_W_ex_i = 0;
 200 : Twiddle_W_ex_i = 0;
 201 : Twiddle_W_ex_i = 0;
 202 : Twiddle_W_ex_i = 0;
 203 : Twiddle_W_ex_i = 0;
 204 : Twiddle_W_ex_i = 0;
 205 : Twiddle_W_ex_i = 0;
 206 : Twiddle_W_ex_i = 0;
 207 : Twiddle_W_ex_i = 0;
 208 : Twiddle_W_ex_i = 0;
 209 : Twiddle_W_ex_i = 0;
 210 : Twiddle_W_ex_i = 0;
 211 : Twiddle_W_ex_i = 0;
 212 : Twiddle_W_ex_i = 0;
 213 : Twiddle_W_ex_i = 0;
 214 : Twiddle_W_ex_i = 0;
 215 : Twiddle_W_ex_i = 0;
 216 : Twiddle_W_ex_i = 0;
 217 : Twiddle_W_ex_i = 0;
 218 : Twiddle_W_ex_i = 0;
 219 : Twiddle_W_ex_i = 0;
 220 : Twiddle_W_ex_i = 0;
 221 : Twiddle_W_ex_i = 0;
 222 : Twiddle_W_ex_i = 0;
 223 : Twiddle_W_ex_i = 0;
 224 : Twiddle_W_ex_i = 0;
 225 : Twiddle_W_ex_i = 0;
 226 : Twiddle_W_ex_i = 0;
 227 : Twiddle_W_ex_i = 0;
 228 : Twiddle_W_ex_i = 0;
 229 : Twiddle_W_ex_i = 0;
 230 : Twiddle_W_ex_i = 0;
 231 : Twiddle_W_ex_i = 0;
 232 : Twiddle_W_ex_i = 0;
 233 : Twiddle_W_ex_i = 0;
 234 : Twiddle_W_ex_i = 0;
 235 : Twiddle_W_ex_i = 0;
 236 : Twiddle_W_ex_i = 0;
 237 : Twiddle_W_ex_i = 0;
 238 : Twiddle_W_ex_i = 0;
 239 : Twiddle_W_ex_i = 0;
 240 : Twiddle_W_ex_i = 0;
 241 : Twiddle_W_ex_i = 0;
 242 : Twiddle_W_ex_i = 0;
 243 : Twiddle_W_ex_i = 0;
 244 : Twiddle_W_ex_i = 0;
 245 : Twiddle_W_ex_i = 0;
 246 : Twiddle_W_ex_i = 0;
 247 : Twiddle_W_ex_i = 0;
 248 : Twiddle_W_ex_i = 0;
 249 : Twiddle_W_ex_i = 0;
 250 : Twiddle_W_ex_i = 0;
 251 : Twiddle_W_ex_i = 0;
 252 : Twiddle_W_ex_i = 0;
 253 : Twiddle_W_ex_i = 0;
 254 : Twiddle_W_ex_i = 0;
 255 : Twiddle_W_ex_i = 0;
 256 : Twiddle_W_ex_i = 2;
 257 : Twiddle_W_ex_i = 0;
 258 : Twiddle_W_ex_i = 0;
 259 : Twiddle_W_ex_i = 0;
 260 : Twiddle_W_ex_i = 0;
 261 : Twiddle_W_ex_i = 0;
 262 : Twiddle_W_ex_i = 0;
 263 : Twiddle_W_ex_i = 0;
 264 : Twiddle_W_ex_i = 0;
 265 : Twiddle_W_ex_i = 0;
 266 : Twiddle_W_ex_i = 0;
 267 : Twiddle_W_ex_i = 0;
 268 : Twiddle_W_ex_i = 0;
 269 : Twiddle_W_ex_i = 0;
 270 : Twiddle_W_ex_i = 0;
 271 : Twiddle_W_ex_i = 0;
 272 : Twiddle_W_ex_i = 0;
 273 : Twiddle_W_ex_i = 0;
 274 : Twiddle_W_ex_i = 0;
 275 : Twiddle_W_ex_i = 0;
 276 : Twiddle_W_ex_i = 0;
 277 : Twiddle_W_ex_i = 0;
 278 : Twiddle_W_ex_i = 0;
 279 : Twiddle_W_ex_i = 0;
 280 : Twiddle_W_ex_i = 0;
 281 : Twiddle_W_ex_i = 0;
 282 : Twiddle_W_ex_i = 0;
 283 : Twiddle_W_ex_i = 0;
 284 : Twiddle_W_ex_i = 0;
 285 : Twiddle_W_ex_i = 0;
 286 : Twiddle_W_ex_i = 0;
 287 : Twiddle_W_ex_i = 0;
 288 : Twiddle_W_ex_i = 0;
 289 : Twiddle_W_ex_i = 0;
 290 : Twiddle_W_ex_i = 0;
 291 : Twiddle_W_ex_i = 0;
 292 : Twiddle_W_ex_i = 0;
 293 : Twiddle_W_ex_i = 0;
 294 : Twiddle_W_ex_i = 0;
 295 : Twiddle_W_ex_i = 0;
 296 : Twiddle_W_ex_i = 0;
 297 : Twiddle_W_ex_i = 0;
 298 : Twiddle_W_ex_i = 0;
 299 : Twiddle_W_ex_i = 0;
 300 : Twiddle_W_ex_i = 0;
 301 : Twiddle_W_ex_i = 0;
 302 : Twiddle_W_ex_i = 0;
 303 : Twiddle_W_ex_i = 0;
 304 : Twiddle_W_ex_i = 0;
 305 : Twiddle_W_ex_i = 0;
 306 : Twiddle_W_ex_i = 0;
 307 : Twiddle_W_ex_i = 0;
 308 : Twiddle_W_ex_i = 0;
 309 : Twiddle_W_ex_i = 0;
 310 : Twiddle_W_ex_i = 0;
 311 : Twiddle_W_ex_i = 0;
 312 : Twiddle_W_ex_i = 0;
 313 : Twiddle_W_ex_i = 0;
 314 : Twiddle_W_ex_i = 0;
 315 : Twiddle_W_ex_i = 0;
 316 : Twiddle_W_ex_i = 0;
 317 : Twiddle_W_ex_i = 0;
 318 : Twiddle_W_ex_i = 0;
 319 : Twiddle_W_ex_i = 0;
 320 : Twiddle_W_ex_i = 0;
 321 : Twiddle_W_ex_i = 0;
 322 : Twiddle_W_ex_i = 0;
 323 : Twiddle_W_ex_i = 0;
 324 : Twiddle_W_ex_i = 0;
 325 : Twiddle_W_ex_i = 0;
 326 : Twiddle_W_ex_i = 0;
 327 : Twiddle_W_ex_i = 0;
 328 : Twiddle_W_ex_i = 0;
 329 : Twiddle_W_ex_i = 0;
 330 : Twiddle_W_ex_i = 0;
 331 : Twiddle_W_ex_i = 0;
 332 : Twiddle_W_ex_i = 0;
 333 : Twiddle_W_ex_i = 0;
 334 : Twiddle_W_ex_i = 0;
 335 : Twiddle_W_ex_i = 0;
 336 : Twiddle_W_ex_i = 0;
 337 : Twiddle_W_ex_i = 0;
 338 : Twiddle_W_ex_i = 0;
 339 : Twiddle_W_ex_i = 0;
 340 : Twiddle_W_ex_i = 0;
 341 : Twiddle_W_ex_i = 0;
 342 : Twiddle_W_ex_i = 0;
 343 : Twiddle_W_ex_i = 0;
 344 : Twiddle_W_ex_i = 0;
 345 : Twiddle_W_ex_i = 0;
 346 : Twiddle_W_ex_i = 0;
 347 : Twiddle_W_ex_i = 0;
 348 : Twiddle_W_ex_i = 0;
 349 : Twiddle_W_ex_i = 0;
 350 : Twiddle_W_ex_i = 0;
 351 : Twiddle_W_ex_i = 0;
 352 : Twiddle_W_ex_i = 0;
 353 : Twiddle_W_ex_i = 0;
 354 : Twiddle_W_ex_i = 0;
 355 : Twiddle_W_ex_i = 0;
 356 : Twiddle_W_ex_i = 0;
 357 : Twiddle_W_ex_i = 0;
 358 : Twiddle_W_ex_i = 0;
 359 : Twiddle_W_ex_i = 0;
 360 : Twiddle_W_ex_i = 0;
 361 : Twiddle_W_ex_i = 0;
 362 : Twiddle_W_ex_i = 0;
 363 : Twiddle_W_ex_i = 0;
 364 : Twiddle_W_ex_i = 0;
 365 : Twiddle_W_ex_i = 0;
 366 : Twiddle_W_ex_i = 0;
 367 : Twiddle_W_ex_i = 0;
 368 : Twiddle_W_ex_i = 0;
 369 : Twiddle_W_ex_i = 0;
 370 : Twiddle_W_ex_i = 0;
 371 : Twiddle_W_ex_i = 0;
 372 : Twiddle_W_ex_i = 0;
 373 : Twiddle_W_ex_i = 0;
 374 : Twiddle_W_ex_i = 0;
 375 : Twiddle_W_ex_i = 0;
 376 : Twiddle_W_ex_i = 0;
 377 : Twiddle_W_ex_i = 0;
 378 : Twiddle_W_ex_i = 0;
 379 : Twiddle_W_ex_i = 0;
 380 : Twiddle_W_ex_i = 0;
 381 : Twiddle_W_ex_i = 0;
 382 : Twiddle_W_ex_i = 0;
 383 : Twiddle_W_ex_i = 0;
 384 : Twiddle_W_ex_i = 0;
 385 : Twiddle_W_ex_i = 0;
 386 : Twiddle_W_ex_i = 0;
 387 : Twiddle_W_ex_i = 0;
 388 : Twiddle_W_ex_i = 0;
 389 : Twiddle_W_ex_i = 0;
 390 : Twiddle_W_ex_i = 0;
 391 : Twiddle_W_ex_i = 0;
 392 : Twiddle_W_ex_i = 0;
 393 : Twiddle_W_ex_i = 0;
 394 : Twiddle_W_ex_i = 0;
 395 : Twiddle_W_ex_i = 0;
 396 : Twiddle_W_ex_i = 0;
 397 : Twiddle_W_ex_i = 0;
 398 : Twiddle_W_ex_i = 0;
 399 : Twiddle_W_ex_i = 0;
 400 : Twiddle_W_ex_i = 0;
 401 : Twiddle_W_ex_i = 0;
 402 : Twiddle_W_ex_i = 0;
 403 : Twiddle_W_ex_i = 0;
 404 : Twiddle_W_ex_i = 0;
 405 : Twiddle_W_ex_i = 0;
 406 : Twiddle_W_ex_i = 0;
 407 : Twiddle_W_ex_i = 0;
 408 : Twiddle_W_ex_i = 0;
 409 : Twiddle_W_ex_i = 0;
 410 : Twiddle_W_ex_i = 0;
 411 : Twiddle_W_ex_i = 0;
 412 : Twiddle_W_ex_i = 0;
 413 : Twiddle_W_ex_i = 0;
 414 : Twiddle_W_ex_i = 0;
 415 : Twiddle_W_ex_i = 0;
 416 : Twiddle_W_ex_i = 0;
 417 : Twiddle_W_ex_i = 0;
 418 : Twiddle_W_ex_i = 0;
 419 : Twiddle_W_ex_i = 0;
 420 : Twiddle_W_ex_i = 0;
 421 : Twiddle_W_ex_i = 0;
 422 : Twiddle_W_ex_i = 0;
 423 : Twiddle_W_ex_i = 0;
 424 : Twiddle_W_ex_i = 0;
 425 : Twiddle_W_ex_i = 0;
 426 : Twiddle_W_ex_i = 0;
 427 : Twiddle_W_ex_i = 0;
 428 : Twiddle_W_ex_i = 0;
 429 : Twiddle_W_ex_i = 0;
 430 : Twiddle_W_ex_i = 0;
 431 : Twiddle_W_ex_i = 0;
 432 : Twiddle_W_ex_i = 0;
 433 : Twiddle_W_ex_i = 0;
 434 : Twiddle_W_ex_i = 0;
 435 : Twiddle_W_ex_i = 0;
 436 : Twiddle_W_ex_i = 0;
 437 : Twiddle_W_ex_i = 0;
 438 : Twiddle_W_ex_i = 0;
 439 : Twiddle_W_ex_i = 0;
 440 : Twiddle_W_ex_i = 0;
 441 : Twiddle_W_ex_i = 0;
 442 : Twiddle_W_ex_i = 0;
 443 : Twiddle_W_ex_i = 0;
 444 : Twiddle_W_ex_i = 0;
 445 : Twiddle_W_ex_i = 0;
 446 : Twiddle_W_ex_i = 0;
 447 : Twiddle_W_ex_i = 0;
 448 : Twiddle_W_ex_i = 0;
 449 : Twiddle_W_ex_i = 0;
 450 : Twiddle_W_ex_i = 0;
 451 : Twiddle_W_ex_i = 0;
 452 : Twiddle_W_ex_i = 0;
 453 : Twiddle_W_ex_i = 0;
 454 : Twiddle_W_ex_i = 0;
 455 : Twiddle_W_ex_i = 0;
 456 : Twiddle_W_ex_i = 0;
 457 : Twiddle_W_ex_i = 0;
 458 : Twiddle_W_ex_i = 0;
 459 : Twiddle_W_ex_i = 0;
 460 : Twiddle_W_ex_i = 0;
 461 : Twiddle_W_ex_i = 0;
 462 : Twiddle_W_ex_i = 0;
 463 : Twiddle_W_ex_i = 0;
 464 : Twiddle_W_ex_i = 0;
 465 : Twiddle_W_ex_i = 0;
 466 : Twiddle_W_ex_i = 0;
 467 : Twiddle_W_ex_i = 0;
 468 : Twiddle_W_ex_i = 0;
 469 : Twiddle_W_ex_i = 0;
 470 : Twiddle_W_ex_i = 0;
 471 : Twiddle_W_ex_i = 0;
 472 : Twiddle_W_ex_i = 0;
 473 : Twiddle_W_ex_i = 0;
 474 : Twiddle_W_ex_i = 0;
 475 : Twiddle_W_ex_i = 0;
 476 : Twiddle_W_ex_i = 0;
 477 : Twiddle_W_ex_i = 0;
 478 : Twiddle_W_ex_i = 0;
 479 : Twiddle_W_ex_i = 0;
 480 : Twiddle_W_ex_i = 0;
 481 : Twiddle_W_ex_i = 0;
 482 : Twiddle_W_ex_i = 0;
 483 : Twiddle_W_ex_i = 0;
 484 : Twiddle_W_ex_i = 0;
 485 : Twiddle_W_ex_i = 0;
 486 : Twiddle_W_ex_i = 0;
 487 : Twiddle_W_ex_i = 0;
 488 : Twiddle_W_ex_i = 0;
 489 : Twiddle_W_ex_i = 0;
 490 : Twiddle_W_ex_i = 0;
 491 : Twiddle_W_ex_i = 0;
 492 : Twiddle_W_ex_i = 0;
 493 : Twiddle_W_ex_i = 0;
 494 : Twiddle_W_ex_i = 0;
 495 : Twiddle_W_ex_i = 0;
 496 : Twiddle_W_ex_i = 0;
 497 : Twiddle_W_ex_i = 0;
 498 : Twiddle_W_ex_i = 0;
 499 : Twiddle_W_ex_i = 0;
 500 : Twiddle_W_ex_i = 0;
 501 : Twiddle_W_ex_i = 0;
 502 : Twiddle_W_ex_i = 0;
 503 : Twiddle_W_ex_i = 0;
 504 : Twiddle_W_ex_i = 0;
 505 : Twiddle_W_ex_i = 0;
 506 : Twiddle_W_ex_i = 0;
 507 : Twiddle_W_ex_i = 0;
 508 : Twiddle_W_ex_i = 0;
 509 : Twiddle_W_ex_i = 0;
 510 : Twiddle_W_ex_i = 0;
 511 : Twiddle_W_ex_i = 0;
default : Twiddle_W_ex_i = 0;
endcase
endfunction
endmodule

